var ACQL = {}

ACQL.init = async ()=> {
    
    MEM._RCP = MEM.preloadWithOwner(MEM.ANNE,{text: "::relative_circuit_path", nid:'1FenmxaSgGt5dtaSCtPpexZ568k5SzZovS'}, "class", MEM.class);
    
    MEM._RCP.execute_circuit = function($fromNObj, $RCP_inst) {
            console.log("(_RCP.execute_circuit)");
            if ($fromNObj==undefined || $fromNObj==null || $RCP_inst==undefined || $RCP_inst==null) return ""; 
            return ACQL._getAndRunCmdSequence($fromNObj, $RCP_inst); 
        }
    
    MEM._RCC = MEM.preloadWithOwner(MEM.ANNE,{text: "::relative_circuit_cmd", nid:'1Epz26fnadq8eB3hNtpwdxd6JaWqcRWyoY'}, "class", MEM.class);
    
    //cmd functions prefix ::
    //cmd vars prefix _ALLCAPS
    //circuit class Prefix->  postfix ?
    //circuit inst prefix->  no postfix
    //sys level sequences named "seq."
    ACQL.RCC_RUNTIME_VAL= MEM.preloadWithOwner(MEM.ANNE,{text: "_RUNTIMEVAL", nid:''}, "class",  MEM._RCC);
    ACQL.RCC_GEN_TEXT_ARR_FROM_TOS= MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_gen_text_arr_from_tos", nid:''}, "inst",  MEM._RCC);
    ACQL.RCC_GET_OUTS = MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_outs", nid:''}, "inst",  MEM._RCC);
    ACQL.RCC_GET_NOBJ_WITH_NID= MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_nobj_with_nid", nid:''}, "inst",  MEM._RCC);
    ACQL.RCC_GET_NOBJS_WITH_NIDS= MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_nobjs_with_nids", nid:''}, "inst",  MEM._RCC);
    ACQL.RCC_GET_RELON_BY_RELN = MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_relon_by_reln", nid:''}, "inst",  MEM._RCC);
    ACQL.RCC_GET_RELONS_BY_RELN= MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_relons_by_reln", nid:''}, "inst",  MEM._RCC);
    ACQL.RCC_GET_RELONS_BY_RELNS= MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_relons_by_relns", nid:''}, "inst",  MEM._RCC);
    ACQL.RCC_GET_TO_NID = MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_to_nid", nid:''}, "inst",  MEM._RCC);
    ACQL.RCC_GET_TO_NIDS= MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_to_nids", nid:''}, "inst",  MEM._RCC);
    //ACQL.RCC_GET_TO_NOBJS_WITH_NIDS= MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_get_to_nobjs_with_nids", nid:'174R7bRezMcpD15pxLRpTFQZb3R3qpAZkY'}, "inst",  MEM._RCC);
    ACQL.RCC_RETURN_VAL= MEM.preloadWithOwner(MEM.ANNE,{text: "::rcc_return_val", nid:''}, "inst",  MEM._RCC);
    
    ACQL.RCP_sequence = MEM.preloadWithOwner(MEM.ANNE,{text: "RCP sequence", nid:''}, "class",  MEM.sequence);
    
    //RCP circuit (insts) can take a runtime value (of anything)
    MEM.preLoadFullRelon(TYPE_PARAM, ACQL.RCP_sequence, ACQL.RCC_RUNTIME_VAL,  MEM.class);

    //RCPgetRuntimeVals class, a CIRCUIT that extracts the runtime vals in an inst circuit (to be applied to the class circuit)
    ACQL._RCPgetRuntimeVals = MEM.preloadWithOwner(MEM.ANNE,{text: "->RCPgetRuntimeVals", nid:''}, "class",  MEM._RCP);
    ACQL.seqGetRuntimeVals =  MEM.preloadWithOwner(MEM.ANNE,{text: "seq.getRuntimeVals", nid:''}, "inst",  ACQL.RCP_sequence);
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGetRuntimeVals, MEM._1,  ACQL.RCC_GET_OUTS);               
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGetRuntimeVals, MEM._2,  ACQL.RCC_GET_RELON_BY_RELN);  
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGetRuntimeVals, MEM._3,  ACQL.RCC_RUNTIME_VAL);      
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGetRuntimeVals, MEM._4,  ACQL.RCC_GET_TO_NID);               
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGetRuntimeVals, MEM._5,  ACQL.RCC_GET_NOBJ_WITH_NID);
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGetRuntimeVals, MEM._6,  ACQL.RCC_RETURN_VAL); 
    MEM.preLoadFullRelon(TYPE_PARAM, ACQL._RCPgetRuntimeVals, ACQL.RCP_sequence, ACQL.seqGetRuntimeVals); 

    //RCPgetNidOfToFromWith circuit class
    ACQL._RCPgetNidOfToFromWith = MEM.preloadWithOwner(MEM.ANNE,{text: "->RCPgetNidOfToFromWith?", nid:''}, "class",  MEM._RCP);
    ACQL.seqgetNidOfToFromWith =  MEM.preloadWithOwner(MEM.ANNE,{text: "seq.getNidOfToFroMWith", nid:''}, "inst",  ACQL.RCP_sequence);
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqgetNidOfToFromWith, MEM._1,  ACQL.RCC_GET_OUTS);                  //start at the self from
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqgetNidOfToFromWith, MEM._2,  ACQL.RCC_GET_RELON_BY_RELN);         //look for a reln
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqgetNidOfToFromWith, MEM._3,  ACQL.RCC_RUNTIME_VAL);               //a reln = the MEM.subject.nid
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqgetNidOfToFromWith, MEM._4,  ACQL.RCC_GET_TO_NID);                //return the .t of the relon
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqgetNidOfToFromWith, MEM._5,  ACQL.RCC_RETURN_VAL);                //look for a reln
    MEM.preLoadFullRelon(TYPE_PARAM, ACQL._RCPgetNidOfToFromWith, ACQL.RCP_sequence, ACQL.seqgetNidOfToFromWith);              //tie the fsSeqInst to the froms_subject

    //RCPgetNidOfToFromWith circuit INSTANCE, with a provided runtime value of MEM.subject  
    ACQL._RCPgetNidOfToFromWith_subj = MEM.preloadWithOwner(MEM.ANNE,{text: "->RCPgetNidOfToFromWith_subj", nid:''}, "inst",  ACQL._RCPgetNidOfToFromWith);                    //start at the self from
    MEM.preLoadFullRelon(TYPE_HAS, ACQL._RCPgetNidOfToFromWith_subj, ACQL.RCC_RUNTIME_VAL,  MEM.subject);
    
    //circuit to generate a text list of the tos of all relons from a neuron, with a reln.
    ACQL._RCPgenTextListOfAllRelnsOf = MEM.preloadWithOwner(MEM.ANNE,{text: "->RCPgenTextListOfAllRelnsOf?", nid:''}, "class",  MEM._RCP);
    ACQL.seqGenTextListOfAllRelnsOf =  MEM.preloadWithOwner(MEM.ANNE,{text: "seq.genTextListOfAllRelnsOf", nid:''}, "inst",  ACQL.RCP_sequence);
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGenTextListOfAllRelnsOf, MEM._1,  ACQL.RCC_GET_OUTS);                //start at the self from
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGenTextListOfAllRelnsOf, MEM._2,  ACQL.RCC_GET_RELONS_BY_RELN);      //look for relons
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGenTextListOfAllRelnsOf, MEM._3,  ACQL.RCC_RUNTIME_VAL);             //a reln = the MEM.__PARAM.nid
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGenTextListOfAllRelnsOf, MEM._4,  ACQL.RCC_GEN_TEXT_ARR_FROM_TOS);   //return the to_s
    MEM.preLoadFullRelon(TYPE_HAS, ACQL.seqGenTextListOfAllRelnsOf, MEM._5,  ACQL.RCC_RETURN_VAL);              //look for a reln
    MEM.preLoadFullRelon(TYPE_PARAM, ACQL._RCPgenTextListOfAllRelnsOf, ACQL.RCP_sequence, ACQL.seqGenTextListOfAllRelnsOf);        //tie the fsSeqInst to the froms_subject

    //for parameter lists.. we exctact the params and build a text list.
    ACQL._RCPgenTextListOfAllRelnsOf_params = MEM.preloadWithOwner(MEM.ANNE,{text: "->RCPgenTextListOfAllRelnsOf_params", nid:''}, 
                                                    "inst",  ACQL._RCPgetNidOfToFromWith);            
    MEM.preLoadFullRelon(TYPE_HAS, ACQL._RCPgenTextListOfAllRelnsOf_params, ACQL.RCC_RUNTIME_VAL,  MEM.__PARAM);
    
    //fIX some base level concepts in existing MEM that require an RCP
    //we want range_low's default children to be the parent subject (if it exists)
    //a "RELATIVE" graph relationship
    MEM.preLoadFullRelon(TYPE_PARAM, MEM.range_low, MEM._RESTRICT_TO, ACQL._RCPgetNidOfToFromWith_subj); 

    //we want range_low's default children to be the parent subject (if it exists)
    //a "RELATIVE" graph relationship
    MEM.preLoadFullRelon(TYPE_PARAM, MEM.range_high, MEM._RESTRICT_TO, ACQL._RCPgetNidOfToFromWith_subj); 

    console.log("*********** ACQL READY ***********");
    return true;
}


ACQL._getAndRunCmdSequence=function($fromNObj, $RCPNOBJ, $runtimeNOBJS=null) {
    console.log("(_RCP_getAndRunCmdSequence) ", $fromNObj, $RCPNOBJ);
    var rcpSeq = null;
    if ($RCPNOBJ.ntype==NTYPE_CLASS) {
        TALK.printRelons($RCPNOBJ.outs);
        var seqR = ACQL._RCC_GET_RELON_BY_RELN_FUNC($RCPNOBJ.outs, ACQL.RCP_sequence.temp_nid);
        rcpSeq = ACQL._RCC_GET_TO_NOBJ_FUNC(seqR);  
        return ACQL.__RCP_processor($fromNObj, rcpSeq, $runtimeNOBJS);
    }

    else if ($RCPNOBJ.ntype==NTYPE_INST) {
        TALK.printRelons($RCPNOBJ.outs);
        var RCPCLASS = MEM._aNeurons[$RCPNOBJ.bes[0]];  

        //extract the TOS of all runtime values into an array
        var runntimeNOBJ = ACQL._getAndRunCmdSequence($RCPNOBJ, ACQL._RCPgetRuntimeVals);
        console.log(runntimeNOBJ); 
        //rerun with the original fromNObj but use the classObj cricuit + runtime vals
        return ACQL._getAndRunCmdSequence($fromNObj, RCPCLASS, runntimeNOBJ);
    }    
}  

//relative circuit path processor
ACQL.__RCP_processor = function ($refRobj, $RCP_obj, $runtimeNOBJ=null) {
    var outs = $RCP_obj.outs;

    //just to make sure, let's sort it one more time.
    outs.sort(MEM.__compareSeqRelons);  //where is this???

    var last_val = $refRobj;
    var cmds = outs;
    for (var r=0; r < cmds.length; r++) {
        if (cmds[r].type!=TYPE_HAS) continue;

        //get the reln cmd --> the to_s  (.t is the temp_nid of the to_s)
        var cmd = MEM._aNeurons[ cmds[r].t ];
        var next_cmd = null;
        if (r < cmds.length-1) next_cmd = MEM._aNeurons[ cmds[r+1].t ];

        //if it is a RCC, process it, return the nObj
        if (cmd.bes[0]==MEM._RCC.temp_nid) {
            if (next_cmd!=undefined && next_cmd!=null && next_cmd.temp_nid==ACQL.RCC_RUNTIME_VAL.temp_nid) {
                if ($runtimeNOBJ!=null) next_cmd = $runtimeNOBJ;
            }
            var obj = ACQL.__RCC_processor (last_val, cmd.temp_nid, next_cmd);
            console.log(obj);
            if (obj.instructions=="next") last_val = obj.val;
            else if (obj.instructions=="next_next") {
                last_val = obj.val;
                r+=1;
            }
            else if (obj.instructions=="return") return obj.val;
            else {
                console.log("UNHANDLED INSTRUCTIONS", obj);
                return null;
            }
        }
    }

    //we shouldn't get here .. but in case a return cmd was forgotten, it will try to give what it has.
    return last_val;    
}

//relative circuit cmd processor  //RCC_RUNTIME_VAL
ACQL.__RCC_processor = function ($ref, $cmd, $next_cmd=null) {
    if ($cmd==ACQL.RCC_GET_OUTS.temp_nid) {
        var outs = ACQL._RCC_GET_OUTS_FUNC($ref);
        return {"instructions":"next", "val":outs};
    }
    //these require a present next_cmd.
    if ($cmd==ACQL.RCC_GET_RELON_BY_RELN.temp_nid) {
        if ($next_cmd==undefined) return {"instructions":"bad"};
        var rObj = ACQL._RCC_GET_RELON_BY_RELN_FUNC($ref, $next_cmd.temp_nid);
        return {"instructions":"next_next", "val":rObj};
    }
    if ($cmd==ACQL.RCC_GEN_TEXT_ARR_FROM_TOS.temp_nid) {
        if ($next_cmd==undefined) return {"instructions":"bad"};
        var rObj = ACQL._RCC_GET_TEXT_ARR_FROM_RELONS($ref, "t", "to_s");
        return {"instructions":"next_next", "val":rObj};
    }
    if ($cmd==ACQL.RCC_GET_RELONS_BY_RELN.temp_nid) {
        if ($next_cmd==undefined) return {"instructions":"bad"};
        var rObjs = ACQL._RCC_GET_RELONS_BY_RELN_FUNC($ref, $next_cmd.temp_nid);
        return {"instructions":"next_next", "val":rObjs};
    }
    if ($cmd==ACQL.RCC_GET_RELONS_BY_RELNS.temp_nid) {
        if ($next_cmd==undefined) return {"instructions":"bad"};
        if (typeof $next_cmd != 'array')  return {"instructions":"bad", "msg":"likely wrong cmd preceeding.  Array expected"};
        var rObjs = ACQL._RCC_GET_RELONS_BY_RELNS_FUNC($ref, $next_cmd);
        return {"instructions":"next_next", "val":rObjs};
    }
    if ($cmd==ACQL.RCC_GET_NOBJ_WITH_NID.temp_nid) {
        var nObj = ACQL._RCC_GET_NOBJ_WITH_NID($ref);  
        return {"instructions":"next", "val":nObj};
    }
    if ($cmd==ACQL.RCC_GET_NOBJS_WITH_NIDS.temp_nid) {
        var nObjs = ACQL._RCC_GET_NOBJS_WITH_NIDS($ref);  
        return {"instructions":"next", "val":nObjs};
    }
    if ($cmd==ACQL.RCC_GET_TO_NID.temp_nid) {
        var temp_nid= ACQL._RCC_GET_TO_NID_FUNC($ref);
        return {"instructions":"next", "val":temp_nid};
    }
    if ($cmd==ACQL.RCC_GET_TO_NIDS.temp_nid) {
        var temp_nids= ACQL._RCC_GET_TO_NIDS_FUNC($ref);
        return {"instructions":"next", "val":temp_nids};
    }
    if ($cmd==ACQL.RCC_RETURN_VAL.temp_nid) {
        return {"instructions":"return", "val":$ref};
    }
    
    return  {"instructions":"unhandled cmd passed "+$cmd};
}

 
ACQL._RCC_GET_TEXT_ARR_FROM_RELONS=function($relons, $prop, $alt_prop) {
    if ($relons==undefined) return null; 
    var arr = [];
    for (var r=0; r < $relons.length; r++) {
        var temp_nid = $relons[r][$prop];
        if ($r==undefined || $r==-1) arr.push($relons[r][$alt_prop]);
        else arr.push(ACQL._RCC_GET_NOBJ_WITH_NID(temp_nid).text);
    }
    return arr;
}
ACQL._RCC_GET_NOBJ_WITH_NID=function($nid) { if ($nid==undefined || $nid==null || $nid<0) return null; return MEM._aNeurons[$nid]; }
ACQL._RCC_GET_NOBJS_WITH_NIDS=function($nids) { 
    if ($nids==undefined || $nids==null || $nids.length==0) return []; 
    var nObjs = [];
    for (var n=0; n < $nids.length; n++) { nObjs.push(MEM._aNeurons[$nids[n]]);}
    return nObjs;
}
ACQL._RCC_GET_OUTS_FUNC=function($ref) { if ($ref==null || $ref.outs==undefined) return null; return $ref.outs; }
ACQL._RCC_GET_RELON_BY_RELN_FUNC=function($outs, $r) { if ($outs==undefined) return null; return $outs.find(obj => obj.r === $r); }
ACQL._RCC_GET_RELONS_BY_RELN_FUNC=function($outs, $r) { 
    if ($outs==undefined) return []; 
    var rObjs = [];
    console.log("looking for r:"+$r);
    console.log( MEM.getNeuronByTempNid($r).text );
    TALK.printRelons($outs);
    for (var r=0; r < $outs.length; r++) {
        if ($outs[r].r==$r) rObjs.push($outs[r]);
    }
    return rObjs;
}
ACQL._RCC_GET_RELONS_BY_RELNS_FUNC=function($outs, $r_nids) { 
    if ($outs==undefined) return []; 
    if ($r_nids==undefined || $r_nids==null) return [];
    var rObjs = [];
    for (var r=0; r < $outs.length; r++) {
        if ($r_nids.indexOf($outs[r].r)!=-1) rObjs.push($outs[r]);
    }
    return rObjs;
}
ACQL._RCC_GET_TO_NID_FUNC=function($rObj) { if ($rObj==null || $rObj.t==undefined) return null; return $rObj.t; }
ACQL._RCC_GET_TO_NIDS_FUNC=function($rObjs) { 
    if ($rObjs==null || $rObjs==undefined || $rObjs.length==0) return [];
    var nids = [];
    for (var r=0; r < $rObjs.length; r++) { nids.push($rObjs[r].t); } 
    return nids; 
}

ACQL._RCC_GET_TO_NOBJ_FUNC=function($rObj) { 
    if ($rObj==null || $rObj.t==undefined) return null; 
    return ACQL._RCC_GET_NOBJ_WITH_NID($rObj.t); 
}
