
/**
 * dossier_image
 */
 class dossier_image extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        console.log("%c dossier_image", TALK.bgredbig);
        if ($misc==null) $misc = {bNOIMG:true};
        else $misc.bNOIMG=true;
        super($pgui, $secondary, $third, $misc);
        this.afile=null;
        this._skips.push(MEM.fka.temp_nid);
    }
    
    initASYNC = async($pguicopy)=>{
        this._skips.push(MEM.neuronImg.temp_nid, MEM.primaryNeuronImg.temp_nid, MEM.neuronVid.temp_nid, MEM.neuronAudio.temp_nid)
        await this.getData(false, this.nObj);
        await this.doHeading();

        this.alterLayout("66","34%");

        var badAudit=false;
        
        //THIS HSOULD BE AT THE TOP
        var el_here = document.createElement("div");
        this.el_content.appendChild(el_here);
        el_here.classList.add("img-big-holder");

        //official IMG neurons must pass the audit to display.
        var loadRez = await IMAGES.loadAuditAndDisplayFromNObj(this.nObj, el_here, "img-dossier", 0, 0, 200);
        this.afile = loadRez.afile;
        if (this.afile.audit>MEDIA_AUDIT_NOTRUN) {
            this.nObj.audit="good";
        }
        else {
            badAudit = true;
            this.nObj.audit="bad";
        }

        //this.doAKA(this.el_bes_content);
        //this.doFKA(this.el_bes_content);
        this.doAltBES(this.el_bes_content);

        //$el, $headingClass="section-title-center", $mappedEvents=[], $tnids_only=[], $col1class="tal50", $col2class="tal50", $title="HAS attributes"
        var el_has = await this.doAllHas(this.el_bes_content, "section-title-center", [], [], "tal35-lbl", "tal65-data");    
        if (badAudit==true) {
            ANNE.A.ezEl(el_has, "div", "simple-row bg-danger2 text-center", "IMG FINGER AUDIT DID NOT PASS");
        }
        else {
            ANNE.A.ezEl(el_has, "div", "simple-row bg-success text-center", "IMG FINGER VERIFIED");
        }

        await this.doAllParams(this.el_content);
        this.doKwds(this.el_content);
        this.doAssociate(this.el_content, "section-title-center");
        await this.doAllInsSection2(this.el_content, "inbound references", true);
       
        this.addAwarvu();
        ANNE.A.removeSelf(this.el_thumbs);
        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }
}