
/**
 * identity
 */
 class dossier_identity extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_identity", TALK.bgredbig);
    }
    initASYNC = async($pguicopy)=>{
        //actions/ghosts can potentially get turned back on if there are pending
        //ghosts to send and this is the user's profile.
        ANNE.A.hide(this.el_actions);

        var bISIDENTITY=true; //we will get ranks
        
        await this.getData(bISIDENTITY, this.nObj);
        await this.doHeading(false, []);
        
        ANNE.A.removeSelf("garden_"+this.nObj.temp_nid);

        await this.doANNEID();    //summary data was snagged in getData instead of the aplex record.

        if (this.nObj.nid==USER._userNObj.nid) {
            await this.getBalance();    
            await this.doAllParams(this.el_content, "", true);
        }

        await this.doHas(this.el_content, "HAS attributes", true);    //generic.   

        if (this.nObj.nid!=USER._userNObj.nid) {
            this.addAwarvu();
        }
        
        await this.doAnumSection(this.el_content);
        
        await this.doImgs(this.el_thumbs); //images after the body

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);

        this.removeANNEXSECTION();
        
    }


    /**
     * to do, add blocks mined metric and find a way to capture it in the annode.
     */
    doANNEID = async()=> {
        var aObj = this.nObj._anneid;
        if (aObj==undefined || aObj==null) return;
        var pObj = new page_params();
        this.el_bes_content.setAttribute("id", "bes_content_"+this.nObj.nid);
        pObj.injection_div = this.el_bes_content.id;
        var misc = {};
        pObj.misc = misc;
        misc.parent_INST = this;
        pObj.p1=this.nObj.nid;
        await PAGES.openPartWithLastPGUI("identity_view", pObj);

        ANNE.A.setHTML("id_name", this.nObj.bestNameHTML());
        var parentNOBJ = this.nObj.getParent();
        if (parentNOBJ!=null) {
            ANNE.A.setHTML("id_class_type", parentNOBJ.bestNameHTML());
        }
        else {
            ANNE.A.setHTML("id_class_type", "fix this jerky");
        }
        
        var _anneid = this.nObj._anneid;
        
        ANNE.A.setHTML("blocks_mined", UTILS.commas(_anneid.blocks_mined));
        ANNE.A.setHTML("rank_bm", _anneid.colorizeRank(_anneid.rank_bm));
        
        ANNE.A.setHTML("share_mines", UTILS.commas(_anneid.share_mines));
        ANNE.A.setHTML("rank_sm", _anneid.colorizeRank(_anneid.rank_sm));
        
        ANNE.A.setHTML("andy_actions", UTILS.commas(_anneid.andy_actions));
        ANNE.A.setHTML("rank_aa", _anneid.colorizeRank(_anneid.rank_aa));

        ANNE.A.setHTML("hanais", UTILS.commas(_anneid.hanais));
        ANNE.A.setHTML("rank_ha", _anneid.colorizeRank(_anneid.rank_ha));

        ANNE.A.setHTML("sponsored_neurons", UTILS.commas(_anneid.sponsored_neurons));
        ANNE.A.setHTML("rank_sn", _anneid.colorizeRank(_anneid.rank_sn));
        
        ANNE.A.setHTML("relons_sponsored", UTILS.commas(_anneid.relons_sponsored));
        ANNE.A.setHTML("rank_rs", _anneid.colorizeRank(_anneid.rank_rs));
    
        ANNE.A.setHTML("did_annex", UTILS.commas(_anneid.did_annex));
        ANNE.A.setHTML("rank_da", _anneid.colorizeRank(_anneid.rank_da));
    
        ANNE.A.setHTML("got_annexed", UTILS.commas(_anneid.got_annexed));
        ANNE.A.setHTML("rank_ga", _anneid.colorizeRank(_anneid.rank_ga));
    
        ANNE.A.setHTML("boostybacks_won", UTILS.commas(_anneid.boostybacks_won));
        ANNE.A.setHTML("rank_bw", _anneid.colorizeRank(_anneid.rank_bw));


        ANNE.A.removeSelf("bebox_name_"+this.ID);

        ANNE.A.addClass("ids_box_"+this.ID, "ids-box-for-identity")
    }
}