/**
 * person
 * 
 * no more wiki or tmdb queries in this view.
 * just edits of existing info or manual entries using the annkh
 */
 class dossier_person extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_person", TALK.bgredbig);
    }


    /**
     * 
     * @returns 
     */
    initASYNC = async()=>{
        //this.beBoxLeft();

        await this.getData(false, this.nObj, []);
        await this.doHeading();

        this.doLifeHeader();
        this._skips.push(MEM.birthday.temp_nid);
        this._skips.push(MEM.deathday.temp_nid);
        this._skips.push(MEM.birthplace.temp_nid);
        this._skips.push(MEM.deathplace.temp_nid);
        this._skips.push(MEM.wcImgUriPart_thumbnail.temp_nid);
        this._skips.push(MEM.tribal.temp_nid);
        this._skips.push(MEM.ethnicity.temp_nid);

        this.testMergeDD();

        if (this.pending_hanai_relon==null) { 
            //ANNE.A.show(this.el_wiki);
            //ANNE.A.show(this.el_tmdb);
            //this.el_wiki.addEventListener("click", e=>this._getWIKIData(e));
            //this.el_tmdb.addEventListener("click", e=>this._getTMDBData(e));
        }

        //this._skips.push(MEM.language.temp_nid);
        //this._skips.push(MEM.firstName.temp_nid); 
        //this._skips.push(MEM.lastName.temp_nid); 
        //this._skips.push(MEM.middleName.temp_nid);
        
        //either owned by this user OR ANNE..
        //show the el tmdb.
        if (this._bMAKEHANAIEVENT==true && this.nObj.owned_by==USER._userNObj.nid) {
            if (this.nObj.ghost==false && this.nObj.temp==false) {
                if (this.el_hanai_to_anne_btn) {
                    ANNE.A.show(this.el_hanai_to_anne_btn);
                }
                //if (this.pending_hanai_relon==null) ANNE.A.show(this.el_tmdb);  //for now, always show this option.
            }
            else {
                //if (this.pending_hanai_relon==null) ANNE.A.show(this.el_tmdb);  //for now, always show this option.
            }
        }
        else if (ANNE.isANNE(this.nObj.owned_by)==true) {
            //if (this.pending_hanai_relon==null) ANNE.A.show(this.el_tmdb);  //for now, always show this option.
        }
                
        var mapped_events = [ 
            {r:MEM.birthday.temp_nid, actionNOBJ:MEM.born, role:"ROLE_WHEN"},
            {r:MEM.birthplace.temp_nid, actionNOBJ:MEM.born, role:"ROLE_WHERE"},
            {r:MEM.deathday.temp_nid, actionNOBJ:MEM.die, role:"ROLE_WHEN"},
            {r:MEM.deathplace.temp_nid, actionNOBJ:MEM.die, role:"ROLE_WHERE"},
            ];

                 
        //this.doAKA(this.el_bes_content);
        //this.doFKA(this.el_bes_content);
        
        this.doAltBES(this.el_bes_content, [MEM.gender.temp_nid,MEM.political_party.temp_nid]);

        await this.doKinfolk(this.el_bes_content);

        await this.doAllParams(this.el_content);
        
        await this.doHas(this.el_content, "HAS attributes", mapped_events);    //generic.
        await this.displayEvents(this.el_content);
        
        

        //do ins here for names.
        //all dossiers now do this
        //if (this.nObj.ghost==false) await ANNE.API.getIns(this.nObj.nid);

        await this.doAllInsSection2(this.el_content, "inbound references", true, "section-title", "first");

        await this.doIDS(this.el_content, "ids", true);


        await this.doAnumSection(this.el_content);
        
        //mapped events are now available thru the action vb.
        //the action vb which we will tie to the class (ie, person)
        //has inbound mappers.
        //loadDefaultRelon(Consts.TYPE_SYS, founded_by, ECS.role_mapper_action, founded);
        
        //relook at this...
        //gui was simplified for now.
 

        //they should added to skips here if we have them.
        this.doAllSysRelons(this.el_content);

        await this.doImgs(this.el_thumbs); //images after the body
        

        //this.doMeta(this.el_meta);  //left stats
        //this.doAllSysRelons(this.el_admin); //right admins
        
        this.addAwarvu();

        this.smartScroll();


        //deep linking back to this page..
        //we want to load up an event on the screen.
        if (this.event_clump_nid!=null) {
            this.launchExistingEvent(this.event_clump_nid);
        }
        return;
    }


 }
