class maker_gui {
    constructor($pgui) {
        this.bNEWONLY=false;
        this.ID = $pgui.guid;
        this.pgui = $pgui;
        this.pObj = $pgui.pObj;
        this.misc = this.pObj.misc;
        if (this.misc==undefined || this.misc==null) this.misc=new Object();
        this.misc.newOk=true;
        if (this.pgui.bNEWONLY!=undefined && this.pgui.bNEWONLY==true) this.bNEWONLY=true;
        this.nObjs = [];
        this.nid = $pgui.pObj.p2;
        this.bDISPLAYDONE=false;
        this.el_new_section = document.getElementById("new_section_"+this.ID);
        this.el_my_section = document.getElementById("my_section_"+this.ID);
        ANNE.A.hide(this.el_my_section);
        this.el_btn_new = document.getElementById("btn_new_"+this.ID);
        this.el_btn_mine = document.getElementById("btn_mine_"+this.ID);
        this.el_read_more = document.getElementById("btn_read_more_"+this.ID);

        this.overrideMsg = "";
        
        this.initEvents();

        if (this.bNEWONLY==true) this.newModeOnly();

        if (ANNE.SETTINGS.debug()==true) {
            console.log(this.pgui);
            console.log(this.pObj);
        }
        
        //default back to proper third...
    }

    setOverrideMsg = function($overrideMsg) {
        this.overrideMsg = $overrideMsg;    
    }
    
    //hijacking the maker for a new neuron + relon.
    newModeOnly = function() {
        //console.warn("newModeOnly");
        this.el_btn_mine.removeEventListener("click", e=>this.showMine(e) );
        this.el_btn_new.removeEventListener("click", e=>this.showNew(e) );
        ANNE.A.removeParent(this.el_btn_mine);
        ANNE.A.removeParent(this.el_btn_new);
        ANNE.A.removeSelf("maker_msg_"+this.ID);
        ANNE.A.removeSelf(this.el_my_section);
        
        if (this.pgui.pObj.c_cbk!=undefined) {
            var el_cancel = document.getElementById("dynamic_cancel_"+this.ID);
            ANNE.A.show(el_cancel);
            ANNE.A.ezSquareDelete(el_cancel, this.pgui.pObj.c_cbk, [this.pgui], "36px", "nevermind");
        }
    }
    refresh = async()=> {
        this.bDISPLAYDONE=false;
        await this.displayData();
    }
    showmore = async($e)=> {
        var removeEl = document.getElementById("read_more_"+this.ID);
        await ANNE.MEM_UDF.popupEl(removeEl);
    }

    //make sure this shows only the thing, not all things.
    showMine = async($e)=>{
        ANNE.A.hide(this.el_new_section);
        await ANNE.UTILS.sleep(200);
        await this.displayData();
        ANNE.A.show(this.el_my_section);
        ANNE.A.addRemoveClass(this.el_btn_new, "toggled-offg2", "toggled-ong2");
        ANNE.A.addRemoveClass(this.el_btn_mine, "toggled-on2", "toggled-off2");
        ANNE.PAGES.updateThird("mine");
    }

    showNew = async($e)=>{
        ANNE.A.hide(this.el_my_section);
        ANNE.A.show(this.el_new_section);
        ANNE.A.addRemoveClass(this.el_btn_mine, "toggled-off2", "toggled-on2");
        ANNE.A.addRemoveClass(this.el_btn_new, "toggled-ong2", "toggled-offg2");
        ANNE.A.smartScroll(this.el_new_section);
        ANNE.PAGES.updateThird("new");
    }

    initEvents() {
        //console.log("init events");
        if (this.el_btn_new!=null) this.el_btn_new.addEventListener("click", e=>this.showNew(e) );
        if (this.el_btn_mine!=null) this.el_btn_mine.addEventListener("click", e=>this.showMine(e) );
        if (this.el_read_more!=null) { 
            this.el_read_more.addEventListener("click", e=>this.showMore(e) );
        }
    }
    
    //this presumes the data has already been chased.
    displayData = async ()=> {
        if (this.bDISPLAYDONE==true) return;

        //no data.
        if (this.nObjs.length==0) {
            var nObj = MEMG.getNeuronByNid(this.nid);
            ANNE.A.empty(this.el_my_section);
            var msg = this.overrideMsg;
            if (msg==null || msg=="") {
                msg = "You have no sponsored, owned or remembered '"+nObj.bestName()+"' yet.";
            }
            ANNE.A.ezEl(this.el_my_section, "div", "", msg);
            return;
        }

        var tableObj = new neuron_table(this.pgui);
        tableObj.bCOLORSQARES=true;
        tableObj.makerViewAllCols(this.nObjs);
        tableObj.neuron_heading_row_class = "neuron-tbl-heading-green";
        ANNE.A.empty(this.el_my_section);
        tableObj.buildDOMTable(this.el_my_section, 10, null, true, true, 26);
        ANNE.A.show(this.el_my_section);
        this.bDISPLAYDONE=true;
    }
}


/**
 * 
 */
class maker_all extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.initTbl($ANNKH);
    }
    initTbl = function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getIdentityStuff(USER._userNObj.nid, $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM,  $ANNKH._bSHOWGH, []);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
        if (this.nObjs.length==0) {
            ANNE.A.ezEl(this.el_my_section, "div", "", "You have no owned or sponsored neurons to view yet");
            ANNE.A.show(this.el_my_section);
        }
        else {
            var tableObj = new neuron_table(this.pgui);
            tableObj.bCOLORSQARES=true;
            tableObj.makerViewAllCols(this.nObjs);
            tableObj.neuron_heading_row_class = "neuron-tbl-heading-green";
            ANNE.A.empty(this.el_my_section);

            tableObj.buildDOMTable(this.el_my_section, -1, null, true, true, 26);
            ANNE.A.show(this.el_my_section);
            ANNE.A.smartScroll("maker_inject");
            ANNE.A.show(this.el_my_section);
        }
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
}


/**
 * 
 */
class maker_asdf_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.main_class = new service_asdf($pgui);
        this.initTbl($ANNKH);
    }
    initTbl = function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid,  $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.ASDF.temp_nid, MEM.specific_d_vote_by_list.temp_nid]);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
}


/**
 * 
 */
class maker_anorg_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.main_class = new service_anorg($pgui);
        this.initTbl($ANNKH);
    }
    initTbl = function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid,  $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.anorg.temp_nid, MEM.specific_d_vote_by_list.temp_nid]);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
}


/**
 * 
 */
class maker_bounty_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.main_class = new service_bounty($pgui);
        this.initTbl($ANNKH);
    }

    initTbl = function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid,  $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.bounty.temp_nid, MEM.specific_d_vote_by_list.temp_nid]);
        for (var r=0; r < USER._userNObj.outs.length; r++) {
            var rel = USER._userNObj.outs[r];
            if(rel.type!=TYPE_SYS_MSG) continue;
            if (rel.r!=MEM.anj_accepted.temp_nid) continue;
            if (rel.to_type!=TO_TYPE_TXID) continue;
            if (rel.sys_ref_txid==undefined) continue;

            var statusTxRObj = MEMG.lookupByTXID(rel.sys_ref_txid);
            if(statusTxRObj==null) {
                continue;
            }
            
            var nOBJ = MEMG.getNeuronByNid(statusTxRObj.from_nid);
            var nOBJ2 = MEMG.getNeuronByTempNid(statusTxRObj.f);
            if (nOBJ.nid!=nOBJ2.nid) alert("doh");
            if (nOBJ!=null) this.nObjs.push( nOBJ );
        }
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
        
        //default to showing them (not making them)
        this.showMine();

    }
    
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
}


/**
 * 
 */
class maker_pdn_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.main_class = new service_pdn($pgui);
        this.initTbl($ANNKH);
    }
    initTbl = function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid,  $ANNKH._bSHOWOW, false, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.PDN.temp_nid]);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
}


/**
 * 
 */
class maker_action_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.main_class = new service_actionverb($pgui);
        this.initTbl($ANNKH);
    }
    initTbl=function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid, $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.role_action.temp_nid], [NTYPE_CLASS]);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
}


class maker_general_prop_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.main_class = new service_genprop($pgui);
        this.initTbl($ANNKH);
    }
    initTbl=function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid, $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM._GENERAL_PROP_CLASS.temp_nid], [NTYPE_CLASS]);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
}


/**
 * 
 */
class maker_anndle_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        console.log($pgui);
        super($pgui);
        this.main_class = new service_anndle($pgui);
        this.initTbl($ANNKH);
    }
    initTbl=function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid, $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.anndle.temp_nid]);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);  
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
    initASNC=async($miscObj)=>{
        return await this.main_class.initASYNC($miscObj);
    }
}


/**
 * 
 */
class maker_imgneuron_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.main_class = new service_imgneuron($pgui);
        this.initTbl($ANNKH);
    }
    initTbl=function($ANNKH) {
        this.nObjs = [];
        if (this.bNEWONLY==false) {
            this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid,  $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.neuronImg.temp_nid]);
        }
        //the make new is going to need to be hijacked.
        else {
            this.main_class.bNEWWITHRELON=true;
        }
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
}


/** 
 * the annkh maker tab for location.
 */
class maker_location_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        ANNE.A.hide("passthru_"+this.ID);
        this.initTbl($ANNKH);
    }
    initTbl=function($ANNKH) {
        this.nObjs = [];
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid, $ANNKH._bSHOWOW, $ANNKH._bSHOWSP, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.location.temp_nid]);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
        this.main_class = new service_location_maker(this.pgui);
    }
    checkChg = function($ANNKH) {
        console.log("checkChg");
        ANNE.A.empty(this.el_my_section);
        this.initTbl($ANNKH);
    }
    setHistoricSite($miscObj) {
        this.main_class.setHistoricSite($miscObj);
    }
}