/**
* this is only going to work with the PAGES module... ie, the explorer app.
* We need a different version for apps not using the PAGES module.
*/

class anne_relon_gui {
    constructor ($pgui) {
        this.pgui = $pgui;
        this.ID = $pgui._guid;
        this.pObj = $pgui.pObj;
        this.txid = this.pObj.p1;
        this.andy = this.pObj.p2;   //collab admin (andy), ($relon.andy_rel!=undefined || $relon.isAndyRel!=undefined)
        this.gotRAWTX = false;
        this.rawTX = null;
        this.bISPENDING=false;
        this.status = "";
        this.bDOINGHANAICOLLAB = false;
        this.bUNCONFIRMED_TX = false;
        this.bMALFORMED = false;
        this._annies_required = 0;
        this.bDONOTSHOWDELETEGHOST=false;

        this.rObj = MEM_UDF.getAnyRel(this.txid);

        if (this.rObj==null) {
            console.log("no relon for txid "+this.txid);
            this.bDEAD=true;
            if (ANNE.PAGES!=null) ANNE.PAGES.historyGoBack();
            return;
        }
            
        else {
            //if it exists..
            //we want the andy_rel obj which has more goodies on it for administrative uses..
            if (this.rObj.andy_rel!=undefined && this.rObj.andy_rel!=null) {
                this.rObj = this.rObj.andy_rel;
            }
                
            this.fromNOBJ = MEMG.getNeuronByNid(this.rObj.from_nid);
            this.bDEAD = false;
        }
        
        console.log(this.rObj);

        this.btn_hanai_approve = null;
        this.btn_hanai_approve_all = null;
        this.text_reason = null;
        this.btn_hanai_decline = null; 
        this.btn_hanai_final_decline = null; 
        this.btn_collab_approve = null;
        this.btn_collab_decline = null;


        this.HANAI_IMPACT_OBJ = null;
        
        ANNE.A.hideParent("tx_json_"+this.ID);

        this.el = document.getElementById("ABODY_"+this.ID);
        this.el_title = document.getElementById("relon_title_"+this.ID);
        this.el_body = document.getElementById("relon_body_"+this.ID);
        this.el_txid = document.getElementById("relon_txid_"+this.ID);
        if (this.el_txid==null) {
            console.log("LSDKFLSKJF");
        }
        this.el_explain = document.getElementById("relon_explanation_"+this.ID);
        this.el_admin = document.getElementById("relon_admin_"+this.ID);

        this.el_hanai_impact = document.getElementById("hanai_impact_"+this.ID);

        this.el_hanai_admin = document.getElementById("hanai_admin_"+this.ID)
        this.el_andy_admin = document.getElementById("andy_admin_"+this.ID);
        this.el_type = document.getElementById("relon_type_"+this.ID);
        this.el_required = document.getElementById("relon_req_"+this.ID);
        this.el_mok = document.getElementById("relon_mok_"+this.ID);
        this.el_annies = document.getElementById("relon_annies_"+this.ID);
        this.el_from = document.getElementById("relon_from_"+this.ID);
        this.el_reln = document.getElementById("relon_reln_"+this.ID);     
        this.el_to_type = document.getElementById("relon_to_type_"+this.ID);
        this.el_to_s = document.getElementById("relon_to_"+this.ID);
        this.el_time = document.getElementById("relon_time_"+this.ID);
        this.el_firstseen = document.getElementById("relon_firstseen_"+this.ID);
        this.el_sysreftxid = document.getElementById("relon_sysreftxid_"+this.ID);
        this.el_relon_sponsor = document.getElementById("relon_sponsor_"+this.ID);

        this.autoHanai_ignore = false;
        this.admin_msg_append = "";
        
    }
    

    /**
     */
     init = function(){
        if (this.pgui==null) return;
        this.displayGUI();
    }


    /**
     */
    displayGUI = async ()=> {
        var bDOEXTRAS = true;
        
        //when we instantiated this class in the page we already chased the hypergraph relon.
        //if it doesn't exist -- our only other play is to look in the blockchain TX history.
        if (this.rObj==null || this.bDEAD==true) {
            var btn_show_json = ANNE.A.__getEl("btn_show_json_"+this.ID);
            ANNE.A.hide(btn_show_json);
            ANNE.A.removeSelf("relon_req_"+this.ID);
            ANNE.A.removeSelf("relon_mok_"+this.ID);
            ANNE.A.removeSelf("relon_annies_"+this.ID);
            ANNE.A.removeSelf("relon_from_"+this.ID);
            ANNE.A.removeSelf("relon_type_"+this.ID);
            ANNE.A.removeSelf("relon_reln_"+this.ID);
            ANNE.A.removeSelf("relon_to_type_"+this.ID);
            ANNE.A.removeSelf("relon_to_"+this.ID);
            ANNE.A.removeSelf("relon_sponsor_"+this.ID);
            ANNE.A.removeSelf("relon_firstseen_"+this.ID);
            ANNE.A.removeSelf("relon_sysreftxid_"+this.ID);
            ANNE.A.removeSelf("relon_time_"+this.ID);
            
            await this.__getBlockchainTX(this.txid);
            if (this.el_txid!=null) this.el_txid.append(ANNE.A.span(this.txid));

            ANNE.A.setHTML(this.el_explain, "this relon was destroyed from the graph");
            return;
        }

        //get the updated relon
        if (this.rObj.time==-1 && this.rObj.ghost==false) {
            if (ANNE.SETTINGS.debug()==true) console.log("lookup to confirm still not yet mined");
            await CHASE.lookupTxids([this.rObj.txid]);

            
            if (this.rObj.time==-1) {
                
                var shouldBeMined = ANNE.UTILS.shouldBeMined(this.rObj.firstseen);
                if (shouldBeMined==true) {
                    //lets look this up in our transaction side to see if we actually got a transaction.
                    //if not, move the transaction out from DB MEM, into GHOST, and go back a page.
                    //popup a notice to explain what we did.

                    this.rawTX = await ANNE.API.getBlockchainTransaction(this.txid);
                    console.log(this.rawTX);
                    
                    //for now, just nuke it from RAM and db.
                    if (this.rawTX==null) {
                        var r = confirm("This relon didn't actually get broadcast or wasn't actually retained in the annode.  Delete it from local memory?");
                        if (r == true) {
                            await ANNE.DB.___delete([this.rObj.txid], "relons"); 
                            MEMP.annihilateRelon_RAM(this.rObj, []);
                        }
                        if (ANNE.PAGES!=null) return ANNE.PAGES.historyGoBack(null);
                    }
                }
            }
        }

        //if we have any missing names for any part of the relon, chase them (go get their values for display).
        await MEMG.extractAllFromRelonsAndChaseMin([this.rObj], 20, bDOEXTRAS);


        /***************/
        //SET BASIC GUI VALS
        /***************/
        await this.setBasicVals();

        /***************/
        //SET ADMIN VALS
        /***************/
        var bDIDEXPLAIN = await this.setAdminVals();
    
        /********************************/
        // STANDARD EXPLAINS
        /********************************/
        if (bDIDEXPLAIN==false) {
            var explain_msg = await TALK.basicExplain(this.rObj);
            ANNE.A.setHTML(this.el_explain, explain_msg, true);
        }

        //type broadcast payment reln ■annies
        if (this.rObj.type==TYPE_BROADCAST_PAY && this.rObj.reln==MEM.annies.nid) {
            await this.__getBlockchainTX();
        }
    }



    setSponsorRights = function() {
        if (UTILS.isset(this.rObj.relon_sponsor==false)) return;
        
        if (this.fromNOBJ._govenor.isHanaiAdmin(this.rObj.relon_sponsor)==true) {
            this.autoHanai_ignore = true;
        }
    }

    
    /**
     */
    setAdminVals = async()=>{

        //COLLAB HANAI is a COLLAB on the FROMNOBJ but a HANAI on the TO!
        //We must check hanai_rights on the TO!

        //COLLAB HANAI ---------> USER HANAI'S THE TO NEURON.
        if (ANNE.UTILS.isset(this.rObj.collab_type)==true && this.rObj.collab_type==CTYPE_COLLAB_HANAI) {
            this.toNOBJ = MEMG.getNeuronByNid(this.rObj.to_s);
            if (this.toNOBJ!=null && (this.toNOBJ._govenor==undefined || this.toNOBJ._govenor==null)) {
                await this.toNOBJ._setGovenorForUser(USER._userNObj);
            }

            //ANNE gets hanai rights to anything for ANNE
            //else if the toNOBJ has granted rights to this user
            //set the relon's hanai_rights on.
            if (ANNE.isANNE(USER._userNObj.nid)==true || this.toNOBJ._govenor.hanai_admin==true) {
                this.rObj.hanai_rights=true;

                //flag if this user (who submit this relon)
                //has hanai rights -- and this andy is not needed.
                this.setSponsorRights();
            }
        }


        //**** HANAI OUT 
        //THIS IS A HANAI OUT RELON ---> set the rObvj.hanai_rights.
        else if (this.rObj!=null && this.rObj.ghost==false && (this.rObj.hanai_rights==undefined || this.rObj.hanai_rights==null)) {
            
            if (this.rObj.r==MEM.hanai_out.temp_nid) {
                if (this.fromNOBJ!=null) { //redo it.
                    
                    await this.fromNOBJ._setGovenorForUser(USER._userNObj);
                    if (this.fromNOBJ._govenor.hanai_admin==true) {
                        this.rObj.hanai_rights=true;

                        //flag if this user (who submit this relon)
                        //has hanai rights -- and this andy is not needed.
                        this.setSponsorRights();
                    }
                }
            }
            
        }
        

        //GHOST RELON -- no admin features (other than delete)
        if (this.rObj.ghost==true) {
            this._displayGhostRelon();
        }

        /**
         * ANNDLE OFFER (not active at present)
         * This is going to be turned off for the annode threejs app
         */
        else if (this.rObj.r==MEM.anndle_offer.temp_nid) {
            var anndleNOBJ = MEMG.getNeuronByTempNid(this.rObj.t);

            //user is the one with admin rights to this anndle.
            if (USER._userNObj.nid==anndleNOBJ.sponsored_by) {
                console.log("THIS USER CAN APPROVE/DENY THIS REQUEST.");
                await this._displayAnndleOfferAdmin();
            }
            else if (USER._userNObj.nid==this.rObj.from_nid) {
                await this._displayAnndleDealOfferrer();
            }
        }

        
        //********
        //CTYPE_HANAI_ONLY --- just a solo HANAI request
        //********
        else if (this.rObj.hanai_rights!=undefined || this.rObj.collab_type==CTYPE_HANAI_ONLY) {
            return await this._displayHanaiAdmin();
        }


        //*****************
        //CTYPE_MERGE_REQUEST
        //*****************
        else if (((this.andy==true || this.rObj.andy==true) && this.rObj.collab_type==CTYPE_MERGE_REQUEST)
                && this.rObj.type==TYPE_SYS && this.rObj.r==MEM.CMD_MERGE_NEURON.temp_nid) {
            
            //old, already taken action upon.
            if (ANNE.UTILS.isset(this.rObj.sys_ref_txid)==true) {
                
                //this is hijacked value that means something else.
                if (parseInt(this.rObj.sys_ref_txid) < 100000000000000) {
                    var explain_msg = "This is a block trigger to run a merge at the end of grace period on block "+this.rObj.sys_ref_txid;
                    ANNE.A.setHTML(this.el_explain, explain_msg, true);
                }
                else {
                    var eROBJ = MEMG.lookupRelonByTXID(this.rObj.sys_ref_txid);
                    var explain_msg = await TALK.basicExplain(eROBJ);
                    ANNE.A.setHTML(this.el_explain, explain_msg, true);
                }
                
                return true;
            }
            await this._displayCollabAdmin();
            return true; 
        }


        //** COLLAB + HANAI
        //** COLLAB RELON ONLY
        //andy admin w/ collab rights..
        else if ((this.andy==true || this.andy=="1" || this.rObj.andy==true) && this.rObj.collab_type!=undefined 
                 && (this.rObj.collab_type==CTYPE_COLLAB_HANAI  || this.rObj.collab_type==CTYPE_COLLAB_ONLY)) {

            //if ANDY action is already taken, display the result here.  Exit.
            if (ANNE.UTILS.isset(this.rObj.sys_ref_txid)==true) {
                if (parseInt(this.rObj.sys_ref_txid) < 100000000000000) {
                    var explain_msg = "hijacked sys ref txid for other purposes.  Fix explain msg here. TO DO."
                    ANNE.A.setHTML(this.el_explain, explain_msg, true);
                }
                else {
                    var eROBJ = MEMG.lookupRelonByTXID(this.rObj.sys_ref_txid);
                    var explain_msg = await TALK.basicExplain(eROBJ);
                    ANNE.A.setHTML(this.el_explain, explain_msg, true);
                }
                return true;
            }
            
            await this._displayCollabAdmin();
            return true; 
        }


        //** PENDING ANJUCATOR
        else if (this.rObj.collab_type==CTYPE_PENDING_ANJ) {
            await this._displayCollabAdmin();
            return true; 
        }

        //??? (what's the difference here with the above pending ANJ?  Investigate.)
        else if ((this.rObj.r==MEM.anjucator.temp_nid && this.rObj.to_s==USER._userNObj.nid)) {
            await this._displayCollabAdmin();
            return true;  
        }
            
        this.assessDeletability();

        return false;
    }
    


    /**
     */
    setBasicVals=async()=>{

        //title
        var shorthand = TALK.genShortRelonTextByTXID(this.rObj.txid, this.rObj, "&nbsp;&#187;&nbsp;", true);
        if (this.rObj.ghost==true) {
            this.el_title.innerHTML = '<img class="dib" src="../imgs/ghost_ico.png" width="12px" title="Ghost (local neuron).">&nbsp;RELON&nbsp;<span class="sub-title">'+shorthand+'</span>';
        }
        else this.el_title.innerHTML = 'RELON&nbsp;<span class="sub-title">'+shorthand+'</span>';
        
        this._displayTxidAndNodeMsg();

        //type
        this.el_type.innerHTML="<b class='rel_part_lbl'>type</b>&nbsp;"+TALK.typeTalk(this.rObj.type, false, true);
        
        //required
        if (this.rObj.required!=undefined && this.rObj.required==true) {
            if (this.rObj.type!=TYPE_PARAM) this.el_required.innerHTML = "The *require* flag is set on this relon but it not a TYPE_PARAM.  No effect.";
            else this.el_required.innerHTML = "This is a required param for "+this.fromNOBJ.bestNameHTML()+" neurons.";
        }
        else ANNE.A.hide(this.el_required);
        
        //multiples ok
        if (this.rObj._multiples_ok!=undefined && this.rObj._multiples_ok==true) {
            this.el_mok.innerHTML = "The relon parameter can be be used multiple times on this neuron.";
        }
        else ANNE.A.hide(this.el_mok)

        //FROM
        EXT_BTNS.makeNeuronLink_colorSquares(this.el_from, this.fromNOBJ.nid, "", "<b class='rel_part_lbl'>from</b>&nbsp;");
        if (this.fromNOBJ.text!="") {
            var span = document.createElement("span");
            span.classList = 'raw-address';
            span.innerHTML = this.rObj.from_nid;
            this.el_from.append(span);
        }

      
        /************************* */
        //sys ref txid
        if (this.rObj.sys_ref_txid!=undefined && this.rObj.sys_ref_txid!=null && this.rObj.sys_ref_txid.length>0) {

            //one of the few hijacked cases.  sys_ref_txid means block of next check on these.
            //annies was hijacked to store the additional proof claim txid backlink.
            //this saves ALOT of annode time when processing AOTCs.
            if (this.rObj.r==MEM.ANNE_BLOCK_TRIGGER.temp_nid && this.rObj.type==TYPE_BRAIN121) {
                ANNE.A.ezSpan(this.el_sysreftxid, "", "", "<b class='rel_part_lbl'>next rigger block</b>&nbsp;"+this.rObj.sys_ref_txid);
                var proofTxidEl = document.createElement("div");
                proofTxidEl.classList = "simple-row";
                ANNE.A.appendAfter(this.el_sysreftxid, proofTxidEl);
                EXT_BTNS.makeRelonViewLinkWithPre("<b class='rel_part_lbl'>proof claim</b>&nbsp;", proofTxidEl, this.rObj.annies);
            }
            else EXT_BTNS.makeRelonViewLinkWithPre("<b class='rel_part_lbl'>sys reference</b>&nbsp;", this.el_sysreftxid, this.rObj.sys_ref_txid);
            ANNE.A.show(this.el_sysreftxid);
        }
        else ANNE.A.removeSelf(this.el_sysreftxid);
        /************************* */

        //reln
        this.relnNOBJ = MEMG.getOrMakeIfNew(this.rObj.reln);
        EXT_BTNS.makeNeuronLink_colorSquares(this.el_reln, this.relnNOBJ.nid, "", "<b class='rel_part_lbl'>reln</b>&nbsp;");

        //to type
        this.el_to_type.innerHTML = "<b class='rel_part_lbl'>to type</b>&nbsp;<em>"+TALK.toTypeTalk(this.rObj.to_type)+"</em>";
                
        var to_type = this.rObj.to_type;
        var to_s = this.rObj.to_s;

        //encrypted type --
        //extract the goodies, store in the relon.decrypted if we haven't yet
        //update ghost or real relon if this is new .decrypted info.
        if (to_type>=21) {
            if(this.rObj.decrypted==undefined) {

                //do mine first (easier)
                if (this.fromNOBJ.ghost==false) {
                    
                    if(this.fromNOBJ.mine==true) {
                        //we need to have a way to know which type of encryption was used.
                        var decryptObj = await USER.ascertainSelfEncryptionAndDecrypt(this.rObj);
                        if(decryptObj.status=="success") {
                            to_s = decryptObj.decrypted;
                            to_type = parseInt(parseInt(this.rObj.to_type)-20);
                        }
                    }
                }
            }
            else {
                to_s = this.rObj.decrypted;
                to_type = parseInt(parseInt(this.rObj.to_type)-20);
            }
        }


        //TO
        var toNOBJ = null;
        if (to_type==TO_TYPE_ANNE) {
            toNOBJ = MEMG.getNeuronByNid(to_s);
            if (toNOBJ!=null) EXT_BTNS.makeNeuronLink_colorSquares(this.el_to_s, toNOBJ.nid, "", "<b class='rel_part_lbl'>to</b>&nbsp;");
            else {
                this.bMALFORMED = true;
            }
            if (toNOBJ!=null && toNOBJ.text!="") {
                ANNE.A.ezEl(this.el_to_s, "span", "raw-address", to_s);
            }
        }
        else if (to_type==TO_TYPE_TXID) {
            EXT_BTNS.makeRelonViewLinkWithPre("<b class='rel_part_lbl'>to</b>&nbsp;<span class=''>"+this.rObj.to_s+"</span>", this.el_to_s, this.rObj.to_s, false, 8, true);
        }

        else {
            var val = to_s;
            var TTOBJ = MEMG.getTerminatingType(this.relnNOBJ);
            if (TTOBJ!=null) {
                var to_sNOBJ = null;
                if (this.rObj.t!=undefined && this.rObj.t!=-1) to_sNOBJ = MEMG.getNeuronByTempNid(this.rObj.t);
                if (TTOBJ.formatter!=undefined) {
                    if (to_sNOBJ!=null) val = TTOBJ.formatter(to_sNOBJ);
                    else val =  TTOBJ.formatter(val);
                }
            }

            //special case of use of blob, want to make this very clear, so format it w/ #
            //else if (this.rObj.r==MEM.AOTC_ACCEPT_OFFER.temp_nid) {
               //console.log("do format here")
            //}
            this.el_to_s.innerHTML = "<b class='rel_part_lbl'>to</b>&nbsp;<span class='text-success-lbl'>"+val+"</span>";
        }

        //INJECT WARNING BEFORE  (only releavnt if relon is ghost relon)
        if (this.rObj.warning!=undefined && this.rObj.ghost==true) {
            var elwarn = document.createElement("div");
            elwarn.classList = "anne-row bg-warning";
            elwarn.innerHTML = this.rObj.warning;
            ANNE.A.insertAfter(this.el_to_s, elwarn);
        }


        //annies (review this logic)
        if (this.rObj.f==MEM.ANNE_BLOCK_TRIGGER.temp_nid || this.rObj.annies==undefined || this.rObj.annies==0) {
            ANNE.A.hide(this.el_annies);
        }
        else {
            var annies = parseInt(this.rObj.annies);
            GUI_STUFF.doAnniesToAnneSpanFull(this.el_annies, "", annies);

            //if the to_s is a txid then the payment went
            //to FROM NID of the relon.
            if (this.rObj.type==TYPE_SYS_MSG) {

                //don't try to chase rorigin 0
                if (this.rObj.rorigin!=0) await this.__getBlockchainTX(null);
        
                if (to_type==TO_TYPE_TXID) {
                    var paid_relon = MEMG.lookupRelonByTXID(to_s);
                    if (paid_relon!=null) {
                        this.el_annies.innerHTML += " paid to "+paid_relon.from_nid;
                    }
                }
                else if (to_type==TO_TYPE_NUMBER) {
                    if (this.rObj.r==MEM.boosties.temp_nid) {
                        EXT_BTNS.makeNeuronLink_colorSquares(this.el_annies, MEM.boosties_bucket.nid, "", "<b>&nbsp;paid to &nbsp;</b>");
                    }
                    else if (this.rObj.r==MEM.winner_payout.temp_nid) {
                        this.el_annies.innerHTML += " paid to drawing winners (to do, list them here)";
                    }
                }
                else {
                    if (this.rObj.r==MEM.annex.temp_nid) {
                        var payoutNOBJ = MEMG.getOrMakeIfNew(to_s);
                        EXT_BTNS.makeNeuronLink_colorSquares(this.el_annies, payoutNOBJ.nid, "", "<b>&nbsp;paid to ANNEX &nbsp;</b>");
                    }
                    else if (this.rObj.r==MEM.annexed_by.temp_nid) {
                        var payoutNOBJ = MEMG.getOrMakeIfNew(this.rObj.from_nid);
                        EXT_BTNS.makeNeuronLink_colorSquares(this.el_annies, payoutNOBJ.nid, "", "<b>&nbsp;paid to previous holder &nbsp;</b>");
                    }
                    else if (this.rObj.r==MEM.winner_payout.temp_nid) {
                        var sys_ref_txid = this.rObj.sys_ref_txid;
                        if (sys_ref_txid==undefined) {
                            console.log("missing data to generate name of boostie winner");
                            var sysRefRelons = await ANNE.API.getRelonsBySYSREFTXID(this.rObj.txid);
                            if (sysRefRelons.length>0) {
                                var tnids = [];
                                for (var p=0; p < sysRefRelons.length; p++) {
                                    var payoutNOBJ = MEMG.getOrMakeIfNew(sysRefRelons[p].to_s);
                                    tnids.push( payoutNOBJ.temp_nid);
                                }
                                EXT_BTNS.makeNeuronLinkFromNeuronArr(this.el_annies, tnids, "", "<b>&nbsp;paid out to &nbsp;</b>", false,"", "dossier", "sq-");
                            }
                        }
                        this.el_to_s.innerHTML = "<b class='rel_part_lbl'>to</b>&nbsp;<span style='font-size:10px'>winning 4 digits:</span><span class='text-success-lbl'>"+val+"</span>";
                    }
                    else {
                        if (this.rObj.type==TO_TYPE_ANNE) {
                            var payoutNOBJ = MEMG.getOrMakeIfNew(to_s);
                            EXT_BTNS.makeNeuronLink_colorSquares(this.el_annies, payoutNOBJ.nid, "", "<b>&nbsp;paid to &nbsp;</b>");
                        }
                    }
                }
            }
            else if (this.rObj.type==TYPE_AWARENESS) {
                this.el_annies.innerHTML += " paid to holder of sp or own rights";
            }
        }

        //RELON sponsor
        if (this.rObj.relon_sponsor!=undefined) {
            EXT_BTNS.makeNeuronLink_colorSquares(this.el_relon_sponsor, this.rObj.relon_sponsor, "", "<b class='rel_part_lbl'>relon sponsor&nbsp;</b>");
            ANNE.A.show(this.el_relon_sponsor);
        }
        else ANNE.A.hide(this.el_relon_sponsor);

        
        //first seen
        if (this.rObj.firstseen!=undefined && this.rObj.firstseen!=0) {
            this.el_firstseen.innerHTML= "<b class='rel_part_lbl'>first seen</b>&nbsp;<span>"+ANNE.UTILS.printunixds(this.rObj.firstseen)+"</span>";
        }
        else ANNE.A.removeSelf(this.el_firstseen);
        
        //time
        var timemsg = "";
        this.bUNCONFIRMED_TX=true;


        if (this.rObj.ghost==false) {
            if (this.rObj.rorigin==RORIGIN_COLLAB_BROADCAST) {
                if (this.rObj.time!=undefined && this.rObj.time>0) {
                    timemsg= "included in block&nbsp;<span class='text-success'>"+this.rObj.time+"</span>";
                    this.bUNCONFIRMED_TX=false;
                }
    
                //the request could be mined, or not.  To get that data we have to look at the 
                //actual transaction since we don't update this status in the collab tbl
                //and the TX is not yet in the hypergraph until it is accepted.
                else if (this.rObj.height_last_change!=undefined) {
                    timemsg= "<span class='text-success'>submit/mined at block height "+this.rObj.height_last_change+"</span>"; 
                    //this.bUNCONFIRMED_TX=true;
                    //var json = await ANNE.API.getBlockchainTransaction(this.txid);
                    //console.log(json);
                }
            }
            else if (this.rObj.rorigin==RORIGIN_BROADCAST) {
                if (this.rObj.time>0) {
                    this.bUNCONFIRMED_TX=false;
                    timemsg= "included in block&nbsp;<span class='text-success'>"+this.rObj.time+"</span>";
                }
                else if (this.rObj.andy_rel!=undefined) {
                    timemsg = "<span class='text-success'>ANDY relon waiting for admin response</span>";
                }
                else timemsg = "<span class='text-success'>unconfirmed transaction not yet mined</span>"; 
            }
                
            else if (this.rObj.rorigin==RORIGIN_ANNODE) {
                if (this.rObj.time>0) {
                    this.bUNCONFIRMED_TX=false;
                    timemsg= "added by the annode at block height <span class='text-success'>"+this.rObj.time+"</span>";
                }
            }
        }

        else {
            timemsg = "(will receive block time when broadcast)";
            
            //this happens with a bad broadcast and a mistaken update in RAM (and even indexeddb)
            //our relon gets an origin yet it wasn't actually successfully broadcast.
            //will chase this out and stop it from happening.
            //IF it does, this fixes it.
            if (this.rObj.rorigin!=RORIGIN_GHOST) {
                this.rObj.rorigin=RORIGIN_GHOST;
                this.rObj.time = -1;
                await GHOSTDATA.updateDBSingleGhostRelon(this.rObj);
                this._displayTxidAndNodeMsg(); //fix the display.
            }
            
        }
        
        if (timemsg!="") this.el_time.innerHTML= timemsg;

        //raw json btn
        if (this.rObj.rorigin==RORIGIN_BROADCAST || this.rObj.rorigin==RORIGIN_COLLAB_BROADCAST) {
            this.__activateJsonBtn();
        }
        else ANNE.A.removeParent("tx_json_"+this.ID);
    }


    /**
     */
    _displayTxidAndNodeMsg=function() {
        ANNE.A.empty(this.el_txid);

        var img = EXT_BTNS.getRelonLinkIco(this.rObj);
        if (this.rObj.temp==true && this.rObj.ghost==false) this.el_txid.append(ANNE.A.span("This is a temp relon (not on-chain or in RAM tbls)"));
        else this.el_txid.append(ANNE.A.span(img+this.rObj.txid));
        var originMsg = "";
        if (this.rObj.rorigin==RORIGIN_ANNODE) originMsg="&nbsp;annode generated relon";
        else if (this.rObj.rorigin==RORIGIN_BROADCAST) originMsg="&nbsp;relon from broadcast";
        else if(this.rObj.rorigin==RORIGIN_GHOST) {
            if (this.rObj.TEMP_ONLY!=undefined) {
                originMsg="&nbsp;<span class='text-warning'>TEMP ONLY</span> relon for gui display.  L1 will create this proper upon submission/hanai.";
                ANNE.A.hide("rv_delete_ghost_btn_"+this.ID);
                this.bDONOTSHOWDELETEGHOST=true;
            } 
            else originMsg="&nbsp;local relon (no one else sees it)";
        }
        else if (this.rObj.rorigin==RORIGIN_COLLAB_BROADCAST) originMsg="&nbsp;relon from collab broadcast";
        else originMsg="&nbsp;unhandled relon rorigin '"+this.rObj.rorigin+"'";
        this.el_txid.innerHTML=this.el_txid.innerHTML+originMsg;
    }


    /**
     */
    _displayGhostRelon = function() {
        ANNE.A.addRemoveClass(this.el_txid, "ghost-actions", "black-subheader");
        if (this.bMALFORMED==true || this.rObj.to_s==null || this.rObj.to_s=="") {
            ANNE.A.setHTML("ghost_upgrade_here_"+this.ID, "THIS RELON IS MALFMORED --> DELETE IT!");
            return;
        }

        //10,000,000

        //if ghost relon on ghost neuron, it will trigger all needed TXs in the q.
        //if just a ghost relon on a normal neuron, it will just be this one relon.
        var ghostmsg = "upgrade this ghost relon";
        if (this.fromNOBJ.ghost==true) ghostmsg += " (& ghost neuron)";
        else if (this.fromNOBJ.owned_by!=USER._userNObj.nid) {
           //if (this.rObj.r==MEM.AOTC_ACCEPT_OFFER.temp_nid) ghostmsg = "do the ANNE OTC deal";
            //else 
            ghostmsg = "upgrade this ghost collab relon";
        }
        var msg = ANNE.EXT_BTNS.getSenderBtnMsg(this.fromNOBJ, "60", ghostmsg, "");
        var btn = ANNE.A.setHTML("ghost_upgrade_here_"+this.ID, msg, true);
        btn.addEventListener("click", e=>this.upgradeGhostRelon(e));
        ANNE.A.show(this.el_admin);

        if (this.bDONOTSHOWDELETEGHOST==false) {
            var btnDelete = ANNE.A.__getEl("rv_delete_ghost_btn_"+this.ID);
            btnDelete.addEventListener("click", async(e)=>{
                await ANNE.GHOSTDATA.deleteSingleGhostRelon(this.txid);
                this.closeAndGoBack(null);
            });
        }
        
        //hanai stuff is impossible on ghosts.
        ANNE.A.removeSelf(this.el_hanai_impact);
        ANNE.A.removeSelf(this.el_hanai_admin);
        ANNE.A.removeSelf(this.el_andy_admin);
    }


    /**
     */
    _displayCollabAdmin=async()=> {
        //ghost upgrade is impossible on non-ghost. :)
        ANNE.A.removeSelf("relon_ghost_stuff_"+this.ID);
        //await this.__getBlockchainTX(null);

        var ctype = "";
        var anjInvite = false;
        var bEARLYEXIT = false;
        var bKEEP = false;

        this.btn_collab_approve = document.getElementById("btn_collab_approve_"+this.ID);
        this.btn_collab_decline = document.getElementById("btn_collab_decline_"+this.ID);
            
        if (this.rObj.collab_type!=undefined) {
            //will do govenor checks on this to ensure proper admin rights.
            if (this.rObj.collab_type==CTYPE_COLLAB_ONLY) {
                ctype = "collab";
                this.btn_collab_approve.innerHTML="approve "+ctype;
                this.btn_collab_decline.innerHTML="decline "+ctype; 
            }

            //don't need to do govenor checks on this.
            //can do them if we want (looking for ANNE admins or andy super supers)
            else if (this.rObj.collab_type==CTYPE_MERGE_REQUEST) {
                ctype = "collab";
                this.btn_collab_approve.innerHTML="approve merge";
                this.btn_collab_decline.innerHTML="decline merge"; 
                
                var reconObj = await ANNE.API.getMergeReconByTXID(this.rObj.txid);
                if (reconObj==undefined || reconObj==null || reconObj.status!="good") {
                    //remove notification from annode.
                    //we have no record of this thing.
                    ANNE.A.setHTML(this.el_explain, "Error: "+reconObj.reason, true);
                    return;
                }

                ANNE.A.show(this.el_admin);
                ANNE.A.show(this.el_andy_admin);
                ANNE.A.show(this.el_explain);

                //annies are required to annex the abosrbed neuron.
                this._annies_required = reconObj.result.annies_required;

                if (this._annies_required!=0) {
                    this.el_explain.innerHTML = this.el_explain.innerHTML+"<BR>There are annies required to payoff a sponsor and make this merge.<BR>";
                    var el_annies = document.createElement("span");
                    el_annies.style.display="block";
                    this.el_explain.appendChild(el_annies);
                    ANNE.A.ezAnniesToAnneDisplay(el_annies, this._annies_required);
                }
               
                this.btn_collab_approve.addEventListener("click", e=>this.approveCollab(e));
                this.btn_collab_decline.addEventListener("click", e=>this.declineCollab(e));
                return;
            }
                
            else if (this.rObj.collab_type==CTYPE_COLLAB_HANAI) {

                //user must have both HANAI rights AND the proper ANDY rights to the TO NEURON!
                if (this.rObj.hanai_rights==true) {
                    
                    //let's try this here too -- to show the impact.
                    /*********/
                    
                   
                    //in the collab hanai pattern the TO is the neuron we want to HANAI.
                    var toNOBJ = MEMG.getNeuronByNid(this.rObj.to_s);
                    
                    this.HANAI_IMPACT_OBJ = await ANNE.HANAI.adminTestForMultiHanai(toNOBJ);
                    if (this.HANAI_IMPACT_OBJ.others_ch.length>1) {
                        this.btn_collab_hanai_approve_all = document.getElementById("btn_relon_collab_hanai_approve_all_"+this.ID);
                        this.btn_collab_hanai_approve_all.addEventListener("click", e=>this.approveCollabHanaiAll(e))
                        ANNE.A.showParent(this.btn_collab_hanai_approve_all);
                        ANNE.A.setHTML(this.btn_collab_hanai_approve_all, "approve **ALL** "+this.HANAI_IMPACT_OBJ.others_ch.length+" hanai & collabs from this user!")
                    }
                    if (this.HANAI_IMPACT_OBJ.valid==false) {
                        ANNE.A.ezEl(this.el_hanai_impact, "div", "", this.HANAI_IMPACT_OBJ.msg,"", "", {"text-align":"center"});
                        ANNE.A.show(this.el_hanai_impact);
                    }
                    else {
                        ANNE.A.ezEl(this.el_hanai_impact, "div", "", this.HANAI_IMPACT_OBJ.msg,"", "", {"text-align":"center"});
                        ANNE.A.show(this.el_hanai_impact);
                    }
                    /*********/
                    
                    ctype = "hanai & collab";
                    this.bDOINGHANAICOLLAB=true;
                    ANNE.A.addRemoveClass(this.btn_collab_approve, "btn-pink-sq", "btn-green-sq");
                   
                    var adden = "Please make sure to check out the '"+toNOBJ.text+"' neuron before approval.";
                    ANNE.A.setHTML("admin_section_title_"+this.ID, "Hanai & Collab Admin");
                    var el_rvico = ANNE.A.addRemoveClass("rv_ico_display", "hanai-collab-big-ico", "andy-big-ico");
                    el_rvico.parentNode.style['background-color']="#fe17df";
                    this.btn_collab_approve.innerHTML="approve "+ctype;
                    this.btn_collab_decline.innerHTML="decline "+ctype; 
                    ANNE.A.show(this.btn_collab_approve);
                    ANNE.A.show(this.btn_collab_decline);
                    bKEEP=true;
                }
                else {
                    ANNE.A.show(this.el_explain); 
                    ANNE.A.removeSelf(this.el_hanai_impact);
                    ANNE.A.removeSelf(this.el_hanai_admin);
                    bEARLYEXIT=true;
                }
            }

            //sometimes the collab type isn't set (we don't have it in MEM_UDF collab space mem)
            else if (this.rObj.collab_type==CTYPE_PENDING_ANJ) {
                ctype = "anjucator invite";
                ANNE.A.addRemoveClass(this.btn_collab_approve, "btn-purple-sq", "btn-green-sq");
                var toNOBJ = MEMG.getNeuronByNid(this.rObj.to_s);
                var adden = "You have been invited to be an anjucator for the '"+toNOBJ.text+"' neuron.";
                
                ANNE.A.setHTML("admin_section_title_"+this.ID, "Anjucator Invite", true, "white-text");

                var el_rvico = ANNE.A.addRemoveClass("rv_ico_display", "anjucator-big-white-ico", "andy-big-ico");
                el_rvico.parentNode.style['background-color']="#7a0faf";
                if (this.rObj.to_s!=USER._userNObj.nid) {
                    ANNE.A.removeParent("btn_collab_approve_"+this.ID);
                    ANNE.A.removeParent("btn_collab_decline_"+this.ID);
                    ANNE.A.hide("andy_admin_"+this.ID);
                }
                anjInvite = true;
                this.btn_collab_approve.innerHTML="approve "+ctype;
                this.btn_collab_decline.innerHTML="decline "+ctype; 
            }
        }

        else {
            //sometimes the dagnab relon isn't set (we don't have it in MEM_UDF collab space mem)
            if ((this.rObj.r==MEM.anjucator.temp_nid && this.rObj.to_s==USER._userNObj.nid)) {
                ctype = "anjucator invite";
                ANNE.A.addRemoveClass(this.btn_collab_approve, "btn-purple-sq", "btn-green-sq");
                var toNOBJ = MEMG.getNeuronByNid(this.rObj.to_s);
                var adden = "You have been invited to be an anjucator for the '"+toNOBJ.text+"' neuron.";
                
                ANNE.A.setHTML("admin_section_title_"+this.ID, "Anjucator Invite", true, "white-text");

                var el_rvico = ANNE.A.addRemoveClass("rv_ico_display", "anjucator-big-white-ico", "andy-big-ico");
                el_rvico.parentNode.style['background-color']="#7a0faf";
                if (this.rObj.to_s!=USER._userNObj.nid) {
                    ANNE.A.removeParent("btn_collab_approve_"+this.ID);
                    ANNE.A.removeParent("btn_collab_decline_"+this.ID);
                    ANNE.A.hide("andy_admin_"+this.ID);
                }
                anjInvite = true;
                this.btn_collab_approve.innerHTML="approve "+ctype;
                this.btn_collab_decline.innerHTML="decline "+ctype; 
                if (this.rObj.to_s==USER._userNObj.nid) {
                    this.btn_collab_approve = document.getElementById("btn_collab_approve_"+this.ID);
                    this.btn_collab_decline = document.getElementById("btn_collab_decline_"+this.ID);
                    this.btn_collab_approve.addEventListener("click", e=>this.approveAnjInvite(e));
                    this.btn_collab_decline.addEventListener("click", e=>this.declineAnjInvite(e));
                    this.rObj.status_text="p";
                    this.rObj.collab_type==CTYPE_PENDING_ANJ
                    ANNE.MEM_UDF.addCollabFromBroadcast(this.rObj, CTYPE_PENDING_ANJ);
                    this.el_explain.innerHTML="This is a pending <b>anjucator invite</b>.";
                    ANNE.A.removeSelf(this.el_hanai_impact);
                    ANNE.A.removeSelf(this.el_hanai_admin);
                    ANNE.A.show(this.el_admin);
                    ANNE.A.show(this.el_andy_admin);
                    ANNE.A.show(this.el_explain);
                    return;
                }
            }     
        }

        //collab relons..
        if (this.rObj.status_text!=undefined && this.rObj.status_text=="r") {
            this.status="r";
            this.el_explain.innerHTML="This was a rejected <b>"+ctype+"</b> request to add data to the <b>"+this.fromNOBJ.text+"</b> neuron.";
        }

        else if (this.rObj.status_text=="p") {
            this.status="p";
            if (anjInvite) {
                this.el_explain.innerHTML="This is a pending <b>anjucator invite</b>.";
            }
            else {
                var msg = ANNE.MEM_UDF.getCollabTypeMsg(this.rObj);
                this.el_explain.innerHTML=msg
            }

            this.bISPENDING=true;
        }

        else if (this.rObj.status_text=="a") {
            this.status="a";
            if (this.bUNCONFIRMED_TX==false) {
                this.el_explain.innerHTML="This is an approved <b>"+ctype+"</b> request waiting to be mined.";
            }
            else this.el_explain.innerHTML="This is an approved <b>"+ctype+"</b> request.";
            this.bISPENDING=false;
            ANNE.A.show(this.el_explain); 
            ANNE.A.removeSelf(this.el_hanai_impact);
            ANNE.A.removeSelf(this.el_hanai_admin);
            return;
        }

        if (bEARLYEXIT==true) return;

        //trying to get collab-hanai to work like hanai with impaact (arrrg)
        //what a rube mess this relon_view is.
        if (bKEEP==false) {
            ANNE.A.removeSelf(this.el_hanai_impact);
            ANNE.A.removeSelf(this.el_hanai_admin);
        }
        ANNE.A.show(this.el_admin);
        ANNE.A.show(this.el_andy_admin);
        ANNE.A.show(this.el_explain);


        if (anjInvite==true) {
            if (this.rObj.to_s==USER._userNObj.nid) {
                if (this.bISPENDING==true) {
                    this.btn_collab_approve = document.getElementById("btn_collab_approve_"+this.ID);
                    this.btn_collab_decline = document.getElementById("btn_collab_decline_"+this.ID);
                    this.btn_collab_approve.addEventListener("click", e=>this.approveAnjInvite(e));
                    this.btn_collab_decline.addEventListener("click", e=>this.declineAnjInvite(e));
                }
            }
            return;
        }

        
        var admin_user_action = 0;

        if (this.fromNOBJ.bISIDENTITY == true) {
            admin_user_action = govenor.COLLAB_NOCOLLABIDENTITY;
        }
            
        else {
            this.fromNOBJ._govenor = null;
            admin_user_action = await this.fromNOBJ.setGovRights(USER._userNObj);
        }
        
        if (admin_user_action>=govenor.DELEGATE_NOW && this.bISPENDING==true) {   
            this.btn_collab_approve = document.getElementById("btn_collab_approve_"+this.ID);
            this.btn_collab_decline = document.getElementById("btn_collab_decline_"+this.ID);
            if (this.bDOINGHANAICOLLAB==true) {
                this.btn_collab_approve.addEventListener("click", e=>this.approveHanaiCollab(e));
                this.btn_collab_decline.addEventListener("click", e=>this.declineHanaiCollab(e));
            }
            else {
                this.btn_collab_approve.addEventListener("click", e=>this.approveCollab(e));
                this.btn_collab_decline.addEventListener("click", e=>this.declineCollab(e));
            }
        }
        else {
            ANNE.A.removeParent("btn_collab_approve_"+this.ID);
            ANNE.A.removeParent("btn_collab_decline_"+this.ID);
            ANNE.A.ezSpan(this.el_hanai_admin, "", "", "Collab request waiting approval");
            ANNE.A.hide("andy_admin_"+this.ID);
        }
    }

 

    /**
     * 
     */
    _displayAnndleOfferAdmin = async()=>{
        ANNE.A.show("relon_admin_"+this.ID);
        ANNE.A.removeSelf("relon_ghost_stuff_"+this.ID)
        ANNE.A.hideParent("tx_json_"+this.ID);
        ANNE.A.show("anndle_admin_"+this.ID);

        //set button events for approve/deny
        //s.b. same as on the dossier page.
        var btn_approve = ANNE.A.__getEl("btn_anndle_approve_"+this.ID);
        btn_approve.addEventListner("click", async($e)=>{
            ANNE.A.hide(btn2);
            var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_accept_offer.nid, TO_TYPE_TXID, this.rObj.txid);
            await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_ACCEPT_OFFER);   
            ANNE.playSound("success");
            return await SENDQ.___sendQueue();
        });

        var btn_decline = ANNE.A.setHTML("btn_anndle_decline_"+this.ID, "decline buy offer");
        btn_decline.addEventListner("click", async($e)=>{
            ANNE.A.hide(btn2);
            var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_decline_offer.nid, TO_TYPE_TXID, this.rObj.txid);
            await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_DECLINE_OFFER);   
            ANNE.playSound("success");
            return await SENDQ.___sendQueue();
        });
    }


    /**
     * 
     */
    _displayAnndleDealOfferrer = async()=>{
        ANNE.A.show("relon_admin_"+this.ID);
        ANNE.A.removeSelf("relon_ghost_stuff_"+this.ID)
        ANNE.A.hideParent("tx_json_"+this.ID);
        ANNE.A.show("anndle_admin_"+this.ID);

        //remove APPROVE btn.
        ANNE.A.hide("btn_anndle_approve_"+this.ID);

        //rename REJECT btn.
        var btn_revoke = ANNE.A.setHTML("btn_anndle_decline_"+this.ID, "revoke buy offer");
        btn_revoke.addEventListner("click", async($e)=>{
            ANNE.A.hide(btn2);
            var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_revoke_offer.nid, TO_TYPE_TXID, this.rObj.txid);
            await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_REVOKE_OFFER);   
            ANNE.playSound("success");
            return await SENDQ.___sendQueue();
        });
    }


    /**
     */
    _displayHanaiAdmin = async()=> {
        ANNE.A.removeSelf("relon_ghost_stuff_"+this.ID);
        ANNE.A.removeSelf(this.el_andy_admin);
        var bAUTOHANAI = false;

        //MEM.dr_andy_hanai_in;
        //MEM.dr_super_super
        //MEM.dr_andy_hanai_in
        //console.log(this.fromNOBJ._govenor);
        //this.fromNOBJ._govenor.applygardenRulesForIdentity(USER._userNObj.nid);
        if (this.autoHanai_ignore==true) {
            console.log("this will be an auto hanai.");
            bAUTOHANAI = true;
        }
        
        this.text_reason = document.getElementById("relon_decline_reason_"+this.ID);
        this.btn_hanai_decline = document.getElementById("btn_relon_decline_"+this.ID);
        this.btn_hanai_approve = document.getElementById("btn_relon_approve_"+this.ID);
        this.btn_hanai_approve_all = document.getElementById("btn_relon_approve_all_"+this.ID);
        this.btn_hanai_final_decline = document.getElementById("btn_relon_final_decline_"+this.ID);
        
        this.el_hanai_admin.classList.add("hanai-bg");


        //for admins, we really should pull this to vet if it is done.
        await ANNE.API.getOuts(this.rObj.from_nid, true, [0,1,7]);
        
        if (this.rObj.sys_ref_txid!=undefined && this.rObj.sys_ref_txid!=null) {
            if (this.rObj.status_text!=undefined) {
                console.log(this.rObj.status_text);
            }
            var sysRefRel = ANNE.MEMG.lookupByTXID(this.rObj.sys_ref_txid);
            if (sysRefRel!=null) {
                if (sysRefRel.r==ANNE.MEM.hanai_in_reject.temp_nid) {
                    console.log("already rejected");
                    this.admin_msg_append = "This Hanai was rejected.";
                    ANNE.A.hide(this.el_admin);
                    ANNE.A.hide(this.el_hanai_admin);
                    ANNE.A.setHTML(this.el_explain, this.admin_msg_append, true);
                    return true;
                }
                else if (sysRefRel.r==ANNE.MEM.hanai_in.temp_nid) {
                    console.log("already approved");
                    this.admin_msg_append = "This Hanai was approved.";
                    ANNE.A.hide(this.el_admin);
                    ANNE.A.hide(this.el_hanai_admin);
                    ANNE.A.setHTML(this.el_explain, this.admin_msg_append, true);
                    return true;
                }
            }
        }


        ANNE.A.show(this.el_admin);
        ANNE.A.show(this.el_hanai_admin);
        
        if (bAUTOHANAI==false) {
            this.btn_hanai_approve.addEventListener("click", e=>this.approveHanaiClicked(e));
            //but how do we know if we have approval for all these types of hanais??
            var pendings_by_this_user = ANNE.MEM_UDF.pendingHanaisFor(this.rObj.relon_sponsor);
            if (pendings_by_this_user.length>1) {
                ANNE.A.showParent(this.btn_hanai_approve_all);
                this.btn_hanai_approve_all.addEventListener("click", e=>this.approveHanaiAllClicked(e))
            }

            this.btn_hanai_decline.addEventListener("click", e=>this.declineHanaiClicked(e));
            this.btn_hanai_final_decline.addEventListener("click", e=>this.finalDeclineHanai(e));

            //show hanai impact...
            this.HANAI_IMPACT_OBJ = await ANNE.HANAI.adminTestForMultiHanai(this.fromNOBJ);
            console.log(this.HANAI_IMPACT_OBJ);
            if (this.HANAI_IMPACT_OBJ.valid==false) {
                ANNE.A.ezEl(this.el_hanai_impact, "div", "", this.HANAI_IMPACT_OBJ.msg,"", "", {"text-align":"center"});
                ANNE.A.show(this.el_hanai_impact);
            }
            else {
                ANNE.A.ezEl(this.el_hanai_impact, "div", "", this.HANAI_IMPACT_OBJ.msg,"", "", {"text-align":"center"});
                ANNE.A.show(this.el_hanai_impact);
                if (this.HANAI_IMPACT_OBJ.force_others==true) {
                    ANNE.A.hide(this.btn_hanai_approve);
                    ANNE.A.showParent(this.btn_hanai_approve_all); //sb already showing..
                    this.btn_hanai_approve_all.innerHTML="approve **ALL**("+this.HANAI_IMPACT_OBJ.others.length+") HANAIS from this user";
                }
            }
        }

        //false alarm, hanai will be auto approved by L1 according to rights set for this sending user.
        //(relon_sponsor)
        else {
            this.btn_hanai_approve.classList.add("disabled");
            this.btn_hanai_approve_all.classList.add("disabled");
            this.btn_hanai_decline.classList.add("disabled");
            this.btn_hanai_final_decline.classList.add("disabled");
            ANNE.A.setHTML("hanai_admin_title", "<b>Hanai admin</b> <span style='font-size:14px'>(**AUTO approved when mined**)</span>")
        }
        
        //why?
        //if (this.bUNCONFIRMED_TX==true) {
            //ANNE.A.hide(this.btn_hanai_approve);
            //ANNE.A.hide(this.btn_hanai_decline);
            //ANNE.A.hide(this.btn_hanai_final_decline);
            //ANNE.A.ezEl(this.el_hanai_admin, "div", "simple-col f8", "Can't take admin action until HANAI out is mined into a block.","", "", {"text-align":"center", "color":"whitesmoke", "min-width":"300px"});
        //}

        return "";

    }


    /**
     * can this relon be deleted?
     * 
     * build out as needed as we finalize L1 protocol.
     * @returns 
     */
    assessDeletability = function(){

        if (this.rObj.ghost==true || this.rObj.temp==true) return;

        if (ANNE.MEM.isANNEADMIN(ANNE.USER._userNObj.nid)==true) {
            if (this.rObj.type==TYPE_SYS_MSG) return;       //never can delete sys msgs
            if (this.rObj.type==TYPE_AWARENESS) return;     //never can delete historic feelz/opinions (can update them w/ new ones)
            if (this.rObj.type==TYPE_BROADCAST_PAY) return; //never can delete broadcast pay relons

            if (this.rObj.type==TYPE_SYS && this.rObj.sys_ref_txid!=null && this.rObj.sys_ref_txid!="") {
                return;
            }

            //real relon delete button.
            var deletebtn = ANNE.A.showParent("rv_delete_real_relon_btn_"+this.ID);

            ANNE.A.show("relon_admin_"+this.ID);
            ANNE.A.hide("ghost_upgrade_here_"+this.ID);
            ANNE.A.hide("rv_delete_ghost_btn_"+this.ID);
            deletebtn.addEventListener("click", e=>this.deleteRealRelon(e));
            return;
        }


        //can't delete relons that are not from you or are not from neurons owned by you.
        //note:  users can do a "collab delete" but that will not show up in the relon_view gui.
        //relon view gui delete is reserved for taking decisive actions.
        if (this.fromNOBJ.nid!=USER._userNObj.nid && this.fromNOBJ.owned_by!=USER._userNObj.nid) {
            return;
        }
        
        //can't delete relon with relon_sponsor
        if (ANNE.isANNE(USER._userNObj.nid)==false && UTILS.isset(this.rObj.relon_sponsor)==true && this.rObj.relon_sponsor!=USER._userNObj.nid) return; 
        
        if (this.rObj.type==TYPE_SYS_MSG) return;       //never can delete sys msgs
        if (this.rObj.type==TYPE_AWARENESS) return;     //never can delete historic feelz/opinions (can update them w/ new ones)
        if (this.rObj.type==TYPE_BROADCAST_PAY) return; //never can delete broadcast pay relons

        //no destroying past TYPE_SYS that were cmds and have sys_ref_txid set.
        
        //eg. can't delete an anjucator invite that has been responded to.
        //note: it may be the case that we don't want ANY relon that has sys_ref_txid set to be deletable.
        //I will observe this and see if that should be the rule here.

        //eg. can't destroy a merge neuron request that has bene responded to.
        //note:  can admins DESTROY a merge neuron request instead of responding to it?  //NO!
        //TODL: must make sure those cannot be arbor pruned.
        if (this.rObj.type==TYPE_SYS && this.rObj.sys_ref_txid!=null && this.rObj.sys_ref_txid!="") {
            return;
        }

        //real relon delete button.
        var deletebtn = ANNE.A.showParent("rv_delete_real_relon_btn_"+this.ID);

        ANNE.A.show("relon_admin_"+this.ID);
        ANNE.A.hide("ghost_upgrade_here_"+this.ID);
        ANNE.A.hide("rv_delete_ghost_btn_"+this.ID);
        deletebtn.addEventListener("click", e=>this.deleteRealRelon(e));
    }
    

    /**
     */
    deleteRealRelon = async($e)=>{
        if (ANNE.PAGES!=null) PAGES.historyPopLast(); //we don't want to go back here.
        var rel = await this.fromNOBJ._makeArborPrune(this.rObj.txid);
        await SENDQ.addRelonToSendQ(rel, true, TXB.TXTYPE_SELF_RELON);
    }


  

    /**
     * This one relon could require a bunch of thigns are submit.
     * If it truly is solo and unconnected to any other ghosts then it 
     * will be submit by itself.
     */
    upgradeGhostRelon=async($e)=>{
        ANNE.A.show("loading");
        this.ghost_to_anneOBJ = new ghost_to_anne(this.fromNOBJ);
        var bAUTOHANAI = true;
        if (ANNE.SETTINGS!=null) bAUTOHANAI = ANNE.SETTINGS.bAUTOHANAI;
        await this.ghost_to_anneOBJ.update(this.fromNOBJ, 0, true, bAUTOHANAI);
        await ANNE.SENDQ.___sendQueue(this.upgradeRelonComplete);
        ANNE.A.hide("loading");
    }


    /**
     */
     upgradeRelonComplete = async($relons)=> {
        console.log("%c (upgradeRelonComplete) ", TALK.bgpink);
        var tnids_map = this.ghost_to_anneOBJ.tnids_map;
        await ANNE.GHOSTDATA.deleteByTnidsMap(tnids_map, null);
        this.closeAndGoBack(null);
    }


    hidebtns=function() {
        ANNE.A.hide(this.btn_hanai_approve);
        ANNE.A.hideParent(this.btn_hanai_approve_all);
        ANNE.A.hide(this.text_reason);
        ANNE.A.hide(this.btn_hanai_decline);
        ANNE.A.hide(this.btn_hanai_final_decline);
    }

    
    /**
     */
    approveHanaiAllClicked=async($e)=>{
        this.hidebtns();
        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.hanai_in_all.nid, TO_TYPE_ANNE, this.rObj.relon_sponsor, null);
        sys_msg_relon.sys_ref_txid = this.rObj.txid;   
        if (ANNE.PAGES!=null) ANNE.PAGES.setTargetPageByOffset(1);    //we want to go one back from here.
        ANNE.SENDQ.___sendQueue(ANNE.PAGES.goToTargetPage);
    }


    /**
     */
    approveHanaiClicked=async($e)=>{
        this.hidebtns();
        var hanai_rels = this.HANAI_IMPACT_OBJ.hanai_rels;
        if (ANNE.UTILS.containsTXID(hanai_rels, this.rObj.txid)==false) hanai_rels.push(this.rObj);
        var unique_fix = [];
        for (var h=0; h < hanai_rels.length; h++) {
            if (unique_fix.indexOf(hanai_rels[h].txid)!=-1) continue;
            var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.hanai_in.nid, TO_TYPE_TXID, hanai_rels[h].txid, null);
            
            //this forces the ref txid to be mined first!
            //it is key to ensuring the balance is available for the neuron to pay out the admin!
            sys_msg_relon.sys_ref_txid = this.txid;   
            unique_fix.push(hanai_rels[h].txid);
        }
            
        if (ANNE.PAGES!=null) ANNE.PAGES.setTargetPageByOffset(1);    //we want to go one back from here.
        ANNE.SENDQ.___sendQueue(ANNE.PAGES.goToTargetPage);
    }


    /**
     * reasons?  we haven't tested that in ages. Oh my.
     */
    declineHanaiClicked=async($e)=>{
        ANNE.A.show("relon_dspan_"+this.ID);
        ANNE.A.show(this.btn_hanai_final_decline);
        ANNE.A.hide(this.btn_hanai_approve);
        ANNE.A.hideParent(this.btn_hanai_approve_all);
        ANNE.A.hide(this.btn_hanai_decline);
        ANNE.A.show(this.text_reason);
    }


    /**
     */
    finalDeclineHanai=async($e)=>{
        ANNE.A.hide("relon_dspan_"+this.ID);
        this.hidebtns();
        
        //do relon..
        //return to close
        var reason = ANNE.A.getValue(this.relon_decline_reason);
        if (reason==null || reason==undefined || reason.length < 10) {
            alert("decline reason must be atleast 10 chars");
            return;
        }
        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.hanai_in_reject.nid, TO_TYPE_STRING, reason, null, null);
        
        //this forces the ref txid to be mined first!
        //it is key to ensuring the balance is available for the neuron to pay out the admin!    
        sys_msg_relon.sys_ref_txid = this.txid;
        ANNE.PAGES.setTargetPageByOffset(1);    //we want to go one back from here.
        ANNE.SENDQ.___sendQueue(ANNE.PAGES.goToTargetPage);
    }


    /**
     * 
     * @param {*} $e 
     */
    approveCollabHanaiAll = async($e)=>{
        if (ANNE.SETTINGS.debug()==true) console.log("(approveCollabHanaiAll)");
        ANNE.A.hide(this.btn_collab_approve);
        ANNE.A.hide(this.btn_collab_decline);
        ANNE.A.hideParent(this.btn_collab_hanai_approve_all);
        var ge = null;
        if (this._annies_required!=0) {
            ge = new Object();
            ge.payment = parseInt(this._annies_required);
        }
        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.hanai_and_collab_accept_all.nid, TO_TYPE_TXID, this.txid, ge);
        sys_msg_relon.sys_ref_txid = this.txid;
        ANNE.PAGES.setTargetPageByOffset(1);    //we want to go one back from here.
        ANNE.SENDQ.___sendQueue(async($rez)=>{
                if (ANNE.SETTINGS.debug()==true) console.log("(__approvalCollabSent)");
                ANNE.A.hide("relon_admin_"+this.ID);
                ANNE.A.hide("andy_admin_"+this.ID);
                console.log($rez);  //should also update this status_txid (and sys_ref_txid in the rel)
                for (var r=0; r < this.HANAI_IMPACT_OBJ.others.length; r++) {
                    this.HANAI_IMPACT_OBJ.others[r].status_text="a";
                }
                return ANNE.PAGES.goToTargetPage($rez);
            }, 
            null,  
            function() {
                if (ANNE.SETTINGS.debug()==true) console.log("(cancelled)");
                ANNE.A.hide("relon_admin_"+this.ID);
                ANNE.A.hide("andy_admin_"+this.ID);
                return;
            }
        );
    }


    /**
     * Don't do these as ghosts, just temps then broadcast them.
     */
    approveCollab=async($e)=>{
        console.log("(approveCollab)");
        ANNE.A.hide(this.btn_collab_approve);
        ANNE.A.hide(this.btn_collab_decline);
        ANNE.A.hide(this.btn_collab_hanai_approve_all);
        var ge = null;
        if (this._annies_required!=0) {
            ge = new Object();
            ge.payment = parseInt(this._annies_required);
        }

        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.andy_collab_accepted, TO_TYPE_TXID, this.txid, ge);
        sys_msg_relon.sys_ref_txid = this.txid;
        ANNE.PAGES.setTargetPageByOffset(1);    //we want to go one back from here.
        ANNE.SENDQ.___sendQueue(
                async($rez)=>{
                console.log("(__approvalCollabSent)");
                ANNE.A.hide("relon_admin_"+this.ID);
                ANNE.A.hide("andy_admin_"+this.ID);
                this.rObj.status_text="a"; 
                return ANNE.PAGES.goToTargetPage($rez);
                }, 
                null,  
                function() {
                    console.log("(cancelled)");
                    ANNE.A.hide("relon_admin_"+this.ID);
                    ANNE.A.hide("andy_admin_"+this.ID);
                    return;
                });
    }


    /**
     * Don't do these as ghosts, just temps then broadcast them.
     * @param {*} $e 
     */
    approveAnjInvite=async($e)=>{
        console.log("(approveAnjInvite)");
        ANNE.A.hide(this.btn_collab_approve);
        ANNE.A.hide(this.btn_collab_decline);
        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.anj_accepted, TO_TYPE_TXID, this.txid, null);
        sys_msg_relon.sys_ref_txid = this.txid;
        ANNE.PAGES.setTargetPageByOffset(1);    //we want to go one back from here.
        ANNE.SENDQ.___sendQueue(this.__approvalAnjSent);
    }
    __approvalAnjSent=async($rez)=>{
        console.log("(approvalAnjSent)");
        ANNE.A.hide("relon_admin_"+this.ID);
        ANNE.A.hide("andy_admin_"+this.ID);
        this.rObj.status_text="a"; 
        ANNE.PAGES.goToTargetPage($rez);
    }


    /**
     * Don't do these as ghosts, just temps then broadcast them.
     * @param {*} $e 
     */
    approveHanaiCollab=async($e)=>{
        console.log("(approveCollab)");
         ANNE.playSound("yesding");
        ANNE.A.hide(this.btn_collab_approve);
        ANNE.A.hide(this.btn_collab_decline);
        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.hanai_and_collab_accept, TO_TYPE_TXID, this.txid, null);
        sys_msg_relon.sys_ref_txid = this.txid;
        ANNE.PAGES.setTargetPageByOffset(1);    //we want to go one back from here.
        ANNE.SENDQ.___sendQueue(this.__approvalHanaiCollabSent);
    }
    /**
     */
    __approvalHanaiCollabSent=async($rez)=>{
        ANNE.A.hide("relon_admin_"+this.ID);
        ANNE.A.hide("andy_admin_"+this.ID);

        if (typeof $rez == "string" && $rez=="cancelled send") {
            return;
        }
        console.log("(__approvalHanaiCollabSent)");
        this.rObj.status_text="a"; 
        ANNE.PAGES.goToTargetPage($rez);
    }


    /**
     * Don't do these as ghosts, just temps then broadcast them.
     * @param {*} $e 
     */
    declineCollab=async($e)=>{
        console.log("(declineCollab)");
        ANNE.A.hide(this.btn_collab_approve);
        ANNE.A.hide(this.btn_collab_decline);
        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.andy_collab_rejected, TO_TYPE_TXID, this.txid, null);
        sys_msg_relon.sys_ref_txid = this.txid;
        ANNE.SENDQ.___sendQueue(this.declineCollabSent);
    }
    __declineCollabSent=async($rez)=>{
        console.log("(__declineCollabSent)");
        ANNE.A.hide("relon_admin_"+this.ID);
        ANNE.A.hide("andy_admin_"+this.ID);
        this.rObj.status_text="d";
        ANNE.PAGES.goToTargetPage($rez);
    }


    /**
     * Don't do these as ghosts, just temps then broadcast them.
     * @param {*} $e 
     */
    declineAnjInvite=async($e)=>{
        console.log("(declineAnjInvite)");
        ANNE.A.hide(this.btn_collab_approve);
        ANNE.A.hide(this.btn_collab_decline);
        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.anj_rejected, TO_TYPE_TXID, this.txid, null);
        sys_msg_relon.sys_ref_txid = this.txid;
        ANNE.SENDQ.___sendQueue(this.__declineAnjSent);
    }
    __declineAnjSent=async($rez)=>{
        console.log("(__declineAnjSent)");
        ANNE.A.hide("relon_admin_"+this.ID);
        ANNE.A.hide("andy_admin_"+this.ID);
        this.rObj.status_text="d";
        ANNE.PAGES.goToTargetPage($rez);
    }


    /**
     * Don't do these as ghosts, just temps then broadcast them.
     * @param {*} $e 
     */
    declineHanaiCollab=async($e)=>{
        console.log("(declineHanaiCollab)");
        ANNE.A.hide(this.btn_collab_approve);
        ANNE.A.hide(this.btn_collab_decline);
        var sys_msg_relon = await MEMZ.ez_new_sys_msg(USER._userNObj, MEM.hanai_and_collab_reject, TO_TYPE_TXID, this.txid, null);
        sys_msg_relon.sys_ref_txid = this.txid;
        ANNE.SENDQ.___sendQueue(this.__declineHanaiCollabSent);
    }

    __declineHanaiCollabSent=async($rez)=>{
        console.log("(__declineHanaiCollabSent)");
        ANNE.A.hide("relon_admin_"+this.ID);
        ANNE.A.hide("andy_admin_"+this.ID);
        this.rObj.status_text="d";
        ANNE.PAGES.goToTargetPage($rez);
    }


    /**
     * Only hit the annode for RAW TX data if the user asks for it.
     */
    __activateJsonBtn=function() {
        var btn_show_json = ANNE.A.showParent("btn_show_json_"+this.ID, true);
        if (btn_show_json==null) return;
        btn_show_json.addEventListener("click", e=>this.__getBlockchainTX(e));
    }

    /**
     */
    __getBlockchainTX=async($e=null)=>{
        if (this.txid[0]=="z" || (this.rObj!=null && this.rObj.ghost==true) || (this.rObj!=null && this.rObj.temp==true)) return;
        if (this.gotRAWTX==true) {
            if (ANNE.A.showing("tx_json_"+this.ID)==true) {
                ANNE.A.hideParent("tx_json_"+this.ID);
                return;
            }
            else {
                ANNE.A.showParent("tx_json_"+this.ID);
                return;
            }
        }
        var msg = "";
        if (this.rObj==null) {
            ANNE.A.show("loading");
            var tx = await ANNE.API.getBlockchainTransaction(this.txid);
            ANNE.A.hide("loading");
            if (tx==null) {
                console.log("couldn't find this transaction on the annode blockchain side.");
                return;
            }
            this.gotRAWTX=true;
        }
                
        else if (this.rObj.rawTX==undefined || this.rObj.rawTX==null) {
            ANNE.A.show("loading");
            this.rObj.rawTX = await ANNE.API.getBlockchainTransaction(this.txid);
            ANNE.A.hide("loading");
            if (ANNE.SETTINGS.debug()==true) console.log(this.rObj.rawTX);
            
            if (this.rObj.rawTX==null) {
                console.warn("couldn't find this transaction on the annode blockchain side.");
                return;
            }
            this.gotRAWTX=true;
        }

        //encrypted msg (decrypted and saved, or first time to decrypt this session)
        if (this.rObj!=null && this.rObj.rawTX 
                && this.rObj.rawTX.attachment 
                && this.rObj.rawTX.attachment.encryptedMessage!=undefined) {
            if (this.rObj.decrypted_msg==undefined || this.rObj.decrypted_msg=="") {
                this.rObj.decrypted_msg = await ANNE.USER.decryptRawTxJsonAttachmentMsg(this.rObj.rawTX);
            }
            msg = this.rObj.decrypted_msg;   
        }

        //standard message
        else if (this.rObj!=null && this.rObj.rawTX!=undefined) {
            if (this.rObj.rawTX.attachment!=undefined && this.rObj.rawTX.attachment!=null 
                && this.rObj.rawTX.attachment.message!=undefined) {
                msg = this.rObj.rawTX.attachment.message;
                this.rObj.msg = msg;
            }
        }

            
       if (this.rObj==null) return;
            
        //hide json, then put this in the real TX area as the msg.
        if (msg!="") {
            var senderNOBJ = MEMG.getOrMakeIfNew(this.rObj.rawTX.sender);
            var receiverNOBJ = MEMG.getOrMakeIfNew(this.rObj.rawTX.recipient);
            var str = "sender: "+senderNOBJ.bestName()+"<BR>receiver: "+receiverNOBJ.bestName()+"<BR>msg: "+msg+"<BR>annies: "+this.rObj.rawTX.amountNQT;
            ANNE.A.setHTML("tx_json_"+this.ID, str);
            ANNE.A.showParent("tx_json_"+this.ID);
        }
        else {
            ANNE.A.setJSON("tx_json_"+this.ID, this.rObj.rawTX);
            ANNE.A.showParent("tx_json_"+this.ID);
            this.gotRAWTX=true;    
        }
    }


    /**
     * 
     */
    closeAndGoBack=async($e)=>{
        if (this.pObj && this.pObj.misc && this.pObj.misc.returnPage!=undefined && this.pObj.misc.returnPage.length) {
            //PAGES.loadPage(this.pObj.misc.returnPage);
            PAGES.historyGoBack($e);
        }

        else PAGES.historyGoBack($e);
    }
    
}


/**
 * ENTER THE PARTS OF A RELON AND MAKE IT.
 */
class relon_naked_entry {
    constructor($pgui) {
        this.pgui = $pgui;
        this.pObj = this.pgui.pObj;
        this.misc = this.pObj.misc;
        this.ID = this.pgui._guid;
        this.cancel_callback = null;
        this.success_callback = null;

        if (this.misc.prompt!=undefined) ANNE.A.setAttribute('prompt_'+this.ID, this.misc.prompt);

        this.el_ghost_btn = document.getElementById("make_ghost_relon_btn_"+this.ID);
        this.el_ghost_btn.addEventListener("click", e=>this.makeGhostRelon(e));
        ANNE.A.hide(this.el_ghost_btn);

        if (this.pObj.c_cbk && typeof this.pObj.c_cbk==="function") this.cancel_callback = this.pObj.c_cbk;
        if (this.pObj.s_cbk && typeof this.pObj.s_cbk==="function") {
            this.success_callback = this.pObj.s_cbk;
        }
        this.el_dynamic_cancel = document.getElementById("dynamic_cancel_"+this.ID);
        if (this.el_dynamic_cancel!=null) {
            ANNE.A.empty(this.el_dynamic_cancel);
            if (this.cancel_callback!=null && this.el_dynamic_cancel!=null) {
                ANNE.A.ezSquareDelete(this.el_dynamic_cancel, this.cancel_callback, [this.pgui], "36px", "nevermind");
            }
        }

        this.type_section = document.getElementById("type_section_"+this.ID);
        this.el_dd_rne_type = document.getElementById("dd_rne_type_"+this.ID);

        this.from_section = document.getElementById("from_section_"+this.ID);
        this.reln_section = document.getElementById("reln_section_"+this.ID);

        this.to_type_section = document.getElementById("to_type_section_"+this.ID);
        this.el_dd_rne_to_type = document.getElementById("dd_rne_to_type_"+this.ID);

        this.to_section = document.getElementById("to_section_"+this.ID);

        this.el_msg = document.getElementById("msg_"+this.ID);

        this.type = null;
        this.fromNOBJ = null;
        this.relnNOBJ = null;
        this.to_type = null;
        this.to_s = null;

        this.el_dd_rne_type.addEventListener("change", e=>this.typeChanged(e));
        this.el_dd_rne_to_type.addEventListener("change", e=>this.toTypeChanged(e));

        this.dynamic_msg = document.getElementById("dynamic_msg_"+this.ID);
        if (this.pObj.misc.title!=undefined) this.dynamic_msg.innerHTML = this.pObj.misc.title;

        this.bDOING_TEMPLATE_PART = false;
    }


    /**
     * Init any values we passed in to this page.
     */
    init = function() {
        if (this.pObj.misc.type!=undefined) {
            var el_parent = ANNE.A.emptyParent(this.el_dd_rne_type);
            this.el_dd_rne_type = null;
            this.type = this.pObj.misc.type;
            //var type_text = ANNE.TALK.typeTalk(this.type); 
            var TOBJ = MEMG.getSysTypeObjByType(this.type);
            ANNE.A.ezSpan(el_parent, "", "disambig-mmw80-lbl", "TYPE");
            ANNE.A.ezEl(el_parent, "div", "disambig-neuron", TOBJ.SYS_ALIAS);
        }

        //no from desired, just fill in the from with a msg.
        if (this.pObj.misc.bDOING_TEMPLATE_PART==true) {
            this.bDOING_TEMPLATE_PART = true;
            var span = document.createElement("span");
            span.classList.add("disambig-mmw80-lbl");
            span.innerHTML="FROM";
            this.from_section.append(span);
            var span2 = document.createElement("span");
            this.from_section.append(span2);
            span2.classList="disambig-neuron";
            span2.innerHTML+="[TBD LATER]";
        }

        //show from if we default it on
        //if no from_nid then we are making a "template"
        //to apply to something else.  this is just a helper form to do so.
        if (this.bDOING_TEMPLATE_PART == false && this.pObj.misc.from_nid!=undefined) {
            ANNE.A.show(this.from_section);
            this.fromNOBJ = MEMG.getNeuronByNid(this.pObj.misc.from_nid);
            this.fromNOBJ.disambigHTMLStr(this.from_section, true, true, "FROM", "disambig-mmw80-lbl");
        }

        if (this.pObj.misc.reln!=undefined && this.pObj.misc.reln!=null) {
            ANNE.A.show(this.reln_section);
            this.relnNOBJ = MEMG.getNeuronByNid(this.pObj.misc.reln_nid);
            this.relnNOBJ.disambigHTMLStr(this.reln_section, true, true, "RELN", "disambig-mmw80-lbl");
        }

        if (this.pObj.misc.to_type!=undefined && this.pObj.misc.to_type!=null) {
            var el_parent = ANNE.A.emptyParent(this.el_dd_rne_to_type);
            this.el_dd_rne_to_type.value = this.pObj.misc.to_type;
            this.el_dd_rne_to_type.setAttribute("disabled", true);
            this.to_type = this.pObj.misc.to_type;
            var to_type_text = ANNE.TALK.toTypeTalk(this.to_type); 
            ANNE.A.ezSpan(el_parent, "", "disambig-mmw80-lbl", "<b>TO TYPE</b>");
            ANNE.A.ezEl(el_parent, "div", "disambig-neuron", to_type_text);
        }

        if (this.pObj.misc.to_s!=undefined && this.pObj.misc.to_s!=null) {
            ANNE.A.show(this.to_section);
            this.to_s = MEMG.getNeuronByNid(this.pObj.misc.to_s);
            if (this.to_type==TO_TYPE_ANNE) {
                var toNOBJ = MEMG.getNeuronByNid(this.to_s);
                toNOBJ.disambigHTMLStr(this.to_section, true, true, "TO", "disambig-mmw80-lbl");
            }
            else {
                this.to_section.innerHTML = this.to_s;
            }
        }
        this.doNextSection();
    }

    
    /**
     * 
     * @param {*} $e 
     */
    typeChanged=async($e)=>{
        console.log("type changed");
        this.type = this.el_dd_rne_type.value;
        if (this.type!=null) {
            var el_parent = ANNE.A.emptyParent(this.el_dd_rne_type)
            var TOBJ = MEMG.getSysTypeObjByType(this.type);

            var classname = "";

            //fix these as needed.. they should be found, but if not, just snag em.
            if (TOBJ==null) {
                classname = "TYPE_"+ANNE.TALK.getTypeName(parseInt(this.type)); 
            }
            else classname = TOBJ.SYS_ALIAS;

            ANNE.A.ezSpan(el_parent, "", "disambig-mmw80-lbl", "TYPE");
            ANNE.A.ezEl(el_parent, "div", "disambig-neuron", classname);
            this.doNextSection();
        }
    }


    /**
     * 
     * @param {*} $e 
     */
    toTypeChanged=async($e)=>{
        console.log("to_type selected");
        this.to_type = this.el_dd_rne_to_type.value;
        if (this.to_type!=null) {
            var el_parent = ANNE.A.emptyParent(this.el_dd_rne_to_type)
            this.to_s=null;
            ANNE.A.empty(this.to_section);
            var TTOBJ = MEMG.getSysToTypeObjByType(this.to_type);
            var el_holder = ANNE.A.ezEl(el_parent, "div", "", "", "to_type_holder_"+this.ID);
            ANNE.A.ezSpan(el_holder, "", "disambig-mmw80-lbl", "TO TYPE");
            ANNE.A.ezEl(el_holder, "div", "disambig-neuron", TTOBJ.SYS_ALIAS);
            this.doNextSection();
        }
    }




    /**
     * Do the parts of the relon in order.
     * It is helpful to get people to understand what a relon is.
     */
    doNextSection=function() {
        ANNE.A.hide(this.el_ghost_btn);
        if (this.type==null) ANNE.A.show(this.type_section);
        else if (this.fromNOBJ==null && this.bDOING_TEMPLATE_PART==false)  this.doFromSection();
        else if (this.relnNOBJ==null) this.doRelnSection();
        else if (this.to_type==null)  ANNE.A.show(this.to_type_section);
        else if (this.to_s==null) {
            this.doToSection();
            if (this.to_type==TO_TYPE_ANNE) ANNE.A.setHTML(this.el_msg, "select the to neuron");
        }
        else {
            ANNE.A.setHTML(this.el_msg, "<span class='text-success-lbl'>relon is valid</span>");
            ANNE.A.show(this.el_ghost_btn);
        }
    }


    //anne_naked_neuron_search=async($searchVal, $bLOCALONLY=false, $ntypes=[NTYPE_INST, NTYPE_CLASS], $bDOAKAS=false)
    searchLocalAllCallback = async($val)=>{
        if ($val.length>0) {
            return await CHASE.anne_naked_neuron_search($val, true, [NTYPE_CLASS, NTYPE_INST]);
        }
        return [];
    }

    searchLocalClassOnlyCallback = async($val)=>{
        if ($val.length>0) {
            return await CHASE.anne_naked_neuron_search($val, true, [NTYPE_CLASS])
        }
        return [];
    }

    searchAnnodeAllCallback = async($e)=>{
        var val = $e.target.value;
        if (val.length>1) {
            return await CHASE.anne_naked_neuron_search(val, false, [NTYPE_CLASS, NTYPE_INST]);
        }
        return [];
    }

    searchAnnodeClassOnlyCallback = async($e)=>{
        var val = $e.target.value;
        if (val.length>1) {
            return await CHASE.anne_naked_neuron_search(val, false, [NTYPE_CLASS]);
        }
        return [];
    }


    /**
     * Open ended from neuron selection.
     */
    doFromSection = function() {
        ANNE.A.empty(this.from_section);
        this.from_section_r1 = document.createElement("div");
        this.from_section_r1.classList = "simple-row";
        this.from_section.appendChild(this.from_section_r1);

        ANNE.A.ezSpan(this.from_section_r1, "", "disambig-mmw80-lbl", "FROM");

        var el_col1 = document.createElement("div");
        el_col1.classList = "simple-col";
        this.from_section_r1.append(el_col1);

        var el_sif_input = document.createElement("input");
        el_sif_input.id = "sif_input_"+this.ID;
        el_sif_input.setAttribute("size", 40);
        el_col1.appendChild(el_sif_input);
        ANNE.A.makeANNE_SIF("sif_input_"+this.ID, this.searchLocalAllCallback, this.searchAnnodeAllCallback, this.selected_from_cb, [], 2, false);

        ANNE.A.show(this.from_section);
    }


    /**
     * 
     * @param {*} $temp_nid 
     */
    selected_from_cb = async($temp_nid)=>{
        if ($temp_nid==-1) {
            ANNE.A.setHTML(this.el_msg, "invalid from neuron");
            return;
        }
        this.fromNOBJ = MEMG.getNeuronByTempNid($temp_nid);
        if (this.fromNOBJ==undefined || this.fromNOBJ==null) {
            ANNE.A.setHTML(this.el_msg, "invalid from neuron");
            return;
        }

        ANNE.A.emptySelf(this.from_section_r1);
        this.fromNOBJ.disambigHTMLStr(this.from_section_r1, true, true, "FROM", "disambig-mmw80-lbl");
        ANNE.A.makeQuickDeleteBtn(this.from_section_r1, e=>this.doFromSection());

         //add a delete button next to disambig with callback to remake the dd.

        this.doNextSection();
    }


    doRelnSection = function() {
        ANNE.A.empty(this.reln_section);
        this.reln_section_r1 = document.createElement("div");
        this.reln_section_r1.classList = "simple-row";
        this.reln_section.appendChild(this.reln_section_r1);

        ANNE.A.ezSpan(this.reln_section_r1, "", "disambig-mmw80-lbl", "RELN");

        var el_col1 = document.createElement("div");
        el_col1.classList = "simple-col";
        this.reln_section_r1.append(el_col1);

        var el_sif_input = document.createElement("input");
        el_sif_input.id = "sif_reln_input_"+this.ID;
        el_sif_input.setAttribute("size", 60);
        el_sif_input.setAttribute("placeholder", "select the RELN");
        el_col1.appendChild(el_sif_input);
        ANNE.A.makeANNE_SIF("sif_reln_input_"+this.ID, this.searchLocalClassOnlyCallback, this.searchAnnodeClassOnlyCallback, this.selected_reln_cb, [], 2, false);
        ANNE.A.show(this.reln_section);
    }


    doRelnReset = async($e)=>{
        ANNE.A.empty("to_type_holder_"+this.ID);
        this.doRelnSection();
    }


    /**
     * 
     * @param {*} $temp_nid 
     */
    selected_reln_cb = async($temp_nid)=>{
        if ($temp_nid==-1) {
            ANNE.A.setHTML(this.el_msg, "");
            return;
        }
        this.relnNOBJ = MEMG.getNeuronByTempNid($temp_nid);
        if (this.relnNOBJ==undefined || this.relnNOBJ==null) {
            ANNE.A.setHTML(this.el_msg, "");
            return;
        }

        ANNE.A.emptySelf(this.reln_section_r1); 
        this.relnNOBJ.disambigHTMLStr(this.reln_section_r1, true, true, "RELN", "disambig-mmw80-lbl");
        ANNE.A.makeQuickDeleteBtn(this.reln_section_r1, e=>this.doRelnReset(e));

        //add a delete button next to disambig with callback to remake the dd.

        //terminating types point to a TO NEURON in their param of the terminating type!
        //the TO_TYPE of the param relon WILL ALWAYS BE STORED AS A TO_TYPE_ANNE
        //and it will point to the TO_TYPE the relon will be making!
        var TTOBJ = MEMG.getTerminatingType(this.relnNOBJ);
        if (TTOBJ!=null) {
            console.log(TTOBJ);
            ANNE.A.show(this.el_dd_rne_to_type);
            this.to_type = TTOBJ.SYS_ENUM_VAL;
            ANNE.A.hide(this.el_dd_rne_to_type);
            var el_parent = this.el_dd_rne_to_type.parentNode;
            var el_holder = ANNE.A.ezEl(el_parent, "div", "", "", "to_type_holder_"+this.ID);

            ANNE.A.ezSpan(el_holder, "", "disambig-mmw80-lbl", "TO TYPE");
            ANNE.A.ezEl(el_holder, "div", "disambig-neuron", TTOBJ.SYS_ALIAS);
            ANNE.A.show(el_holder);

            //if this is a TYPE_PARAM, we already know the to.
            if (this.type==TYPE_PARAM) {
                this.to_s = TTOBJ.nid;
                //var aParts = TTOBJ.text.split("_");
                ANNE.A.show(this.to_section);
                TTOBJ.disambigHTMLStr(this.to_section, true, true, "TO", "disambig-mmw80-lbl");
            }
        }

        //investigate if this is classes only, and we have classes.
        //ECS._classes_only
        else {
            if (this.relnNOBJ._classes_only==true) {
                console.log("classes only for this reln");
                
                //we aren't making params to encrypted stuff ...
                //and this is not a terminating type..
                //safe (in majority of cases) here to presume TO_TYPE_ANNE
                if (this.type==TYPE_PARAM){
                    this.to_type = TO_TYPE_ANNE;
                    ANNE.A.hide(this.el_dd_rne_to_type);
                    var el_parent = this.el_dd_rne_to_type.parentNode;
                    var el_holder = ANNE.A.ezEl(el_parent, "div", "", "", "to_type_holder_"+this.ID);
                    ANNE.A.ezSpan(el_holder, "", "disambig-mmw80-lbl", "TO TYPE");
                    ANNE.A.ezEl(el_holder, "div", "disambig-neuron", "TO_TYPE_ANNE");
                    ANNE.A.show(el_holder);
                }
            }
        }
        ANNE.A.setHTML(this.el_msg, "");
        this.doNextSection();
    }


    _toCancel = async($ge)=> {
        await PAGES.closeInjectedDetails($ge);
        await this.smartScroll();
    }
    _toSuccess  = async($ge, $to_s, $new_relon=null)=> { 
        await PAGES.closeInjectedDetails($ge);

        this.to_section.innerHTML = "";
        ANNE.A.empty(this.to_section);
        ANNE.A.show(this.to_section);
            
        this.to_s = $to_s;
        if (this.to_type==TO_TYPE_ANNE) {
            var toNOBJ = MEMG.getNeuronByNid(this.to_s);
            toNOBJ.disambigHTMLStr(this.to_section, true, true, "TO", "disambig-mmw80-lbl");    
        }
        else {
            this.to_section.innerHTML = this.to_s;
        }

        ANNE.A.empty(this.el_msg);

        //could disambig the entire relon here in the el msg?
        var to = this.to_s;
        var to_type_override = this.to_type;
        if (this.type==TYPE_PARAM) to_type_override = TO_TYPE_ANNE;
        if (to_type_override==TO_TYPE_ANNE) to = MEMG.getNeuronByNid(this.to_s).bestNameHTML();

        this.el_msg.innerHTML = ANNE.TALK.quickRelonLinePrint(parseInt(this.type), this.fromNOBJ, this.relnNOBJ, parseInt(to_type_override), to);

        ANNE.A.show(this.el_ghost_btn);
        
        await this.smartScroll();
    }
        

    smartScroll = async()=>{
        if (this.misc && this.misc.parent_INST!=null) ANNE.A.smartScroll("scrollable_"+this.misc.parent_INST.ID);
    }

    
    doToSection = async($prompt="select the to value")=> {
        var pObj = new page_params(this._toSuccess, this._toCancel, null, null);
        pObj.injection_div = this.to_section;
        var misc = {};
        if (this.fromNOBJ!=null) misc.from_nid = this.fromNOBJ.nid;
        else misc.from_nid=null;
        
        misc.reln_nid = this.relnNOBJ.nid;
        misc.prompt=$prompt;
        misc.guitracker= null;
        misc.type = null;
        misc.param_txid = null;
        misc.ghost = true;          //always work with ghost data in forms.
        pObj.misc = misc;
        misc.parent_INST = this;

        var page = "";

        var TTOBJ = MEMG.getSysToTypeObjByType(this.to_type);
        if (TTOBJ!=null) {
            var PGNAME = "TT_"+TTOBJ.SYS_ALIAS.replace("TO_TYPE_", "");
            if (PGNAME=="TT_DATE") page = "selector_date";
            else if (PGNAME=="TT_ANNE") {
                if (this.relnNOBJ.nid==MEM.anne_id.temp_nid) {
                    page = "hasfull";
                    misc.classRestrictNid = MEM.ec_thing.nid;
                }
            }
            else if (this.relnNOBJ.nid==MEM.e_anne_id.temp_nid || PGNAME=="TT_ENCR_ANNE") page = "hasfull_encr";
            else page = PGNAME;
        }
    
        if (page=="") {
            if (this.relnNOBJ.nid==MEM.ec_action.nid || this.relnNOBJ.nid==MEM.role_action.nid) page = "selector_action";
            else if (this.relnNOBJ.is(MEM.date_gregorian)==true || this.relnNOBJ.nid==MEM.role_when.nid) page = "selector_date";
            else if (this.relnNOBJ.nid==MEM.location.nid || this.relnNOBJ.nid==MEM.role_where.nid) page = "selector_location";
            else if (this.relnNOBJ.nid==MEM.person.nid) {
                page = "selector_person";
            }
            else {
                misc.classRestrictNid = MEM.ec_thing.nid;
                page = "hasfull";
            }
        }

        //misc.parent_INST
        misc.page = page;
        console.log("%c pagname %c "+page, TALK.bgblack, TALK.bggreen);

        //await PAGES.openPart("relon_naked_entry", pObj);
        await PAGES.openPartWithLastPGUI(page, pObj);

        ANNE.A.show(this.to_section);
    }
    

    /**
     * Make ghost relon OR just return the pattern obj we wanted to build.
     * @param {*} $e 
     * @returns 
     */
    makeGhostRelon = async($e)=>{
        var to_type_override = this.to_type;
        if (this.type==TYPE_PARAM) to_type_override = TO_TYPE_ANNE;
        
        //ie, re-route back to lukat (primary use of this template feature)
        if (this.bDOING_TEMPLATE_PART==true) {
            if (this.success_callback!=null) {
                return this.success_callback(this.type, this.relnNOBJ, this.to_type, this.to_s);
            }
        }
        var ghostRelon = await GHOSTDATA.makeGhostRelon(this.type, this.fromNOBJ, this.relnNOBJ.nid, to_type_override, this.to_s);
        var toNOBJ = MEMG.getNeuronByNid(this.to_s);
        if (this.success_callback!=null) {
            //set gui_relon_refresh function if u want a specific on-screen relon/refresh/placement.
            //otherwise, best-attempt guess is used.
            this.success_callback(this.relnNOBJ, toNOBJ, {pgui:this.pgui, pObj:this.pObj, relon:ghostRelon});
        }
    }
}