var PAGES = {};
PAGES.el_home_view = null;

PAGES.bINIT = false;
PAGES._pages = [];
PAGES.bLOCKED=false;
PAGES.last_home_pgui = null;
PAGES._last_inject_pgui = null;
PAGES._lastPgui = null;

//ported from NF (used in close but not yet actually used again in opens)
PAGES._pguis = [];
PAGES._WEHAVEANACTIVEMODAL = false;
PAGES.standardPguisQ = [];
PAGES.history = [];
PAGES.bSENDERON=false;
PAGES._targetPage = 0;


/**
 * @author {Mr.Scatman}
 */
PAGES.init=function() {
    PAGES.bINIT=true;
    PAGES.el_home_view = ANNE.A.__getEl("threejs_blockers");
    PAGES.el_site = ANNE.A.__getEl("anne_site");

    PAGES.add_page_template({
        display:"relon_view", 
        divid:"relon_view", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_STANDARD, 
        spacevar:"relon_view", 
        multiples:true,
        content:"explorer_app/relon_view.html",
        spacevar:"relon_view",
        autoCloseHangers:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("relon_view"+$p1).substring(0,8);
        },
    });


    PAGES.add_page_template({
        display:"dossier", 
        divid:"dossier", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_STANDARD, 
        spacevar:"dossier", 
        multiples:true,
        autoCloseHangers:true,
        content:"explorer_app/dossier_view.html",
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("dv"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({
        display:"send_funds", 
        divid:"send_funds", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_STANDARD, 
        spacevar:"send_funds", 
        content:"explorer_app/send_funds.html",
    });

    PAGES.add_page_template({  
        display:"streampay", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"streampay", 
        autoCloseHangers:true,
        content:"explorer_app/maker_streampay.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("sp"+$p1).substring(0,8);
        },
    });

    
    PAGES.add_page_template({
        display:"ANNET", 
        divid:"ANNET", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_STANDARD, 
        multiples:true,
        cheapEvents:["RESIZE_WINDOW"],
        autoCloseHangers:true,
        content:"annet.html",
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("ANNET"+$p1).substring(0,8);
        },
    });


    PAGES.add_page_template({
        display:"receive_funds", 
        divid:"receive_funds", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_STANDARD, 
        spacevar:"receive_funds", 
        content:"explorer_app/receive_funds.html",
    });

    PAGES.add_page_template({
        display:"restore_backup", 
        divid:"restore_backup", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_STANDARD, 
        spacevar:"restore_backup", 
        content:"explorer_app/restore_backup.html",
    });

    PAGES.add_page_template({
        display:"unlock", 
        divid:"unlock", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_STANDARD, 
        spacevar:"UNLOCK", 
        content:"explorer_app/unlock.html"
    });

    //basic login page..
    PAGES.add_page_template({
        display:"login", 
        divid:"login", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"LOGINBASIC", 
        content:"explorer_app/login.html"
    });

    //destroy the entire wallet
    PAGES.add_page_template({
        display:"destroy_wallet", 
        divid:"destroy_wallet", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        content:"explorer_app/destroy_wallet.html"
    });

    //destroy an account
    PAGES.add_page_template({
        display:"destroy_account", 
        divid:"destroy_account", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_STANDARD, 
        content:"explorer_app/destroy_account.html"
    });

    PAGES.add_page_template({
        display:"anneid", 
        divid:"anneid", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"anneid", 
        content:"explorer_app/anneid.html"
    });
    PAGES.add_page_template({
        display:"accounts", 
        divid:"accounts", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"accounts", 
        content:"explorer_app/accounts.html"
    });

    PAGES.add_page_template({
        display:"awareness", 
        divid:"awareness", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"awareness", 
        content:"awareness_details.html"
    });

    PAGES.add_page_template({
        display:"lukat_search", 
        divid:"lukat_search", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"lukat_search", 
        content:"explorer_app/lukat_search.html"
    });

    PAGES.add_page_template({
        display:"anne_vote", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        spacevar:"anne_vote", 
        divid:"anne_vote",
        content:"explorer_app/anjucator_vote.html",
        instantiate:true,
        multiples:true,
        get_gui_id_callback:function ($p1) {
            return ANNE.other.sha256("anne_vote"+$p1).substring(0,8);   
        },
    });

    PAGES.add_page_template({
        display:"achat", 
        divid:"achat", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"achat", 
        content:"explorer_app/achat.html"
    });

    PAGES.add_page_template({
        display:"ghosts", 
        divid:"ghosts", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"GHOSTDATA", 
        content:"explorer_app/ghosts.html"
    });

    PAGES.add_page_template({
        display:"andy", 
        divid:"andy", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"", 
        instantiate:false,
        multiples:false,
        content:"explorer_app/andy.html"
    });


    PAGES.add_page_template({
        display:"hanai", 
        divid:"hanai", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"hanai", 
        content:"explorer_app/hanai.html"
    });

    PAGES.add_page_template({
        display:"resources", 
        divid:"resources", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"resources", 
        content:"resources.html"
    });

    PAGES.add_page_template({
        display:"annode", 
        divid:"annode", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"ANNODE", 
        content:"explorer_app/annode.html"
    });
        
    PAGES.add_page_template({  
        display:"Local notifications", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_MODAL,
        spacevar:"LNOTS", 
        divid:"lnots", 
        content:"explorer_app/lnots.html"
    });

    PAGES.add_page_template({  
        display:"TX Sender", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_MODAL,
        spacevar:"SENDER", 
        divid:"sender", 
        content:"explorer_app/sender.html"
    });

    //injected into maker: service_keyword 
    PAGES.add_page_template({  
        display:"symbol", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        spacevar:"symbol", 
        divid:"symbol", 
        autoCloseHangers:true,
        content:"explorer_app/maker_symbol.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("symb"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"date", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        spacevar:"date", 
        divid:"date", 
        autoCloseHangers:true,
        content:"explorer_app/maker_date.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("date"+$p1).substring(0,8);
        },
    });

     //injected into maker: service_keyword 
     PAGES.add_page_template({  
        display:"allmystuff", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        spacevar:"allmystuff", 
        divid:"allmystuff", 
        autoCloseHangers:true,
        content:"explorer_app/maker_all.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("all"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"actionverb", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"actionverb", 
        autoCloseHangers:true,
        content:"explorer_app/maker_actionverb.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("av"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"generalprop", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"generalprop", 
        autoCloseHangers:true,
        content:"explorer_app/maker_generalprop.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("av"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"anndle", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"anndle", 
        autoCloseHangers:true,
        content:"explorer_app/maker_anndle.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("av"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"company", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"company", 
        autoCloseHangers:true,
        content:"explorer_app/maker_company.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("comp"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"bounty", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"bounty", 
        autoCloseHangers:true,
        content:"explorer_app/maker_bounty.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("bty"+$p1).substring(0,8);
        },
    });


    PAGES.add_page_template({  
        display:"selector_date", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"selector_date", 
        autoCloseHangers:true,
        content:"explorer_app/selectors/selector_date.html",
        injection_div:"tbd",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("tbd"+$p1).substring(0,8);
        },
    });


    
    PAGES.add_page_template({  
        display:"identity_view", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT, 
        divid:"identity_view", 
        autoCloseHangers:true,
        content:"explorer_app/identity_view.html",
        injection_div:"tbd",
        instantiate:false,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("ev"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"selector_mediachoice", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT, 
        divid:"selector_mediachoice", 
        autoCloseHangers:true,
        content:"explorer_app/selectors/selector_mediachoice.html",
        injection_div:"tbd",
        instantiate:true,
        classRestrictNid:MEM.ec_thing.nid,
        searchFornewOK:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("mediachoice"+$p1).substring(0,8);
        },
    });
    

    PAGES.add_page_template({  
        display:"selector_action", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"selector_action", 
        autoCloseHangers:true,
        content:"explorer_app/selectors/selector_action_vb.html",
        injection_div:"tbd",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("sav"+$p1).substring(0,8);
        },
    });
    PAGES.add_page_template({  
        display:"selector_location", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT, 
        divid:"selector_location", 
        autoCloseHangers:true,
        content:"explorer_app/selectors/ss_selector_location.html",
        injection_div:"tbd",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("loc"+$p1).substring(0,8);
        },
    });
    PAGES.add_page_template({  
        display:"selector_person", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"selector_person", 
        autoCloseHangers:true,
        content:"explorer_app/selectors/ss_selector_person.html",
        injection_div:"tbd",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("per"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"selector_class_person", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"selector_class_person", 
        autoCloseHangers:true,
        content:"explorer_app/selectors/ss_selector_class_person.html",
        injection_div:"tbd",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("per"+$p1).substring(0,8);
        },
    });
    
    PAGES.add_page_template({  
        display:"selector_thing", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"selector_thing", 
        autoCloseHangers:true,
        content:"explorer_app/selectors/ss_selector_thing.html",
        injection_div:"tbd",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("thing"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({
        display:"hasfull", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"hasfull",
        content:"explorer_app/selectors/ss_selector_hasfull.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("hasfull"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"hasfull_encr", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"hasfull_encr",
        content:"explorer_app/selectors/ss_selector_hasfull.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("hasfull_encr"+$fromPlusReln).substring(0,8);   
        },
    });
    //TT_STRING for any to value that has a parent of String.
    PAGES.add_page_template({
        display:"TT_STRING", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_STRING",
        content:"explorer_app/selectors/selector_string.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_STRING"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_STRING", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_ENCR_STRING",
        content:"explorer_app/selectors/selector_string.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_STRING"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_URL", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_URL",
        content:"explorer_app/selectors/selector_url.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_URL"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_URL", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_ENCR_URL",
        content:"explorer_app/selectors/selector_url.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_URL"+$fromPlusReln).substring(0,8);   
        },
    });

    PAGES.add_page_template({
        display:"TT_IPV4", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_IPV4",
        content:"explorer_app/selectors/selector_ipv4.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_IPV4"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_IPV4", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_ENCR_IPV4",
        content:"explorer_app/selectors/selector_ipv4.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_IPV4"+$fromPlusReln).substring(0,8);   
        },
    });

    PAGES.add_page_template({
        display:"TT_IPV6", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_IPV6",
        content:"explorer_app/selectors/selector_ipv6.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_IPV6"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_IPV6", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_ENCR_IPV6",
        content:"explorer_app/selectors/selector_ipv6.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_IPV6"+$fromPlusReln).substring(0,8);   
        },
    });

    PAGES.add_page_template({
        display:"TT_DATE", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_DATE",
        content:"explorer_app/selectors/selector_date_string.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_DATE"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_DATE", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD, 
        divid:"TT_ENCR_DATE",
        content:"explorer_app/selectors/selector_date_string.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_DATE"+$fromPlusReln).substring(0,8);   
        },
    });

    //TT_BLOB for any to value that has a parent of String.
    PAGES.add_page_template({
        display:"TT_BLOB", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_BLOB",
        content:"explorer_app/selectors/selector_blob.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_BLOB"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_BLOB", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD, 
        divid:"TT_ENCR_BLOB",
        content:"explorer_app/selectors/selector_blob.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_BLOB"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_NUMBER", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_NUMBER",
        content:"explorer_app/selectors/selector_number.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_NUMBER"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_NUMBER", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_ENCR_NUMBER",
        content:"explorer_app/selectors/selector_number.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_NUMBER"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_TXID", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_TXID",
        content:"explorer_app/selectors/selector_txid.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_TXID"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_TXID", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_ENCR_TXID",
        content:"explorer_app/selectors/selector_txid.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_TXID"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_BOOLEAN", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_BOOLEAN",
        content:"explorer_app/selectors/selector_boolean.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        encrypted:false,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_BOOLEAN"+$fromPlusReln).substring(0,8);   
        },
    });
    PAGES.add_page_template({
        display:"TT_ENCR_BOOLEAN", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_STANDARD,
        divid:"TT_ENCR_BOOLEAN",
        content:"explorer_app/selectors/selector_boolean.html",
        injection_div:"tbd",
        autoCloseHangers:true,
        encrypted:true,
        get_gui_id_callback:function ($fromPlusReln) {
            return ANNE.other.sha256("TT_ENCR_BOOLEAN"+$fromPlusReln).substring(0,8);   
        },
    });

    PAGES.add_page_template({
        display:"relon_naked_entry", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"relon_naked_entry",
        content:"explorer_app/relon_naked_entry.html",
        injection_div:"tbd",
        instantiate:true,
        autoCloseHangers:true,
        get_gui_id_callback:function ($x) {
            return ANNE.other.sha256("NRE"+$x).substring(0,8);   
        },
    });

    

    PAGES.add_page_template({  
        display:"imgneuron", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"imgneuron", 
        autoCloseHangers:true,
        content:"explorer_app/maker_imgneuron.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("imgn"+$p1).substring(0,8);
        },
    });
    
    PAGES.add_page_template({  
        display:"mediapicker", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT, 
        divid:"mediapicker", 
        autoCloseHangers:true,
        content:"explorer_app/selector_mediapicker.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("imgn"+$p1).substring(0,8);
        },
    });
    

    PAGES.add_page_template({  
        display:"location", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"location", 
        autoCloseHangers:true,
        content:"explorer_app/maker_location.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("loc"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"location_historic_site", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"location_historic_site", 
        autoCloseHangers:true,
        content:"explorer_app/maker_location.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("loc"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"integer", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"integer", 
        autoCloseHangers:true,
        content:"explorer_app/maker_integer.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("int"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"asdf", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT, 
        divid:"asdf", 
        autoCloseHangers:true,
        content:"explorer_app/maker_asdf.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("asdf"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"person", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"person", 
        autoCloseHangers:true,
        content:"explorer_app/maker_person.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("per"+$p1).substring(0,8);
        },
    });

    
    PAGES.add_page_template({  
        display:"actionevent", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"actionevent", 
        autoCloseHangers:true,
        content:"explorer_app/maker_actionevent.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("ev"+$p1).substring(0,8);
        },
    });

    PAGES.add_page_template({  
        display:"anorg", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"anorg", 
        autoCloseHangers:true,
        content:"explorer_app/maker_anorg.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("anorg"+$p1).substring(0,8);
        },
    });


    PAGES.add_page_template({  
        display:"pdn", 
        path_type:PATHTYPE_ANNE, 
        render_type:RENDERTYPE_INJECT,
        divid:"pdn", 
        autoCloseHangers:true,
        content:"explorer_app/maker_PDN.html",
        injection_div:"maker_inject",
        instantiate:true,
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("pdn"+$p1).substring(0,8);
        },
    });


    PAGES.add_page_template({
        display:"table", 
        divid:"RELONTBL", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_INJECT, 
        instantiate:true,
        content:"table_widget.html",
        injection_div:"tbd",
        autoCloseHangers:true,
        multiples:true, 
        get_gui_id_callback:function ($p1) {    //p1 here is the txid.
            return ANNE.other.sha256("RELONTBL"+$p1);
        }
    });

    PAGES.add_page_template({
        display:"lukat_results", 
        divid:"lukat_results", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_INJECT, 
        instantiate:true,
        content:"explorer_app/lukat_results.html",
        injection_div:"tbd",
        autoCloseHangers:true,
        multiples:true, 
        get_gui_id_callback:function ($p1) { 
            return ANNE.other.sha256("lr"+$p1).substring(0,6);
        }
    });

    PAGES.add_page_template({
        display:"wiki_results", 
        divid:"wiki_results", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_INJECT, 
        instantiate:true,
        content:"explorer_app/wiki_results.html",
        injection_div:"tbd",
        autoCloseHangers:true,
        multiples:true, 
        get_gui_id_callback:function ($p1) { 
            return ANNE.other.sha256("lr"+$p1).substring(0,6);
        }
    });


    //we inject this in any page we want roles to be settable.
    //this can be in any neuron but it most often in neurons which are
    //clumps and instantiate an ec_action.
    PAGES.add_page_template({
        display:"rolesetter", 
        divid:"rolesetter", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_INJECT, 
        instantiate:true,
        content:"rolesetter.html",
        injection_div:"tbd",
        autoCloseHangers:true,
        multiples:true, 
        get_gui_id_callback:function ($p1) { 
            return ANNE.other.sha256("rs"+$p1).substring(0,6);
        }
    });

    PAGES.add_page_template({
        display:"annkh", 
        divid:"annkh", 
        path_type:PATHTYPE_ANNE,
        render_type:RENDERTYPE_BASE, 
        spacevar:"annkh", 
        content:"explorer_app/annkh.html"
    });

}




/**
 * @author {Mr.Scatman}
 */
PAGES.add_page_template = function($obj) {
    var pgt = PAGES.get_page_template($obj.divid);
    if (pgt!=null) {
        console.log("A page is already registered with that divid");
        return pgt;
    }

    pgt = new page_template($obj);
    PAGES._pages.push(pgt);
    return pgt;
}


/**
 * @author {Mr.Scatman}
 */
PAGES.get_page_template = function ($divid) {
    var lower = $divid.toLowerCase();
    
    for (var p=0; p < PAGES._pages.length; p++) {
        if (PAGES._pages[p].divid.toLowerCase()==lower) return PAGES._pages[p];
    }
    return null;
}


/**
 */
PAGES.openPartWithLastPGUI=async($partPage, $pObj)=> {
    return await PAGES._lastPgui.loadPart($partPage, $pObj);
}

/**
 */
PAGES.openPart=async($page, $pObj)=>{
    var pgt = PAGES.get_page_template($page);
    if (pgt==undefined || pgt==null) {
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("(openPare) page:**"+$page+"** fix this, the ext should be easy");
        alert("(openPare) page:**"+$page+"** fix this, the ext should be easy");
        return;
    }

    ANNE.A.empty($pObj.injection_div);
    var pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
    var pgui = pguiObj.pgui;
       
    //page template passthroughs to the dynamic pObj
    if ($pObj!=null && $pObj.misc!=null) {
        if ($pObj.misc.classRestrictNid==undefined || $pObj.misc.classRestrictNid==null) {
            $pObj.misc.restricToNid = pgt.classRestrictNid;
        }
        else $pObj.misc.restricToNid = $pObj.misc.classRestrictNid;
        
        if ($pObj.misc.searchFornewOK==undefined || $pObj.misc.searchFornewOK==null) {
            $pObj.misc.searchFornewOK = pgt.searchFornewOK;
        }
    }

    //make sure we have a misc object our pgui object. 
    if (($pObj && ($pObj.misc==undefined || pgui.misc==null))
        || $pObj==null) pgui.misc = new Object();
    

    if ($page=="identity_view") {
        pgui = pguiObj.pgui;
    }
    
    else if ($page=="imgneuron") {
        pgui = pguiObj.pgui;
        pgui.bNEWONLY=true; //will invoke newModeOnly
        pgui.INST = new maker_imgneuron_gui(pgui, $pObj.miscObj);
    }

    //do we still use this????
    else if ($page=="RELONTBL") {
        alert("WE STILL USE RELONTBL!");
        pgui.INST = new relon_table(pgui);
        await pgui.INST.initASYNC(pgui);
    }
    
    else if ($page=="relon_naked_entry") {
        pgui.INST = new relon_naked_entry(pgui);
        await pgui.INST.init(pgui);
    }
    else if ($page=="lukat_results") {
        pgui.INST = new lukat_results(pgui);
    }
    else if ($page=="wiki_results") {
        pgui.INST = new wiki_results(pgui);
    }
    else if ($page=="rolesetter") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new service_ghost_clump(pgui);
        await pgui.INST.initASYNC(pgui);
    }

    else if ($page=="selector_date") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_date(pgui);
    }

    else if ($page=="selector_action") {

        var bONLYLOCAL=true;
        await ANNE.API.queryTosFromRelns([MEM.ec_action.nid], 0, null, bONLYLOCAL);

        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new ss_action_selector(pgui);
    }

    else if ($page=="selector_location") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        
        var from_nid = $pObj.misc.from_nid;
        var fNOBJ = MEMG.getNeuronByNid(from_nid);

        //if we have from context and that from context is also a location, use the location selector.
        if (MEMG.beIsA(fNOBJ, MEM.location.temp_nid)==true) pgui.INST = new ss_location_selector(pgui);

        //if the from context exists and is NOT location or there is no from context.
        else pgui.INST = new ss_location_naked_selector(pgui);  //no parent location context.

        await pgui.INST.initLocAsync();
    }

    else if ($page=="selector_person") {

        var bONLYLOCAL=true;
        await ANNE.API.queryTosFromRelns([MEM.person.nid], 0, null, bONLYLOCAL);

        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new ss_person_selector(pgui);
        await pgui.INST.initPerAsync();
    }

    //make sure to have full param relon for the relnNOBJ that is the "class"
    else if ($page=="selector_class_person") {
        var bONLYLOCAL=true;
        await ANNE.API.queryTosFromRelns([MEM.person.nid], 0, null, bONLYLOCAL);
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new ss_class_person_selector(pgui);
        await pgui.INST.initClassPerAsync();
    }

    else if ($page=="selector_thing") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new ss_thing_selector(pgui);
        await pgui.INST.initPerAsync();
    }

    else if ($page=="selector_mediachoice") {
        if ($pObj.misc==undefined || $pObj.misc==null) $pObj.misc = {};
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_mediachoice(pgui);
    }
        
    else if ($page=="selector_mediapicker") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_mediapicker(pgui);
    }

    else if ($page=="hasfull" || $page=="hasfull_encr") {

        if ($pObj!=null && $pObj.misc!=null && $pObj.misc.classRestricNid!=undefined) {
            var bONLYLOCAL=true;
            await ANNE.API.queryTosFromRelns([$pObj.misc.classRestricNid], 0, null, bONLYLOCAL);
        }
        
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new ss_selector_hasfull(pgui);
    }
    else if ($page=="TT_STRING" || $page=="TT_ENCR_STRING") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_string(pgui);
    }
    else if ($page=="TT_BLOB" || $page=="TT_ENCR_BLOB") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_blob(pgui);
    }

    //this is for date strings that are not neurons.
    //this is not a common use in ANNE anymore now that we have proper date neurons
    //As of now, this only use is in a PDN where the PDN maker wants to store a date string
    //We could have just used a TT_ENCR_STRING but this helps the end-user know to expect a date.
    //This can thus work with L2 apps that encrypt a date for some process (betting etc)
    else if ($page=="TT_DATE" || $page=="TT_ENCR_DATE") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_date_string(pgui);
    }
    else if ($page=="TT_BOOLEAN" || $page=="TT_ENCR_BOOLEAN") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_boolean(pgui);
    }
    else if ($page=="TT_TXID" || $page=="TT_ENCR_TXID") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_txid(pgui);
    }
    else if ($page=="TT_TIME" || $page=="TT_ENCR_TIME") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_time(pgui);
    }
    else if ($page=="TT_DATETIME" || $page=="TT_ENCR_DATETIME") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_datetime(pgui);
    }
    else if ($page=="TT_FILEHASH" || $page=="TT_ENCR_FILEHASH") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_filehash(pgui);
    }
    else if ($page=="TT_NUMBER" || $page=="TT_ENCR_NUMBER") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_number(pgui);
    }
    else if ($page=="TT_URL" || $page=="TT_ENCR_URL") {
        pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
        pgui = pguiObj.pgui;
        pgui.INST = new selector_url(pgui);
    }

    //else if ($page=="NF_TREEWIDGET") {
       // pguiObj = await PAGES.loadTemplate(pgt, $pObj.injection_div, pgt.content, $pObj);
       // pgui = pguiObj.pgui;
       // TREEWIDGET.init(pgui);
   // }


    else alert("part '"+$page+"' not handled!");

    //smart scroll passed in, call it.
    if ($pObj.misc!=undefined && $pObj.misc!=null 
            && $pObj.misc.smartScroll!=undefined 
            && typeof $pObj.misc.smartScroll  === "function") {
        $pObj.misc.smartScroll();
    }

    //focus on the inject.
    if ($pObj.misc!=undefined && $pObj.misc!=null 
        && $pObj.misc.smartDefocus!=undefined 
        && typeof $pObj.misc.smartDefocus  === "function") {
        await $pObj.misc.smartDefocus();
    }
    

    return pgui;
}


/**
 * @author {Mr.Scatman}
 */
PAGES.closeInjectPage = function($pgui) {
    PAGES.destroyInject($pgui); 
}


/**
 * Open ANNET.
 * @param {*} $temp_nid 
 */
PAGES.openANNET=async($temp_nid)=> {
    var nObj = MEMG.getNeuronByTempNid($temp_nid);
    ANNE.MEM_UDF.show3js(nObj);
}



/**
 */
PAGES.openNeuronDossierView = function($nid, $misc=null) {
    var nObj = MEMG.getNeuronByNid($nid);
    var paramsObj = new page_params(null, null, null, nObj.nid);
    if ($misc!=null) paramsObj.misc=$misc;
    else paramsObj.p5 = nObj.bestNameHTML();
    PAGES.openPage("dossier", paramsObj);
}


/**
 * Check for guid match for our inject pgui (one per top)
 * or in the child pguis (parts are assigned to parent pguis in the child array
 */
PAGES.getPguiByGuid = function ($guid) {
    if (PAGES._last_inject_pgui!=null) {
        if (PAGES._last_inject_pgui._guid==$guid) return PAGES._last_inject_pgui;
        var childPgui = PAGES._last_inject_pgui.getChildPguiByGuid($guid);
        if (childPgui!=null) return childPgui;
    }
    if (PAGES._lastPgui!=null) {
         if (PAGES._lastPgui._guid==$guid) return PAGES._lastPgui;
         var childPgui = PAGES._lastPgui.getChildPguiByGuid($guid);
         if (childPgui!=null) return childPgui;
    }
    alert("cant find that pgui");
    return null;
}


/**
 * @param {*} $nOBJ 
 * @returns 
 */
PAGES.loadDossierPreReqs = async($nOBJ)=> {
    var bGETALL = false;
    var types = [TYPE_SYS, TYPE_SYS_MSG, TYPE_BE, TYPE_PARAM, TYPE_HAS, TYPE_CLUMP, TYPE_ROLE, TYPE_BRAIN];
    if ($nOBJ.ntype==NTYPE_CLASS) {
        classNOBJ = $nOBJ;
        bGETALL = true;
    }
    else classNOBJ = MEMG.getNeuronByTempNid($nOBJ.bes[0]);
    ANNE.A.show("loading");

    if ($nOBJ.nid==MEM.ASDF.nid || $nOBJ.nid==MEM.ANNE_BLOCK_TRIGGER.nid) {
        if (types.indexOf(TYPE_BRAIN120)==-1) types.push(TYPE_BRAIN120);
        if (types.indexOf(TYPE_SYS_MSG)==-1) types.push(TYPE_SYS_MSG);
    }

    //TO DO OPTIMIZATION
    //WE DO NOT NEED A BEM TYPE SEARCH ON THE ANNODE (WITH TONS OF RETURN RELONS) for all class types.

    if ($nOBJ.ghost==false && $nOBJ.temp==false) {
        if ($nOBJ.nid==USER._userNObj.nid) types.push(TYPE_SYS_MSG); //we want these

        //for classes where we need ins, pop them here.
        if (classNOBJ!=null && classNOBJ.is(MEM.fund)==true) {
            types.push(TYPE_INTERNAL_PAY);
            await CHASE.queryForOutsAndIns_BEM($nOBJ, true, types);
        }

        //most dossier neurons we don't need to chase the ins.
        //we can accumulate them on-demand as they self-reference.
        else if(classNOBJ!=null) {

            //we want bounty ins to catch any claims.
            if (classNOBJ.is(MEM.bounty)==true) {
                await CHASE.queryForOutsAndIns($nOBJ, true, [0,1,2,3,5,6,7,8,9,10]);
            }

            //distro (which should show the vote, if it has been called)
            else if (classNOBJ.temp_nid==MEM.specific_d_vote_by_list.temp_nid) {
                await CHASE.queryForOutsAndIns($nOBJ, true, [0,1,2,3,5,6,7,8,9,10]);
            }

            //the vote neuron
            else if (classNOBJ.temp_nid==MEM.distro_vote.temp_nid) {
                await CHASE.queryForOutsAndIns($nOBJ, true, [0,1,2,3,5,6,7,8,9,10]);
            }

            //we need a queryForOuts_not_BEM (to supply only [4] and get all other outs])
            else if(bGETALL==true) {
                await CHASE.queryForOuts_BEM($nOBJ, true, [0,1,2,3,5,6,7,8,9,10]);
            }

            //person, corp, location etc (inst).. just get bem once if we haven't already this session.
            else {
                await CHASE.queryForOuts_BEM($nOBJ, true, types); 
            }
        }
    } 

    if (classNOBJ==null) {
        if ($nOBJ.ntype==NTYPE_CLASS) classNOBJ = $nOBJ;
        else classNOBJ = MEMG.getNeuronByTempNid($nOBJ.bes[0]);
    }
    
    //fix the neuron display (text)
    var els = document.querySelectorAll('.msg-neuron-link-needs-update[nid="'+$nOBJ.nid+'"]');
    for (var e=0; e < els.length; e++) {
        var element = els[e];
        element.classList.remove("msg-neuron-link-needs-update");
        var ico = EXT_BTNS.doBestIco($nOBJ, ico);
        element.innerHTML = ico+$nOBJ.bestNameHTML();
    }

    return classNOBJ;
}


/**
 * I forget stuff.  Need more aliases.
 * @param {*} $page 
 * @param {*} $pObj 
 * @param {*} $secondary 
 * @param {*} $third 
 * @param {*} $misc 
 * @returns 
 */
PAGES.launchPage = async($page, $pObj=null, $secondary=null, $third=null, $misc=null)=> {
    return await PAGES.openPage($page, $pObj, $secondary, $third, $misc);
}


/**
 * 
 * @param {*} $page 
 * @param {*} $pObj 
 * @param {*} $secondary 
 * @param {*} $third 
 * @param {*} $misc 
 * @param {*} $cb - callback
 * @returns 
 */
PAGES.openPage = async($page, $pObj=null, $secondary=null, $third=null, $misc=null, $cb=null)=> {
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true)console.log("%c openPage %c"+$page, TALK.bgblack, TALK.bggreen);
    if (PAGES.bINIT==false) PAGES.init();
    if (PAGES.bLOCKED==true && $page!="locked") {
        alert("pages is locked, sorry");
        return;
    }

    var pendCB = false;

    //once and for all fix this drama
    var fadeIN_menu = PAGES.fixVisiblity($page);
    
    PAGES.bSENDERON=false;
    
    ANNE.A.empty(PAGES.el_home_view);   //empty the home view.

    //cleanup last page ...
    if (PAGES._lastPgui!=null) {
        if (typeof PAGES._lastPgui.destroyAll==="function") {
            PAGES._lastPgui.destroyAll();
        }   
        PAGES._lastPgui==null;
    }

    var pgui = null;
    var pgt = PAGES.get_page_template($page);
    
    //we want to make sure the el_site el is showing.
    //this should block out any app/graphics of the explorer in the bg.
    ANNE.A.show(PAGES.el_site);

    if ($page=="sender") {      //the sender final disp (w/ cost)
        ANNE.A.show(PAGES.el_home_view);   
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        SENDER.init(PAGES._last_inject_pgui);
        PAGES.bSENDERON=true;
        return; //get out, no history for this.
    }

    else if ($page=="achat") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        await ANNE.ACHAT.init($misc);    //load up standard achat stuffs.
    }

    else if ($page=="ANNET" || $page=="annet") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        await ANNET.init(pgui.pgui);
    }
    

    //sendq opens the sender..
    else if ($page=="sendq") {  //the q w/ items 
        ANNE.A.show(PAGES.el_home_view);
        SENDQ.init(); 
        return;//get out, no history for this.
    }

    
    if (PAGES._lastPgui!=null && (PAGES._lastPgui.pObj.divid=="sender")) {
        ANNE.A.show(PAGES.el_home_view);  
    }


    else if ($page=="anne_vote") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        PAGES._lastPgui.INST = new anne_vote(PAGES._lastPgui);
        await PAGES._lastPgui.INST.initASYNC(PAGES._lastPgui);
    }

    //this could all be automated from on-ANNE data.
    else if ($page=="dossier") {    //instantiated class..
        var nOBJ = MEMG.getOrMakeIfNew($pObj.p1);
        ANNE.MEM_UDF.fireNeuron(nOBJ, 1.2);
        var classNOBJ = await PAGES.loadDossierPreReqs(nOBJ, true);
        var extraTypes = [];

        //if (classNOBJ!=null && classNOBJ.nid==MEM.streampay.nid) {
            //extraTypes.push(TYPE_INTERNAL_PAY);
            //extraTypes.push(TYPE_BROADCAST_PAY);
            //extraTypes.push(TYPE_BRAIN120);
            //extraTypes.push(TYPE_BRAIN121);
            //extraTypes.push(TYPE_SYS_MSG);

        if (nOBJ.ghost==false) {

            //get *ALL* outs now in the relons tbl outs.
            //we are not bogged down by payments or awareness anymore with those in their own area.
            await ANNE.API.getOuts(nOBJ.nid, false, []);
            await ANNE.API.getIns(nOBJ.nid);
        }
        
        //get all the goodies we need to display this thing.
        //for ins displays we will just let the user click things and browse around to get them.
        await ANNE.CHASE.oneGenQueryable(nOBJ, extraTypes);  //if we are missing classNOBJ, this will get it.
            
        //we must have a be-class to be able to view a neuron with dossier.
        if (classNOBJ==null) {
            if (nOBJ.bes.length) {
                classNOBJ = MEMG.getNeuronByTempNid(nOBJ.bes[0]);
                if (classNOBJ==null) {
                    alert("no known parent for "+nOBJ.nid+", can't display this neuron.");
                    return PAGES.historyGoBack(null);
                }

                //now we know the class, run this one more time.
                await PAGES.loadDossierPreReqs(nOBJ, false);
                if (classNOBJ.nid==MEM.streampay.nid) {
                    if (nOBJ.ghost==false) await ANNE.API.getIns(nOBJ.nid);
                }
                await ANNE.CHASE.oneGenQueryable(nOBJ, extraTypes);
            }
            else {
                alert("This "+nOBJ.nid+" has no BE CLASS.  Dead neuron or a yet to be registered identity");
                return PAGES.historyGoBack(null);
            }
        }

        ANNE.A.hide("loading");
        
        ANNE.MEM_UDF.fireNeuron(classNOBJ, .3);

        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        
        if (nOBJ.ntype==NTYPE_CLASS) {
            if (nOBJ.is(MEM.ec_action)==true ||
                nOBJ.is(MEM.ec_is)==true || 
                nOBJ.is(MEM.ec_posn)==true) {
                PAGES._lastPgui.INST = new dossier_verbish(PAGES._lastPgui, $secondary, $third, $misc);
            }
            else if ( nOBJ.is(MEM.idiom)==true) {
                PAGES._lastPgui.INST = new dossier_idiom(PAGES._lastPgui, $secondary, $third, $misc);
            }
            else PAGES._lastPgui.INST = new dossier_class(PAGES._lastPgui, $secondary, $third, $misc);
        }
        else if (classNOBJ.temp_nid==MEM.location.temp_nid) {
            PAGES._lastPgui.INST = new dossier_location(PAGES._lastPgui, $secondary, $third, $misc);
        }
        else if (classNOBJ.temp_nid==MEM.company.temp_nid) {
            PAGES._lastPgui.INST = new dossier_company(PAGES._lastPgui, $secondary, $third, $misc);
        }
        else if (classNOBJ.temp_nid==MEM.person.temp_nid) {
            PAGES._lastPgui.INST = new dossier_person(PAGES._lastPgui, $secondary, $third, $misc);
        }
        else if (MEM.isIdentity(classNOBJ)==true) {
            PAGES._lastPgui.INST = new dossier_identity(PAGES._lastPgui, $secondary, $third, $misc);
        }
        else if (classNOBJ.temp_nid==MEM.integer.temp_nid) {
            PAGES._lastPgui.INST = new dossier_integer(PAGES._lastPgui, $secondary, $third, $misc);
        }
        else if (classNOBJ.temp_nid==MEM.date_gregorian.temp_nid) {
            PAGES._lastPgui.INST = new dossier_date(PAGES._lastPgui, $secondary, $third, $misc);
        }
        else if (classNOBJ.temp_nid==MEM.ASDF.temp_nid) {
            PAGES._lastPgui.INST = new dossier_asdf(PAGES._lastPgui, $secondary, $third, $misc);
        }

        else if (classNOBJ.temp_nid==MEM.bounty.temp_nid) {
            PAGES._lastPgui.INST = new dossier_bounty(PAGES._lastPgui, $secondary, $third, $misc);
        }

        else if (MEM.isAnorg(classNOBJ.temp_nid)==true) {
            PAGES._lastPgui.INST = new dossier_anorg(PAGES._lastPgui, $secondary, $third, $misc);
        }

        else if (classNOBJ.temp_nid==MEM.anndle.temp_nid || classNOBJ.temp_nid==MEM.subanndle.temp_nid) {
            PAGES._lastPgui.INST = new dossier_anndle(PAGES._lastPgui, $secondary, $third, $misc);
        }

        else if (classNOBJ.temp_nid==MEM.neuronImg.temp_nid) {
            PAGES._lastPgui.INST = new dossier_image(PAGES._lastPgui, $secondary, $third, $misc);
        }

        //is a child of action, aka, an action verb.
        //will this ever get here or does VERBISH steal it all?
        else if (MEM.isECAction(nOBJ, false)==true || classNOBJ.nid==MEM.ec_posn.nid) {
            PAGES._lastPgui.INST = new dossier_event_inst(PAGES._lastPgui, $secondary, $third, $misc);
        }

        else if (nOBJ.bes[0]==MEM.PDN_PUBLIC_ACCESS.temp_nid 
                    || nOBJ.bes[0]==MEM.PDN_VIP.temp_nid
                    || nOBJ.bes[0]==MEM.PDN_BEARER_TOKEN.temp_nid) {
            PAGES._lastPgui.INST = new dossier_pdn(PAGES._lastPgui, $secondary, $third, $misc);
        }

        //aon
        //else if (classNOBJ.temp_nid==MEM.aon.temp_nid) {
           //PAGES._lastPgui.INST = new dossier_aon(PAGES._lastPgui, $secondary, $third, $misc);
        //}

        //a type of distribution request (not the vote neuron)
        else if (classNOBJ.temp_nid==MEM.specific_d_vote_by_list.temp_nid) {
            PAGES._lastPgui.INST = new dossier_distro(PAGES._lastPgui, $secondary, $third, $misc);
        }

        //actual vote neuron to distribute funds
        else if (classNOBJ.temp_nid==MEM.distro_vote.temp_nid) {
            PAGES._lastPgui.INST = new dossier_distro_vote(PAGES._lastPgui, $secondary, $third, $misc);
        }

        //streampay fund
        else if (classNOBJ.temp_nid==MEM.streampay.temp_nid) {
            //await ANNE.API.queryForOuts(nOBJ.nid, true, 17);
            PAGES._lastPgui.INST = new dossier_streampay(PAGES._lastPgui, $secondary, $third, $misc);
        }

        //general fund
        else if (classNOBJ.temp_nid==MEM.fund.temp_nid) {
            PAGES._lastPgui.INST = new dossier_fund(PAGES._lastPgui, $secondary, $third, $misc);
        }
        else {
            PAGES._lastPgui.INST = new dossier_general_inst(PAGES._lastPgui, $secondary, $third, $misc);
        }

        if (typeof PAGES._lastPgui.INST.initASYNC === "function") {
            await PAGES._lastPgui.INST.initASYNC(PAGES._lastPgui);
        }
    }

    else if ($page=="relon_view") {
        //console.log(pgt);
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        await MEM_UDF.getAnyRelChase(pgui.pgui.pObj.p1);
        PAGES._lastPgui.INST = new anne_relon_gui(PAGES._lastPgui);
        if (PAGES._lastPgui==null || PAGES._lastPgui.INST==null) {
            console.log("????????");
        }
        else if (PAGES._lastPgui.INST!=undefined && PAGES._lastPgui.INST!=null) PAGES._lastPgui.INST.init();
    }

    else if ($page=="receive_funds") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        ANNE.RECEIVE_FUNDS.init();
    }

    else if ($page=="send_funds") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        await ANNE.SEND_FUNDS.init($pObj);
    }

    else if ($page=="restore_backup") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        ANNE.ANNEID.BACKUP.init();
    }

    else if ($page=="destroy_account") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        ANNE.ANNEID.DESTROY_ACCOUNT.init();
    }

    else if ($page=="locked") {   
        pgt = PAGES.get_page_template("unlock");
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        ANNE.UNLOCK.init();  //object at bottom of anne.js
        PAGES.bLOCKED=true;
    }

    else if ($page=="annkh") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        await ANNKH.init($secondary, $third, $misc);
    }

    else if ($page=="login") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        LOGINBASIC.init(PAGES._lastPgui);
    }

    /** WILL NUKE EVERYTHIGN!! **/
    else if ($page=="destroy_wallet") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        DESTROY_WALLET.init();
    }

    else if ($page=="activate") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
    }

    else if ($page=="anneid") {
        //get new TXs here?
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        pendCB = true;
        await ANNE.ANNEID.initAsync($cb);
    }

    else if ($page=="accounts") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        PAGES._lastPgui.INST = new anne_accounts(PAGES._lastPgui);
        await PAGES._lastPgui.INST.init();
    }
    

    //TODO -- a deeper dive on the feelz/awarenesses for this thing.
    //sort/filter by anneid attributes...
    //feelz breakdown by religion / gender / location / marital status..  
    //or any custom demographic.
    else if ($page=="awareness") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
    }

    else if ($page=="annode") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
        await ANNE.ANNODE.initAsync();   
    }

    else if ($page=="bazaan") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        ANNE.UNIT_TESTS.init();
    }
        
    else if ($page=="lukat_search") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);    
        PAGES._lastPgui = pgui.pgui; 
        PAGES._lastPgui.INST = new lukat(PAGES._lastPgui);
        await PAGES._lastPgui.INST.init($misc);
    }

    else if ($page=="resources") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui; 
    }

    else if ($page=="hanai") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        ANNE.HANAI.initHanaiView();
    }

    else if ($page=="lnots") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        PAGES._lastPgui.INST = new anne_local_notifications(PAGES._lastPgui);
        await PAGES._lastPgui.INST.init();
    }

    else if ($page=="ghosts") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        PAGES._lastPgui = pgui.pgui;
        PAGES._lastPgui.INST = new anne_ghosts(PAGES._lastPgui);
        await PAGES._lastPgui.INST.init();
    }

    else if ($page=="andy") {
        pgui = await PAGES.loadTemplate(pgt, PAGES.el_home_view, pgt.content, $pObj);
        PAGES._lastPgui = pgui.pgui;
        PAGES._lastPgui = pgui.pgui;
        PAGES._lastPgui.INST = new anne_andy(PAGES._lastPgui);
        await PAGES._lastPgui.INST.init();
    }

    if ($page!="login" && $page!="locked") {
        PAGES.history.push({page:$page, pObj:$pObj, secondary:null, third:null, misc:null});
    }

    if (PAGES.history.length > 1) {
        ANNE.A.show("btn_back");
        //ANNE.A.addRemoveClass('btn_back', "visible", "invisible");
    }

    if (pendCB==false && $cb!=null) {
        if (fadeIN_menu==true) {
            ANNE.A.gs_alphaIn("leftMainBtnMenuXX");
        }
        $cb();
    }
    return;
}


/**
 * 
 * @returns 
 */
PAGES.getLastHistory=function() {
    if (PAGES.history.length==0) return "";
    return PAGES.history[ PAGES.history.length-1];
}


/**
 * 
 * @param {*} $nids 
 */
PAGES.removeHistory=function($nids) {
    if ($nids==undefined || $nids==null) {
        console.log("problem with removeHistory");
        return;
    }
    for (var p=0; p < PAGES.history.length; p++) {
        if (PAGES.history[p].pObj==null) continue;
        if (PAGES.history[p].pObj.p1==null) continue;
        if ($nids.indexOf(PAGES.history[p].pObj.p1)!=-1) {
            PAGES.history.splice(p,1);
            p--;
        }
    }
}


/**
 * for console debugging
 */
PAGES.printHistory=function() {
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==false) return;
    
    for (var h=PAGES.history.length-1; h>=0; h--) {
        console.log("history page:"+PAGES.history[h].page);
        if (PAGES.history[h].secondary!=null) console.log("secondary",+PAGES.history[h].secondary);
        if (PAGES.history[h].third!=null) console.log("third",+PAGES.history[h].third);
        if (PAGES.history[h].misc!=null) console.log("misc",+PAGES.history[h].misc);
    }
}


/**
 * Helps with back to get closer to where the user actually was.
 * See maker.
 * @author {Mr.Scatman}
 */
PAGES.updateSecondary = function($secondary) {
    if (PAGES.history.length) {
        PAGES.history[ PAGES.history.length-1].secondary = $secondary;
    }
}


PAGES.updateThird = function($data) {
    if (PAGES.history.length) {
        PAGES.history[ PAGES.history.length-1].third = $data;
    }
}

PAGES.updateLastHistoryMisc = function($misc) {
    if (PAGES.history.length) {
        PAGES.history[ PAGES.history.length-1].misc = $misc;
    }
}

PAGES.updateLastHistMiscProp = function($prop, $propVal){
    if (PAGES.history.length) {
        var histobj = PAGES.history[ PAGES.history.length-1];
        var miscObj = histobj.misc;
        if (miscObj==undefined) misc = {$prop:$propVal};
        else miscObj.misc[$prop] = $propVal;
    }
}
PAGES.updateLastHistMiscPropDelete = function($prop){
    if (PAGES.history.length) {
        var histobj = PAGES.history[ PAGES.history.length-1];
        var miscObj = histobj.misc;
        if (miscObj==undefined) return;
        if (miscObj[$prop]==undefined) return;
        delete miscObj[$prop];
    }
}

PAGES.wipeHistory = function() {
    console.log("(PAGES.wipeHistory) page history wiped")
    PAGES.history = [];
}


/**
 * User do update a history object.
 * Primary used for when a ghost is upgraded and it gets a real nid.
 * When the user goes back that old ghost neuron is dead and will not show.
 * We update the nid so it can go to the new neuron.
 * If there is another copy of this page in the history burried deep,
 * too bad!
 */
PAGES.updateLastHistoryPOBJ=function($page, $pObjProp, $val) {
    console.log("(updateLastHistoryPOBJ)", $page, $pObjProp, $val);
    for (var h=PAGES.history.length-1; h>=0; h--) {
        var hist = PAGES.history[h];
        if (hist.page==$page) {
            hist.pObj[$pObjProp]=$val;
            return;
        }
    }
    return;
}


PAGES.historyPopLast = function() {
    PAGES.history.pop();
    return;
}

/**
 * @author {Mr.Scatman}
 */
PAGES.historyDeleteLast = function($page) {
    for (var p=PAGES.history.length; p>=0; p--) {
        if (PAGES.history[p]==$page) {
            PAGES.history[p].splice(p,1);
            return;
        }
    }
}


/**
 * Set a target page to use in a callback.
 */
PAGES.setTargetPageByOffset = function($offset) {
    var targetPage = PAGES.history.length-($offset-1);
    PAGES._targetPage = Math.max(0, targetPage);
}

/**
 */
PAGES.setTargetToCurrent = function() {
    var targetPage = PAGES.history.length-1;
    PAGES._targetPage = Math.max(0, targetPage);
}

/**
 */
PAGES.currentPage = function() {
    return PAGES.history.length-1;
}
    

/**
 * Instead of trying to manuall update too many willy wonka divs or places hard to get at..
 * Just refresh the dag nab page.
 */
PAGES.refreshCurrent = function() {
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true)console.log("refresh current")
    var hist = PAGES.history.pop(); //the current page we are on NOW.
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true)console.log("popped off hist", hist);
    PAGES.openPage(hist.page, hist.pObj, hist.secondary, hist.third, hist.misc);
}


/**
 */
PAGES.goToManualTargetPage = async($tp)=> {
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true)console.log("$tp:"+$tp+" =="+PAGES._targetPage);
    var pg = PAGES.history[$tp];
    PAGES.history = PAGES.history.slice(0, $tp);
    PAGES.bSENDERON=false;
    PAGES._targetPage=0;
    await PAGES.historyGoBack(null);
}


/**
 * use this function as the callback function of the SENDQ
 */
PAGES.goToTargetPage = async($rez)=> {
    if ($rez==undefined) return;
    
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true)console.log("pages.goToTargetPage", $rez);
    var pg = PAGES.history[PAGES._targetPage];
    PAGES.history = PAGES.history.slice(0, PAGES._targetPage);
    PAGES.bSENDERON=false;
    PAGES._targetPage=0;
    await PAGES.historyGoBack(null);
}



/**
 * We are having visibility dramas.
 * @param {*} $page 
 */
PAGES.fixVisiblity=function($page) {

    //hide the left menu, show 3js.
    if ($page=="ANNET") {
        if (ANNE.ACE!=null) ANNE.ACE.refocus();
        ANNE.A.gs_alphaOut("leftMainBtnMenuXX");
        ANNE.MEM_UDF.show3js();
        return false;
    }

    //hide both the left menu and 3js.
    else if ($page=="locked" || $page=="login") {
        ANNE.A.gs_alphaOut("leftMainBtnMenuXX");
        ANNE.MEM_UDF.hide3js();
        return false;
    }

    //show the left menu, hide 3js
    else {
        ANNE.MEM_UDF.hide3js();
        return true;
    }
}


/**
 * @author {Mr.Scatman}
 */
PAGES.historyGoBack = async(e)=> {
    ANNE.A.empty(PAGES.el_home_view); //TEST THIS
    if (PAGES._lastPgui!=null) {
        if (typeof PAGES._lastPgui.destroyAll==="function") {
            PAGES._lastPgui.destroyAll();
        }   
        PAGES._lastPgui=null;
    }

    if (PAGES.history.length==0 || (PAGES.history.length==1 && PAGES.bSENDERON==false)) {
        ANNE.A.hide("btn_back");

        //in this app, if we have no history we go to ANNEID page.
        if (PAGES.history.length==0) await ANNE.PAGES.openPage("anneid");
        return false;
    }

    var hist = PAGES.history.pop(); //the current page we are on NOW.

    //from sender we do not store hist so we only need to pop once.
    //the previous page we want to reload.
    if (PAGES.bSENDERON==false) {
        if (hist.secondary==undefined || hist.secondary=="" || hist.secondary==null) {
            hist = PAGES.history.pop();
        }
        else hist.secondary = "";
    }
    
    PAGES.bSENDERON=false;
    await PAGES.openPage(hist.page, hist.pObj, hist.secondary, hist.third, hist.misc);
    ANNE.A.show(PAGES.el_home_view);   //empty the home view.
    
    if (PAGES.history.length<=1 && PAGES.bSENDERON==false) {
        ANNE.A.hide("btn_back");
    }

    
    return true;
}


/**
 * 
 * @returns 
 */
PAGES.refreshPage=async()=>{
    ANNE.A.empty(PAGES.el_home_view); //TEST THIS
    if (PAGES._lastPgui!=null) {
        if (typeof PAGES._lastPgui.destroyAll==="function") {
            PAGES._lastPgui.destroyAll();
        }   
        PAGES._lastPgui=null;
    }

    if (PAGES.history.length==0 || (PAGES.history.length==1 && PAGES.bSENDERON==false)) {
        ANNE.A.hide("btn_back");

        //in this app, if we have no history we go to ANNEID page.
        if (PAGES.history.length==0) await ANNE.PAGES.openPage("anneid");
        return false;
    }

    var hist = PAGES.history.pop(); //the current page we are on NOW.
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("popped off hist", hist);
    await PAGES.openPage(hist.page, hist.pObj, hist.secondary, hist.third, hist.misc);

    if (PAGES.history.length<=1 && PAGES.bSENDERON==false) {
        ANNE.A.hide("btn_back");
    }

    PAGES.bSENDERON=false;
    return true;
}


PAGES.historyGoBackBack = async(e)=> {
    if (PAGES.history.length==0 || (PAGES.history.length==1 && PAGES.bSENDERON==false)) {
        ANNE.A.hide("btn_back");
        return;
    }
    var hist = PAGES.history.pop();
    
    if (PAGES.history.length<=1 && PAGES.bSENDERON==false) {
        ANNE.A.hide("btn_back");
    }
    await PAGES.openPage(hist.page, hist.pObj, hist.secondary, hist.third, hist.misc);
    
    return;
}



/**
 * @author {Mr.Scatman}
 */
PAGES.launchRelon=async($txid, $known_andy=false, $returnPage="")=>{
    //console.log($txid);

    var params = new page_params(null, null, null, $txid, $known_andy);
    
    if ($returnPage!="") {
        if (params.misc==null) params.misc={};
        params.misc.return_page = $returnPage;
    }
    
    PAGES.openPage("relon_view", params);
}


PAGES.launchHrefNeuron=async($e)=>{
    $e.preventDefault();
    var target = $e.target;
    if (target==null) return;
    var nid = target.getAttribute("nid");
    if (nid==undefined || nid==null) return;
    var page = target.getAttribute("page");
    if(page==undefined || page==null) page="";
    PAGES.launchNeuron(nid);
}


/**
 * @param {*} $nid 
 * @param {*} $wikiObj 
 */
PAGES.launchDossManual = async($nid, $wikiObj)=>{
    var pObj = new page_params(null, null, null, $nid);
    pObj.misc = {wikiObj:$wikiObj};
    PAGES.openPage("dossier", pObj, null, null, pObj.misc);
}


/**
 * 
 * 
 * @author {Mr.Scatman}
 */
PAGES.launchNeuron=async($nid, $page="dossier", $e=null, $jsonparams=null)=>{
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("launchNeuron:"+$nid);
    if ($nid==undefined || $nid==null) {
        console.log("big trouble");
        if ($e!=null && $e.target!=undefined) {
            $nid = $e.target.getAttribute("nid");
            if ($nid==undefined || $nid!=null) return;
            else if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("(launchNeuron) fixed this with the nid attr");
        }
        else return;
    }

    var misc = null;

    //by using setAttribute we can store miscp1, miscp2, and miscp3 vals
    //we can extract those (they are the names of the attribute holding the val)
    //we can extract those then put them in the misc object for the page
    //if 1 isn't there we don't look for 2. 
    if ($e!=null) {
        var el = ANNE.A.getFirstParentOf($e.target, "btn-launch", true);
        if (el!=null) {
            misc = new Object();
            var pg = el.getAttribute("page");
            if (pg!=null) $page= pg;    //page override from btn attrs
            for (var m=1; m < 4; m++) {
                var miscp = el.getAttribute("miscp"+m);
                if (miscp!=null) {
                    miscpval = el.getAttribute(miscp);
                    misc[miscp]=miscpval;
                }
                break;
            }
        }
    }

    ANNE.A.playSound("beep");
    var pObj = new page_params(null, null, null, $nid);

    if ($jsonparams!=null) {
        var keys = Object.keys($jsonparams);
        for (var k=0; k < keys.length; k++) { pObj[ keys[k]] = $jsonparams[k];}
    }

    PAGES.openPage($page, pObj, null, null, misc);
}
 

/**
 * @author {Mr.Scatman}
 */
PAGES.loadTemplate=async($pgt, $inj_div, $url, $pObj=null, loadClass="load-wrapper")=> {
    if ($pgt==undefined || $pgt==null) {
       if (ANNE.SETTINGS.bCONSOLE_DEBUG==true)  console.log("pgt doesn't exists");
        return;
    }
    var pgui = $pgt.add_page_gui($pObj);
    pgui.bISOPEN=true; 
    $pgt.bISOPEN=true;

    await ANNE.A.load($inj_div, pgui.pgui, $url, loadClass);
    return pgui;
}



/**
 * @author {Mr.Scatman}
 */
PAGES.close = function($divid, $guid="", $closeCallbackOverride=null, $bNOCALLBACKS=false, $BASEBIPASS=false) {
    var ptemplate=PAGES.get_page_template($divid);
    if (ptemplate==null) {
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("that ('"+$divid+"') divid doesn't exist as a page");
        return;
    }
    if (ptemplate.bISOPEN==false) {
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("that page "+$divid+" isn't open");
        return;
    }

    var pgui = null;
    pgui = ptemplate.get_pgui_and_remove_from_tracker($guid);
    if (pgui==null) {
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("that page "+$divid+" pgui guid: "+$guid+" isn't open!");
    }

    //are we going to use modal mode anymore???
    if (pgui.loadedAsModal==true) {
        ANNE.A.empty(NF.modals_id, true);
        ANNE.A.hide(NF.modals_id+"_blocker");
        ANNE.A.removeClass('anne_site',"blur-it");
        PAGES._WEHAVEANACTIVEMODAL = null;
    }

    //if this was loaded as a part, we do nothing when it closes.
    //the owning page will handle the show/hide and cleanup.
    if (pgui.loadedAsPart==false && pgui.loadedAsModal==false) {
        if (ptemplate.render_type==RENDERTYPE_STANDARD) {
            PAGES.cleanupPQuiStandardQ(ptemplate);
        }
    }

    //if this was a parent pgui with open injected pages,
    //and parent was closed.. (with injected pages hanging open)...
    //we must clean up our messes in NF memory.
    //NOTE: we turn close callbacks off for this inception of closing
    //nested pages.
    if (pgui._pgui_children.length) {
        pgui.closeAllChildren();
    }

    //if we were a loaded injected page in another page...
    //and we closed the injected one.. let the parent know 
    //it lost a child.  ;(   (hehe)
    if (pgui._parent_pgui!=null) {
        pgui._parent_pgui.removeFromChildPguiTrackers(pgui);
    }

    //get rid of the injection_div stuffs
    if (ptemplate.injection_div!="") {
        if (pgui.injection_div!=undefined && pgui.injection_div!="") {
            ANNE.A.empty(pgui.injection_div, true);
        }
        else ANNE.A.empty(ptemplate.injection_div, true);
    }

    if ($bNOCALLBACKS==false) {
        if ($closeCallbackOverride!=null) $closeCallbackOverride();
        else if (ptemplate.callback_close!=undefined && typeof ptemplate.callback_close==="function") {
            $pgui.page.callback_close();
        }
    }
}


/**
 * @param {page_template} $ptemplate 
 * @author {Mr.Scatman}
 */
PAGES.cleanupPQuiStandardQ = function($ptemplate) {
    for (var q=0; q<PAGES.standardPguisQ.length;q++) {
        var pgui =PAGES.standardPguisQ[q];
        if (pgui.page.divid==$ptemplate.divid) {
            PAGES.standardPguisQ.splice(q, 1);
            if ($ptemplate.multiples==true) ANNE.A.removeSelf(pgui.page.divid+"_"+pgui.guid);
            else ANNE.A.removeSelf(pgui.page.divid);
            q=q-1;
            break;
        }
    }   
}

/**
 * Get the default page for a class.
 * ParamRelon and contextNOBJ optional to help in some cases differentiate the page handler.
 * 
 * @param {anne_neuron} $classNOBJ 
 * @param {Object} $paramRelon 
 * @param {ann_neuron} $contextNOBJ 
 * @returns {String}
 */
 PAGES.getDefaultSelectorPageForClass=function($classNOBJ, $paramRelon=null, $contextNOBJ=null) {
    if ($classNOBJ==null) {
        alert("$classNOBJ cannot be null.");
        return;
    }
    
    var TTOBJ = MEMG.getTerminatingType($classNOBJ);
    if (TTOBJ!=null) {
        var PGNAME = "TT_"+TTOBJ.SYS_ALIAS.replace("TO_TYPE_", "");
        if (PGNAME=="TT_DATE" && $paramRelon!=null && $paramRelon.to_type!=TO_TYPE_ENCR_DATE) {
            return "selector_date";
        }

        if (PGNAME=="TT_NUMBER" && $paramRelon!=null && $paramRelon.to_type!=TO_TYPE_ENCR_NUMBER) {
            return "TT_NUMBER";
        }
        
        if (PGNAME=="TT_ANNE") return "hasfull";

        if ($classNOBJ.nid==MEM.e_anne_id.temp_nid || PGNAME=="TT_ENCR_ANNE") {
            return "hasfull_encr";
        }
        return PGNAME;
    }


    if ($classNOBJ.nid==MEM.ec_action.nid || $classNOBJ.nid==MEM.role_action.nid) return "selector_action";
    else if ($classNOBJ.is(MEM.date_gregorian)==true || $classNOBJ.nid==MEM.role_when.nid) return "selector_date";
    else if ($classNOBJ.nid==MEM.location.nid || $classNOBJ.nid==MEM.role_where.nid) return "selector_location";
    else if ($classNOBJ.nid==MEM.person.nid) {
        if ($paramRelon!=null) {
            var relnNOBJ = ANNE.MEMG.getNeuronByTempNid($paramRelon.r);
            if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log(relnNOBJ);
            if (relnNOBJ.functional_childparent_reln!=undefined || relnNOBJ.functional_childparent_parent!=undefined) {
                if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("slector_class_person");
                return "selector_class_person";
            }
        }
        return "selector_person";
    }
    else if ($classNOBJ.nid==MEM.ec_thing.nid) {
        return "hasfull";        
    }
    else if ($classNOBJ.is(MEM.role_thing)==true) {
        if ($contextNOBJ!=null && $contextNOBJ.is(MEM.person)==true) {


            //if the relon is 
            //loadDefaultRelon(Consts.TYPE_BE, pvs.position, ECS.BE_CHILDREN_RELN, ECS.ec_is);
    		//loadDefaultRelon(Consts.TYPE_BE, pvs.position, ECS.BE_PARENT, ECS.ec_nonliving); 
            //this.functional_childparent_reln
            //this.functional_childparent_parent
            if ($paramRelon!=null) {
                var relnNOBJ = ANNE.MEMG.getNeuronByTempNid($paramRelon.r);
                if (relnNOBJ.functional_childparent_reln!=undefined || relnNOBJ.functional_childparent_parent!=undefined) {
                    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("slector_class_person");
                }
            }
            
            return "selector_person";
        
        
        }
        else return "hasfull";
    }
    else return "hasfull";
}


/**
 * Make an injector relon button.  (no type????)
 * @param {*} $INST 
 * @param {String} $txid 
 * @param {*} $el_id 
 * @param {*} $guitracker 
 * @param {*} $forTempNid 
 * @param {*} $scb 
 * @param {*} $ccb 
 * @returns 
 */
PAGES.make_injectAddRelonGui=function($INST, $txid, $el_id, $guitracker="", $forTempNid=-1, $scb=null, $ccb=null) {
    var btn = document.createElement("button");
    btn.setAttribute("id", $guitracker);
    btn.setAttribute("txid", $txid);
    btn.setAttribute("el", $el_id);
    btn.setAttribute("guitracker", $guitracker);
    btn.setAttribute("forTempNid", $forTempNid);
    btn.addEventListener("click", e=>ANNE.PAGES.injectAddRelonGui(
        btn, $INST, $txid, $el_id, $guitracker, $forTempNid, $scb, $ccb));
    return btn;
}



/** 
 * Inject relon gui, dynamic by type.
 * 
 * Intended with param relons to generate a button.
 * 
 * $txid is the relon pattern (param) we are going to make.
 * $el is the div we want to inject the dynamic form into. 
 * $guitracker is = relon.rid + "_" + $ID.  It identifies the row  so 
 * that we can alter it when the user does something in the queue.   
 * 
 * @author {Mr.Scatman}
 */
PAGES.injectAddRelonGui=async ($btn, $INST, $txid, $el, $guitracker="", $forTempNid=-1, $scb=null, $ccb=null) => {
    ANNE.A.empty($el);
    var paramRelon=MEMG.lookupRelonByTXID($txid);

    if (paramRelon!=null && ANNE.SETTINGS.debug()==true) ANNE.TALK.printRelon(paramRelon);

    var promptIt="";
    if (paramRelon!=null && paramRelon.prompt!=undefined) promptIt = paramRelon.prompt;
    else {
        var btnprompt = $btn.getAttribute("prompt");
        if (btnprompt!=undefined && btnprompt!=null) promptIt = btnprompt;
    }

    var helperMsg = $btn.getAttribute("helperMsg");
    if (helperMsg==undefined) helperMsg="";

    var type = TYPE_HAS;
    var relnNOBJ = null;
    if (paramRelon!=null) {
        
        //lolz :)
        if ($txid=="5548279511800517650" ||
            $txid=="17698417090656313660" ||
            $txid=="12890309293912315010") {
            if (paramRelon.to_s!=MEM.person.nid) {
                paramRelon.to_s = MEM.person.nid;  //fix until i fix inception.
                await ANNE.DB.___update(paramRelon);
                console.log("%c TEMP HACK PARAM RELON FIX for kinfolk pointing to person.", TALK.bgred);
            }
        }

        relnNOBJ = MEMG.getNeuronByNid(paramRelon.reln);
    }

    if (relnNOBJ==null) return;
    
    var relon_type=$btn.getAttribute("relon_type");
    if (relon_type!=undefined && relon_type!=null) type = relon_type;
    else if (relnNOBJ!=null && relnNOBJ.target_type!=undefined) {
        type = relnNOBJ.target_type;
    }
    else {
        //look again, it is too important.
    }

    //override fix for type_roles..
    //if we have a relnNOBJ that is a role..
    //and the definition forgot to specify dimension type.
    if (relnNOBJ.is(ANNE.MEM.role)==true) {
        type=TYPE_ROLE;
    }
    
    var restrictToNid=null;
    var for_nOBJ=null;
    if ($forTempNid!="") for_nOBJ = MEMG.getNeuronByTempNid($forTempNid);
    if (for_nOBJ==null) for_nOBJ = USER._userNObj;

    var toNOBJ = MEMG.getNeuronByNid(paramRelon.to_s);
    if (toNOBJ!=null) restrictToNid = toNOBJ.nid;


    //replace to toNOBJ with the override, if it isn't bad.
    var restrictToNidOverride = $btn.getAttribute("restrictToNid");
    if (restrictToNidOverride!=undefined && restrictToNidOverride!=null) {
        var testTONOBJ = MEMG.getNeuronByNid(restrictToNidOverride); //override to the TO so we get the right page.
        if (testTONOBJ!=null) {
            restrictToNid = restrictToNidOverride;
            toNOBJ = testTONOBJ;
        }
        else if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("BAD OVERRIDE DATA, skipping restrictToNid")
    }

    var pObj = new page_params($scb, $ccb, null, null);
    pObj.injection_div = $el;
    var misc = {};
    misc.from_nid = for_nOBJ.nid;
    misc.reln_nid = null;
    if (paramRelon!=null) misc.reln_nid = paramRelon.reln;
    misc.prompt=promptIt;
    misc.classRestrictNid = restrictToNid;
    misc.guitracker= $guitracker;
    misc.type = type;
    misc.helperMsg = helperMsg;
    misc.param_txid = null;
    if ($txid!=null) misc.param_txid = $txid;
    misc.ghost = true;          //always work with ghost data in forms.
    pObj.misc = misc;
    misc.parent_INST = $INST;
    if ($INST!=null) {
        if (typeof $INST.smartScroll==="function") misc.smartScroll = $INST.smartScroll;
        if (typeof $INST.smartDefocus==="function") misc.smartDefocus = $INST.smartDefocus;
    }


    var validate = $btn.getAttribute("validate");
    if (validate!=undefined) {
        if (validate=="future_block") {
            misc.validate_data_entry_cb = ANNE._validate_block_height_is_future;
        }
    }

    var default_value = null;
    if ($btn!=null) default_value = $btn.getAttribute("default-value");

    //we will prepop the typed in value to this value.
    //if it doesn't match something we have we want to create a new something.
    if (default_value!=undefined && default_value!=null) {
        misc.default_value = default_value;
        misc.searchFornewOK = true;
    }

    var instOnly = $btn.getAttribute("insts_only");
    if (instOnly!=null && instOnly=="1") misc.insts_only=true;
    else misc.insts_only=false;

    //used for basic vals, not searches.  A different type of default val than thte default-value attr.
    var default_val = $btn.getAttribute("default");
    if (default_val!=null) misc.default_basic_val = default_val;

    var dispAC = $btn.getAttribute("display_annecoin");
    if (dispAC!=undefined) misc.dispAC = true;

    var displayInID = $btn.getAttribute("displayin_id");
    if (displayInID!=undefined) misc.refresh_el = displayInID;
    
    //min_val and max_val when anne coin are always anne coin (not annies)
    var min_val = $btn.getAttribute("minimum");
    if (min_val!=null) misc.min_val = min_val;
    var max_val = $btn.getAttribute("maximum");
    if (max_val!=null) misc.max_val = max_val;

    var refresh_el = $btn.getAttribute("refresh_el");
    if (refresh_el!=null) misc.refresh_el = refresh_el;

    var manual_tnids = $btn.getAttribute("manual-tnids");
    if (ANNE.UTILS.isset(manual_tnids)==true) {
        var manual_tnids_arr = manual_tnids.split(",");
        for (var m=0; m <manual_tnids_arr.length; m++) {
            manual_tnids_arr[m] = parseInt(manual_tnids_arr[m]);
        }
        misc.manual_tnids_arr = manual_tnids_arr;
    }

    var col1 = $btn.getAttribute("col1");
    if(col1!=null) misc.col1 = col1;
    var col2 = $btn.getAttribute("col2");
    if(col2!=null) misc.col2 = col2;

    var annieshack = $btn.getAttribute("annieshack");
    if(annieshack!=null) misc.annieshack = annieshack;
    
    var nounit = $btn.getAttribute("nounit");
    if(nounit!=null) misc.nounit = nounit;
   
    //setting primary pic is a picker
    if (relnNOBJ!=null) {
        if (relnNOBJ.temp_nid==MEM.primaryNeuronImg.temp_nid) {
            var msg = "Type in and select an existing <em><b>"+name+"</b></em>&nbsp;img to be the &nbsp;<span class='text-success-lbl'>"+relnNOBJ.text+"</span>";
            misc.prompt = msg;
            misc.child_cdx = [{from_nid:for_nOBJ.nid, reln:MEM.neuronImg.nid, to_s:null, type:null, to_type:TO_TYPE_ANNE, target_part:"to_s"}];
            misc.img_picker = true;
        }

        else if (relnNOBJ.temp_nid==MEM.meme.temp_nid) {
            misc.page = pagename;
            misc.media_type = "img";
            misc.media_neuron = MEM.neuronImg;
            await PAGES.openPartWithLastPGUI("selector_mediachoice", pObj);
            return;
        }

        //making a neuronImg relon is picking an existing OR making a new.
        else if (relnNOBJ.temp_nid==MEM.neuronImg.temp_nid) {
            misc.page = pagename;
            misc.media_type = "img";
            misc.media_neuron = MEM.neuronImg;
            await PAGES.openPartWithLastPGUI("selector_mediachoice", pObj);
            return;
        }
        else if (relnNOBJ.temp_nid==MEM.neuronAudio.temp_nid) {
            misc.page = pagename;
            misc.media_type = "audio";
            misc.media_neuron = MEM.neuronAudio;
            await PAGES.openPartWithLastPGUI("selector_mediachoice", pObj);
            return;
        }
        else if (relnNOBJ.temp_nid==MEM.neuronVid.temp_nid) {
            misc.page = pagename;
            misc.media_type = "vid";
            misc.media_neuron = MEM.neuronVid;
            await PAGES.openPartWithLastPGUI("selector_mediachoice", pObj);
            return;
        }
    }
    
    misc.paramRelon = paramRelon;
    
    var pagename = PAGES.getDefaultSelectorPageForClass(toNOBJ, paramRelon, for_nOBJ);
    misc.page = pagename;
    console.log("%c pagname %c "+pagename, TALK.bgblack, TALK.bggreen);

    await PAGES.openPartWithLastPGUI(pagename, pObj);
}


/**
 */
PAGES.make_injectPremadeRelon=function($el,  $text, $type, $from_nid, $reln_nid, $to_type, $to, $classStr="btn-blue-sq", $callback=null) {
    var btn = ANNE.A.ezEl($el, "button", "anne-tiny-btn "+$classStr, $text);
    //btn.setAttribute("relon_ttype", $ttype);
    btn.setAttribute("relon_type", $type);
    btn.setAttribute("relon_from", $from_nid);
    btn.setAttribute("relon_reln", $reln_nid);
    btn.setAttribute("relon_to_type", $to_type);
    btn.setAttribute("relon_to", $to);
    btn.addEventListener("click", e=>PAGES.injectPremadeRelon($type, $from_nid, $reln_nid, $to_type, $to, btn, $callback));
    return btn;
}


/**
 * Premade relons are only for relons to non ANNE neurons.
 * (quick info to urls, text strings, numerics etc)
 * make this value in ghost 
 * or in real mem and submit.
 */
PAGES.injectPremadeRelon=async($type, $from_nid, $reln_nid, $to_type, $to, $btn=null, $callback=null)=> {
    var service_fee = null;
    if ($btn) {
        service_fee = $btn.getAttribute("service_fee");
        ANNE.A.removeSelf($btn);
    }
    else if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) {
        alert("NO BTN???");
    }

    //instead of params we could extract this from the gui item which also holds the values.
    var fromNOBJ = MEMG.getNeuronByNid($from_nid);
    var relon = await GHOSTDATA.makeGhostRelon($type, fromNOBJ, $reln_nid, $to_type, $to);
    MEMZ.ez_setNARRPtrsForNew(relon);   
    if ($callback!=null) return await $callback(relon, $btn, $reln_nid);
}


/** 
 * 
 * @author {Mr.Scatman}
 */
PAGES.closeInjectedDetails = async($ge)=> {
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("%cclose up injected details", TALK.bgredbig);
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log($ge);
    if ($ge==null) return;
    var pgui = $ge.pgui;
    var pObj = $ge.pObj;
    if (pgui!=null) PAGES.destroyInject(pgui); 
    ANNE.A.hide(pObj.injection_div);
}



/**
 */
PAGES.destroyInject = function($pgui){
    PAGES.close($pgui.page.divid, $pgui._guid);
}