var ANNKH = {};
ANNKH.makerPgt = null;
ANNKH._pgui = null;
ANNKH._bSHOWSP = true;
ANNKH._bSHOWGH = true;
ANNKH._bSHOWOW = true;
ANNKH._bSHOWRM = true;
ANNKH.links = [];

ANNKH.init=async($secondary=null, $third=null, $misc=null)=> {
    ANNKH.el = ANNE.A.__getEl("maker_inject");
    ANNKH.links = [];
    
    ANNKH.makeEvents();
    ANNKH._pgui = null;

    //must load all our stuff.
    await ANNE.API.getAllMyStuff(ANNE.USER._userNObj.nid, true, true);
    
    //secondary is the pageid of the inner maker we want to use.
    //ie, "location" "date" etc.
    //this is for deep linking going "back" as well as selector widgets wanting to make something new
    //they will directly link to an secondary page.
    if ($secondary!=null && $secondary!="") {
        ANNKH._pgui = await ANNKH.injectByPage($secondary, $misc);
        if ($third=="mine"){
            if (ANNKH._pgui!=undefined && ANNKH._pgui!=null && ANNKH._pgui.INST!=undefined && ANNKH._pgui.INST!=null) {
                ANNKH._pgui.INST.showMine(null);
            }
        }
    }

    //a passed wiki category.
    else if ($misc!=null) {
        console.log($misc);
        var activePgui = await ANNKH.injectByPage("allmystuff");
        new anne_alert("no handler", "There is no known handler for wiki category&nbsp;<b>"+$misc.wiki_type+"</b>&nbsp;in this extension", null, null, null);
    }

    else await ANNKH.injectByPage("allmystuff");
}


/**
 *
 */
ANNKH.makeEvents=function() { 
    var link_all = document.getElementById("link_all");
    link_all.addEventListener("click", e=>ANNKH.inject(e));
    ANNKH.links.push(link_all);

    var linkactions = document.getElementById("link_mk_actions");
    linkactions.addEventListener("click", e=>ANNKH.inject(e));
    ANNKH.links.push(linkactions);

    var linkgenprop = document.getElementById("link_mk_genprop");
    linkgenprop.addEventListener("click", e=>ANNKH.inject(e));
    ANNKH.links.push(linkgenprop);

    var linkperson = document.getElementById("link_mk_person");
    linkperson.addEventListener("click", e=>ANNKH.inject(e));
    ANNKH.links.push(linkperson);

    var linkcompany = document.getElementById("link_mk_company");
    linkcompany.addEventListener("click", e=>ANNKH.inject(e));
    ANNKH.links.push(linkcompany);

    var linkloc = document.getElementById("link_mk_loc");
    linkloc.addEventListener("click", e=>ANNKH.inject(e));
    ANNKH.links.push(linkloc);

    //var linkDate = document.getElementById("link_mk_date");
    //linkDate.addEventListener("click", e=>ANNKH.inject(e));
    //ANNKH.links.push(linkDate);

    //we need to deactivate this link if BOUNTIES are deactivate in the ANNODE
    var linkbounty = document.getElementById("link_mk_bounty");
    ANNKH.links.push(linkbounty);
    
    if(ANNE.API._AAUTH.BOUNTY_active==false) {
        linkbounty.classList.add("annode-disabled-link");
        linkbounty.setAttribute("title", "This type of TX is currently deactivated in L1 ANNE.");
    }
    else {
        linkbounty.classList.remove("annode-disabled-link");
        linkbounty.addEventListener("click", e=>ANNKH.inject(e));
        linkbounty.setAttribute("title", "");
    }

    var linkasdf = document.getElementById("link_mk_asdf");
    ANNKH.links.push(linkasdf);
    if(ANNE.API._AAUTH.ASDF_active==false) {
        linkasdf.classList.add("annode-disabled-link");
        linkasdf.setAttribute("title", "This type of TX is currently deactivated in L1 ANNE.");
    }
    else {
        linkasdf.classList.remove("annode-disabled-link");
        linkasdf.addEventListener("click", e=>ANNKH.inject(e));
        linkasdf.setAttribute("title", "");
    }

    //we need to deactivate this link if PDNS are deactivate in the ANNODE
    var linkpdn = document.getElementById("link_mk_pdn");
    ANNKH.links.push(linkpdn);
    if(ANNE.API._AAUTH.PDNS_active==false) {
        linkpdn.classList.add("annode-disabled-link");
        linkpdn.setAttribute("title", "This type of TX is currently deactivated in L1 ANNE.");
    }
    else {
        linkpdn.classList.remove("annode-disabled-link");
        linkpdn.addEventListener("click", e=>ANNKH.inject(e));
        linkpdn.setAttribute("title", "");
    }

    //we need to deactivate this link if ANNDLES are deactivate in the ANNODE
    var linkanndle = document.getElementById("link_mk_anndle");
    ANNKH.links.push(linkanndle);
    if(ANNE.API._AAUTH.ANNDLE_active==false) {
        linkanndle.classList.add("annode-disabled-link");
        linkanndle.setAttribute("title", "This type of TX is currently deactivated in L1 ANNE.");
    }
    else {
        linkanndle.classList.remove("annode-disabled-link");
        linkanndle.addEventListener("click", e=>ANNKH.inject(e));
        linkanndle.setAttribute("title", "");
    }
    
    var linkanorg = document.getElementById("link_mk_anorg");
    ANNKH.links.push(linkanorg);
    linkanorg.addEventListener("click", e=>ANNKH.inject(e));

    var linkstreampay = document.getElementById("link_mk_streampay");
    ANNKH.links.push(linkstreampay);
    linkstreampay.addEventListener("click", e=>ANNKH.inject(e));

    var chk_sp = document.getElementById("chk_sp");
    if(ANNKH._bSHOWSP==true) chk_sp.checked=true;
    else chk_sp.checked=false;
    chk_sp.addEventListener("change", (e)=>{
        console.log("chk_sp change sponsored");
        var chk_sp = document.getElementById("chk_sp");
        if (chk_sp.checked==true) ANNKH._bSHOWSP=true;
        else ANNKH._bSHOWSP=false;
        if (ANNKH._pgui.INST!=null) ANNKH._pgui.INST.checkChg(ANNKH);
    })

    var chk_gh = document.getElementById("chk_gh");
    if (ANNKH._bSHOWGH==true) chk_gh.checked=true;
    else chk_gh.checked=false;
    chk_gh.addEventListener("change", (e)=>{
        console.log("chk_gh change ghosts");
        var chk_gh = document.getElementById("chk_gh");
        if (chk_gh.checked==true) ANNKH._bSHOWGH=true;
        else ANNKH._bSHOWGH=false;
        if (ANNKH._pgui.INST!=null) ANNKH._pgui.INST.checkChg(ANNKH);
    })

    var chk_ow = document.getElementById("chk_ow");
    if (ANNKH._bSHOWOW==true) chk_ow.checked=true;
    else chk_ow.checked=false;
    chk_ow.addEventListener("change", (e)=>{
        console.log("chk_ow change owned");
        var chk_ow = document.getElementById("chk_ow");
        if (chk_ow.checked==true) ANNKH._bSHOWOW=true;
        else ANNKH._bSHOWOW=false;
        if (ANNKH._pgui.INST!=null) ANNKH._pgui.INST.checkChg(ANNKH);
    })

    
    var chk_rm = document.getElementById("chk_rm");
    if (ANNKH._bSHOWRM==true) chk_rm.checked=true;
    else chk_rm.checked=false;
    chk_rm.addEventListener("change", (e)=>{
        console.log("chk_rm change owned");
        var chk_rm = document.getElementById("chk_rm");
            if (chk_rm.checked==true) ANNKH._bSHOWRM=true;//delayed?
        else ANNKH._bSHOWRM=false;
        if (ANNKH._pgui.INST!=null) ANNKH._pgui.INST.checkChg(ANNKH);
    })
}


ANNKH.emptyActive = function($pgt) {
    if (ANNKH.makerPgt!=null) {
        if (typeof ANNKH.makerPgt.destroyAll==="function") {
            ANNKH.makerPgt.destroyAll();
        }
        ANNE.A.empty("maker_inject");   //empty the home view.
        ANNE.A.empty("maker_status");
    }
}


/**
 * 
 * @param {*} $e 
 * @returns 
 */
ANNKH.inject=async($e)=>{
    $e.stopPropagation();
    $e.preventDefault();
    var btn = $e.target;
    btn = ANNE.A.getFirstParentOf(btn, "sh-link");
    if (btn==null) return;

    for (var li=0; li < ANNKH.links.length; li++) {
        ANNE.A.removeClass(ANNKH.links[li], "sh-link-active");
    }

    ANNE.A.addClass(btn, "sh-link-active");
    var page = btn.getAttribute("data-page");

    if (page==undefined || page==null) {
        alert("no page data-page in link");
        return;
    }

    ANNE.PAGES.updateSecondary(page);
    return await ANNKH.injectByPage(page);
}


ANNKH.getPageByClass=function($classNOBJ){
    if ($classNOBJ.temp_nid==MEM.location.temp_nid) return "location";
    else if ($classNOBJ.temp_nid==MEM.symbol.temp_nid) return "symbol";
    else if ($classNOBJ.is(MEM.ec_action.temp_nid)==true) return "actionverb";
    else if ($classNOBJ.temp_nid==MEM.anndle.temp_nid) return "anndle";
    else if ($classNOBJ.temp_nid==MEM.anorg.temp_nid) return "anorg";
    else if ($classNOBJ.temp_nid==MEM.company.temp_nid) return "company";
    else if ($classNOBJ.temp_nid==MEM.date_gregorian.temp_nid) return "date";
    else if ($classNOBJ.temp_nid==MEM.neuronImg.temp_nid) return "mediapicker";
    else if ($classNOBJ.temp_nid==MEM.integer.temp_nid) return "integer";
    else if ($classNOBJ.temp_nid==MEM.person.temp_nid) return "person";
    else if ($classNOBJ.temp_nid==MEM.ASDF.temp_nid) return "asdf";
    else if ($classNOBJ.temp_nid==MEM.streampay.temp_nid) return "streampay";
    return "allmystuff";
}


ANNKH.injectByPage=async($page, $miscObj=null)=>{
    //console.log("%c injectByPage:"+$page, TALK.bggreen);
    ANNE.A.hide("make_info");
    
    //empty our current div if we were using it.
    ANNKH.emptyActive();
    ANNKH.makerPgt = PAGES.get_page_template($page);
    if (ANNKH.makerPgt==null) return;
    var pguiObj = null;
    ANNKH._pgui = null;

    //tested done
    if ($page=="allmystuff") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(null, null, null, null, null, null));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_all(ANNKH._pgui, ANNKH);
    }

    else if ($page=="symbol") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.symbol.nid, MEM.symbol.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_symbol_gui(ANNKH._pgui,  ANNKH, $miscObj);
    }

    //tested done
    else if ($page=="actionverb") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.ec_action.nid, MEM.ec_action.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_action_gui(ANNKH._pgui, ANNKH, $miscObj);
    }


    //this is key to building out new data neuron protocols and adding to the net-whole of general props we use
    //to define things.  These can be thought of as "columns" in any data table.. or "props" html, or the key in json a key pair.
    else if ($page=="generalprop") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM._GENERAL_PROP_CLASS.nid, MEM._GENERAL_PROP_CLASS.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_general_prop_gui(ANNKH._pgui, ANNKH, $miscObj);
    }


    else if ($page=="anndle") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.anndle.nid, MEM.anndle.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_anndle_gui(ANNKH._pgui,ANNKH, $miscObj);
        await ANNKH._pgui.INST.initASNC($miscObj);
    }

    else if ($page=="anorg") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.anorg.nid, MEM.anorg.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_anorg_gui(ANNKH._pgui, ANNKH, $miscObj);
    }

    else if ($page=="pdn") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.anorg.nid, MEM.anorg.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_pdn_gui(ANNKH._pgui, ANNKH, $miscObj);
        await ANNKH._pgui.INST.main_class.initASYNC(ANNKH._pgui);
    }

    else if ($page=="company") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.company.nid, MEM.company.nid));
        ANNKH._pgui = pguiObj.pgui;
        console.log(" page = company miscObj:"+$miscObj)
        ANNKH._pgui.INST = new maker_company_gui(ANNKH._pgui, ANNKH);
        if ($miscObj!=null) await ANNKH._pgui.INST.initASYNC($miscObj);
    }



    //tested done
    else if ($page=="location") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.location.nid, MEM.location.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_location_gui(ANNKH._pgui, ANNKH, $miscObj);
        if (ANNKH._pgui.INST.miscObjFromSelector !=null) {
            await ANNKH._pgui.INST.initASYNC();
        }
    }


    //this is initiated from a wiki helper popup
    else if ($page=="location_historic_site") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.location.nid, MEM.location.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_location_gui(ANNKH._pgui,ANNKH, $miscObj);
        if ($miscObj!=null) ANNKH._pgui.INST.setHistoricSite($miscObj);
    }

    


    //tested done
    else if ($page=="integer") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.integer.nid, MEM.integer.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_integer_gui(ANNKH._pgui, ANNKH, $miscObj);
    }
    
    else if ($page=="person") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.person.nid, MEM.person.nid));
        ANNKH._pgui = pguiObj.pgui;
        //console.log(" page = person miscObj:"+$miscObj)
        ANNKH._pgui.INST = new maker_person_gui(ANNKH._pgui, ANNKH);
        if ($miscObj!=null) await ANNKH._pgui.INST.initASYNC($miscObj);
    }

    else if ($page=="bounty") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.bounty.nid, MEM.bounty.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_bounty_gui(ANNKH._pgui, ANNKH, $miscObj);
    }

    else if ($page=="asdf") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.ASDF.nid, MEM.ASDF.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_asdf_gui(ANNKH._pgui, ANNKH, $miscObj);
    }

    else if ($page=="streampay") {
        pguiObj = await PAGES.loadTemplate(ANNKH.makerPgt, "maker_inject", ANNKH.makerPgt.content, new page_params(ANNKH.newNeuronSuccess, null, ANNKH.newNeuronFail, null, MEM.streampay.nid, MEM.streampay.nid));
        ANNKH._pgui = pguiObj.pgui;
        ANNKH._pgui.INST = new maker_streampay_gui(ANNKH._pgui, ANNKH, $miscObj);
    }

    //secondary here will be used for inner maker type selection.
    //we want to go back and have this open.
    PAGES.updateSecondary($page);
    return ANNKH._pgui;
}


/**
 * In the new EXT history flow this page is not remaining open behind the scens.
 * It is closed.
 * 
 * We will store a misc object on the last page and handle it if we
 * have a handler for it.
 * 
 * This is set in the services.js  callback_funct:this.success_callback,
 * The success callback is set in the pObj of the instantiating call above
 * in this file's function injectByPage().
 * The actual execution of the callback is in the 
 * function TXB.send3r ------- await ge.callback_funct(cmdObj.relon, ge, _THIS_VARS); line
 */
ANNKH.newNeuronSuccess=async($relon, $ge, $THIS_VARS=null)=> {
    console.log("(ANNKH.newNeuronSuccess) new neuron success");

    if ($relon!=null) {
        ANNE.TALK.printRelon($relon);
    }
    var arr = [];
    if ($ge.passthru!=null) arr.push($ge.passthru);
    if ($ge.passthru2!=null) arr.push($ge.passthru2);
    if ($ge.extra_outs!=null && $ge.extra_outs.length) {
        arr = arr.concat($ge.extra_outs);
    }

    await ANNE.MEMP.processNeuronsFromRelons(arr, false, true, "relons", "ANNKH.newNeuronSuccess"); 
    
    if (arr.length) {
        var fromNOBJ = MEMG.getNeuronByNid(arr[0].from_nid);
        if (fromNOBJ==null) return;
        var parentNObj = MEMG.getNeuronByTempNid(fromNOBJ.bes[0]);
        PAGES.updateLastHistoryMisc({from_nid:fromNOBJ.nid, parentClass:parentNObj});
    }
    return;
}


ANNKH.newNeuronFail=function($x){
    console.log("newNeuronFail");
    console.log($x);
}