/**
 * Ghosts page in ANNE. (injected page uses an inst of this class.)
 */
class anne_ghosts {
    constructor($pgui) {
        this.pgui = $pgui;
        this.tbl_cols = [{
            neuron_link:false,
            title:"from",
            prop:"from_nid",
            class1:"lnot-notice"
        },
        {
            neuron_link:true,
            title:"asset",
            prop:"asset_nid",
            class1:"lnot-asset",
            achat:"achat_sesh_id"
        },        
        {
            neuron_link:false,
            title:"block",
            prop:"time",
            class1:"lnot-block"
        },
        {
            relon_link:true,
            title:"txid",
            prop:"txid",
            class1:"lnot-txid"
        }
    ];

    }


    reinit = async()=> {
        var el_ghosts = ANNE.A.__getEl("my_ghosts");
        ANNE.A.empty(el_ghosts);
        await this.init();  
    }

    /**
     */
    init=async()=>{
        var ghosts = GHOSTDATA.getGhosts();  // await ANNE.DB_local.__getGhostsOnly();
        if (ghosts.length==0) { 
            ANNE.A.ezEl("my_ghosts", "div", "", "You have no local ghosts.");
            ANNE.A.hideParent("btn_upgrade");
            ANNE.A.hideParent("btn_delete_all");
            return;
        }
        else {
           // var el_recheck_all = ANNE.A.show('btn_recheck_all');
            //el_recheck_all.addEventListener("click", async(e)=>{
               // await GHOSTDATA.recheckAll(ghosts);
                //ANNE.A.hide("btn_recheck_all");
           // });
        }


        var tableObj = new neuron_table(this.pgui);
        tableObj.bCOLORSQARES=true;
        tableObj.relonTblMaker(ghosts);
        var el_ghosts = ANNE.A.__getEl("my_ghosts");
        ANNE.A.empty(el_ghosts);
        ANNE.A.show(el_ghosts);
        tableObj.heading_col_class = "ghost-heading";
        tableObj.buildDOMTable(el_ghosts);
    
        this.el_upgrade = document.getElementById("btn_upgrade");
        this.el_upgrade.addEventListener("click", async (e)=>{
            //console.log("ghost data send all ghosts.");
            ANNE.A.show("local_color");
            var ghostobj = new ghost_to_anne();
            var bAUTOHANAI = true;
            if (ANNE.SETTINGS!=null) bAUTOHANAI = ANNE.SETTINGS.bAUTOHANAI;
            await ghostobj.updateAll(bAUTOHANAI, null);
            ANNE.A.hide("local_color");
        });

        this.el_delete_all = document.getElementById("btn_delete_all");
        const THIS = this;
        this.el_delete_all.addEventListener("click", async (e)=>{
            var r = confirm("Are you sure?  This will nuke all ghost neurons and any relons connecting to them.");
            if (r == false) return;
            ANNE.A.hide(this.el_delete_all);
            console.log("DELETE ALL GHOSTS.");
            ANNE.A.show("local_blocker");
            var ghost_nids_deleted = await ANNE.GHOSTDATA.deleteAllGhosts();
            await THIS.reinit();
            ANNE.A.hide("local_blocker");

            if (ANNE.PAGES!=null) {
                ANNE.PAGES.removeHistory(ghost_nids_deleted);
            }
            
            //must reset the graph display, if we have it.
            if (ANNE.ACE!=null) {
                ANNE.ACE.resetAfterDelete();
            }
            
            ANNE.A.hide("threejs_search_bar");
        });
    }


    /**
     *  after ghost wipe clean up things. 
     */
    refresh = function() {
        ANNE.C.resetDisplay(); 
        PAGES.closeInjectPage(this.pgui);
    }

}
